﻿using GAFNETLibrary.Enums;

namespace GAFNETBlazor.Models
{
    public class AliquotaInterestadualModel
    {
        public long Id { get; set; }
        public string UF { get; set; }

        public int? TabA { get; set; }

        public int? SituacaoTributaria { get; set; }

        public decimal PercRedICMS { get; set; }

        public string Mensagens { get; set; }

        public int TipoReducaoICMS { get; set; }

        public decimal PercICMS { get; set; }

        public int TipoReducaoICMSST { get; set; }

        public long IdAliquota { get; set; }

        public decimal PercMargem { get; set; }

        public decimal PercRedST { get; set; }

        public decimal PercMargemRed { get; set; }
        public decimal PercFundoPobreza { get; set; }

        public bool TemCredICMSSimples { get; set; }

        public string CodigoBeneficioFiscal { get; set; }
        public long? IdGAF { get; set; }

        public virtual AliquotaModel Aliquota { get; set; }

        public string CST
        {
            get
            {
                if (TabA.HasValue)
                {
                    return ((int)TabA).ToString() + ((int)SituacaoTributaria).ToString("00");
                }
                else
                {
                    return "000";
                }
            }
        }
        public string CSTFinal => !string.IsNullOrEmpty(CST) ? CST.Substring(1, CST.Length - 1) : string.Empty;
        public AliquotaInterestadualModel()
        {
            TabA               = (int)TabelaA.Nac_Exceto_Ind_Cod_3_a_5;
            SituacaoTributaria = (int)GAFNETLibrary.Enums.SituacaoTributaria.Trib_Integralmente;
        }
        public AliquotaInterestadualModel Clone()
        {
            return (AliquotaInterestadualModel)MemberwiseClone();
        }
    }
}
