﻿
using GAFNETLibrary.Enums;
using System.Collections.ObjectModel;

namespace GAFNETBlazor.Models
{
    public class AliquotaModel
    {
        public long Id { get; set; }
        public string Descricao { get; set; }
        public int TabA { get; set; }
        public int SituacaoTributaria { get; set; }
        public string Mensagens { get; set; }
        public int TipoReducaoICMS { get; set; }
        public decimal PercIPI { get; set; }
        public int CSTIPI { get; set; }
        public int CSTPISCOFINS { get; set; }
        public int TipoReducaoICMSST { get; set; }
        public int? CSTPISCOFINSEntrada { get; set; }
        public decimal PercPISEntrada { get; set; }
        public decimal PercCOFINSEntrada { get; set; }
        public decimal PercMargemRed { get; set; }
        public int? CdTabelaPISCOFINS { get; set; }
        public decimal PercMargem { get; set; }
        public decimal PercRedST { get; set; }
        public decimal PercICMS { get; set; }
        public decimal PercRedICMS { get; set; }
        public bool Ativo { get; set; } = true;
        public decimal PercPIS { get; set; }
        public decimal PercCOFINS { get; set; }
        public bool RegimeEspecial { get; set; }
        public bool UsoConsumo { get; set; }
        public bool TemCredICMSSimples { get; set; }
        public decimal PercCredICMSSimples { get; set; }
        public long? IdGaf { get; set; }
        public string CodigoBeneficioFiscal { get; set; }
        public bool LeiIncentivoSC { get; set; }
        public string EnquadramentoIPI { get; set; }
        public ObservableCollection<AliquotaInterestadualModel> AliquotasInterestaduais { get; set; }
        public string CST => (TabA).ToString() + (SituacaoTributaria).ToString("00");
        
        public string DescricaoAtivo => Ativo ? "Ativo" : "Inativo";
        public string CSTFinal => !string.IsNullOrEmpty(CST) ? CST[1..] : string.Empty;
        public bool ObrigaAliquotaICMS => "-00-20-10-".Contains("-" + CSTFinal + "-");
        public bool ObrigaReducaoICMS => "-20-70-".Contains("-" + CSTFinal + "-");
        public bool ObrigaMargem => "-10-30-70-201-202-203-".Contains("-" + CSTFinal + "-");
        public AliquotaModel()
        {
            AliquotasInterestaduais = new ObservableCollection<AliquotaInterestadualModel>();
            TabA = (int)TabelaA.Nac_Exceto_Ind_Cod_3_a_5;
            SituacaoTributaria = (int)GAFNETLibrary.Enums.SituacaoTributaria.Trib_Integralmente;
            TipoReducaoICMS = (int)GAFNETLibrary.Enums.TipoReducaoICMS.NaBaseDeCalculo;
            TipoReducaoICMSST = (int)GAFNETLibrary.Enums.TipoReducaoICMSST.NaBaseDeCalculo;
        }
    }
}
