﻿using GAFNETLibrary.Enums;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace GAFNETBlazor.Models
{
    public class ItemFaturamentoModel
    {
        public long Id { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal PercComissOriginal { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        [Display(Name = "Comiss. %")]
        public decimal PercComiss { get; set; }
        [Column(TypeName = "numeric(18, 2)")]
        public decimal PercComissaoProd { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.0000000000")]
        [Display(Name = "Desc. $")]
        public decimal VlrDescUnit { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.0000000")]
        [Display(Name = "Valor")]
        public decimal VlrUnit { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.0000000")]
        public decimal QtdLiberada { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.0000000")]
        public decimal QtdFaturada { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.0000000")]
        public decimal VlrUnitOriginal { get; set; }
        public int Numero { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal PercDesc { get; set; }
        public string DescricaoAdicional { get; set; }
        [Display(Name = "Quantidade")]
        public decimal QtdLancada { get; set; }
        [Display(Name = "Perc. ICMS")]
        public decimal PercICMS { get; set; }
        public decimal PercISQN { get; set; }
        public decimal PercIPI { get; set; }
        public decimal PercICMSInterno { get; set; }
        [Display(Name = "Perc. ST")]
        public decimal PercICMSST { get; set; }
        public string CST { get; set; }
        public long IdClassificacaoFiscal { get; set; }
        public decimal PercCSLL { get; set; }
        public bool RegimeEspecial { get; set; }
        public decimal PercMargem { get; set; }
        public decimal PercRedST { get; set; }
        public decimal PercRedICMS { get; set; }
        public decimal PST { get; set; } // Alíquota suportada pelo Consumidor Final

        [DisplayFormat(DataFormatString = "#,##0.00")]
        [Display(Name = "Vlr. ST")]
        public decimal VlrICMSST { get; set; }
        [Display(Name = "Vlr. Base ST")]
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrBaseICMSST { get; set; }
        public TipoReducaoICMS TipoReducaoICMS { get; set; } = TipoReducaoICMS.NaBaseDeCalculo;
        public bool UsoConsumoAliq { get; set; }
        [Display(Name = "Base ICMS")]
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrBaseICMS { get; set; }
        [Display(Name = "Vlr. ICMS")]
        public decimal VlrICMS { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        [Display(Name = "Frete")]
        public decimal VlrFrete { get; set; }
        public int? CSTPISCOFINS { get; set; }
        public int? CSTIPI { get; set; }
        public decimal VlrBaseIPI { get; set; }
        public decimal VlrIPI { get; set; }
        public decimal PercPIS { get; set; }
        public decimal VlrBasePIS { get; set; }
        public decimal VlrPIS { get; set; }
        public decimal PercCOFINS { get; set; }
        public decimal VlrBaseCOFINS { get; set; }
        public decimal VlrCOFINS { get; set; }
        public decimal PercDevolucao { get; set; }
        public decimal VlrIPIDevolucao { get; set; }
        public int CFOP { get; set; }
        public long IdUnidade { get; set; }
        public string CodigoANP { get; set; }
        public TipoReducaoICMSST TipoReducaoICMSST { get; set; } = TipoReducaoICMSST.NaBaseDeCalculo;
        [DisplayFormat(DataFormatString = "#,##0.00")]
        [Display(Name = "Desp. Acess.")]
        public decimal VlrOutDespAcess { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        [Display(Name = "Seguro")]
        public decimal VlrSeguro { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal PercCredICMSSimples { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrCredICMSSimples { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrBaseFreteICMSST { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrBaseSeguroICMSST { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrBaseOutDespAcessICMSST { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrICMSSTRetido { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrBaseICMSSTRetido { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrTotDesc { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrTotAcresc { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        [Display(Name = "Tot. Bruto")]
        public decimal VlrTotBruto { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrTotLiquido { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal QtdDevolvida { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.0000000")]
        public decimal QtdRetornada { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.0000000")]
        public decimal CustoProd { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrBaseICMSParaDIFA { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal PercTabelaIBPT { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrTotTribParaNFe { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrTribNacionalIBPT { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrTribEstadualIBPT { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrTribMunicipalIBPT { get; set; }
        public decimal VlrTribImportadosIBPT { get; set; }
        public string EnquadramentoIPI { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal DIFA { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal PercPobreza { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal PercICMSInternoUFDestino { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal PercICMSInterest { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal PercICMSPartilhaInterest { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrICMSPobreza { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrICMSInterestUFDestino { get; set; }
        [DisplayFormat(DataFormatString = "#,##0.00")]
        public decimal VlrICMSInterestUFRemetente { get; set; }
        public decimal PercFundoPobreza { get; set; }
        [Column(TypeName = "numeric(18, 2)")]
        public decimal VlrBaseFundoPobreza { get; set; }
        [Column(TypeName = "numeric(18, 2)")]
        public decimal VlrFundoPobreza { get; set; }
        [Column(TypeName = "numeric(18, 2)")]
        public decimal PercFundoPobrezaST { get; set; }
        [Column(TypeName = "numeric(18, 2)")]
        public decimal VlrBaseFundoPobrezaST { get; set; }
        [Column(TypeName = "numeric(18, 2)")]
        public decimal VlrFundoPobrezaST { get; set; }
        [Column(TypeName = "numeric(18, 2)")]
        public decimal VlrICMSFundoPobreza { get; set; }
        [Column(TypeName = "numeric(18, 2)")]
        public decimal VlrICMSSubstituto { get; set; }
        [Column(TypeName = "numeric(18, 2)")]
        public decimal VlrBaseFundoPobrezaSTRet { get; set; }
        [Column(TypeName = "numeric(18, 2)")]
        public decimal PercFundoPobrezaSTRet { get; set; }
        [Column(TypeName = "numeric(18, 2)")]
        public decimal VlrFundoPobrezaSTRet { get; set; }
        public long IdFaturamento { get; set; }
        public long IdProduto { get; set; }
        public string CdProdForn { get; set; } // código do produto no fornecedor (feito aqui por causa da importação do XML)
        public string CodigoBeneficioFiscal { get; set; }
        public int? NItemPedidoDeCompra { get; set; }

        public FaturamentoModel Faturamento { get; set; }
        public ProdutoModel Produto { get; set; } = new ProdutoModel { Aliquota = new AliquotaModel() };
        public UnidadeProdutoModel Unidade { get; set; } = new UnidadeProdutoModel();
        public ClassificacaoFiscalModel ClassificacaoFiscal { get; set; } = new ClassificacaoFiscalModel();

        public string CSTFinal => CST?.Length > 2 ? CST[1..] : "";

        [NotMapped]
        public decimal QtdRetornadaAnterior { get; set; }
        [NotMapped]
        public decimal QtdDevolvidaAnterior { get; set; }
        [NotMapped]
        public decimal QtdLancadaOrigem { get; set; } // quando a nota for devolvida ou retornada essa é a quantidade lançada na nota que está sendo devolvida
        public decimal QtdSaldo => QtdLancadaOrigem - (QtdLancada + QtdDevolvidaAnterior + QtdRetornadaAnterior);

    }
}
