﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace GAFNETBlazor.Models;

public partial class ItemPagarReceberModel
{
    public long Id { get; set; }
    public long IdPagarReceber { get; set; }
    public long IdContaApropriacao { get; set; }
    public int NParcela { get; set; }
    public DateTime DtVencimento { get; set; }
    [Column(TypeName = "numeric(18, 2)")]
    public decimal Valor { get; set; }
    [StringLength(2000)]
    public string Observacoes { get; set; }
    public DateTime? DtApropriacao { get; set; }

    public PagarReceberModel PagarReceber { get; set; }
    public ObservableCollection<DetalhamentoPagarReceberModel> DetalhamentosPagarReceber { get; set; } = new();
    public List<BaixaPagarReceberModel> BaixasPagarReceber { get; set; } 
    public decimal VlrPago
    {
        get
        {
            if (BaixasPagarReceber == null) return 0;

            decimal totPago = 0;
            foreach (var baixa in BaixasPagarReceber)
            {
                if (BaixasPagarReceber == null) return 0;
                totPago += baixa.ItemMovCaixa.Valor;
            }
            return totPago;
        }
    }

    public decimal VlrSaldo => Valor - VlrPago;
}
