﻿using GAFNETLibrary.Enums;
using GAFNETLibrary.Models;
using System;

namespace GAFNETBlazor.Models
{
    public partial class PesquisaFaturamentoModel
    {
        public long Id { get; set; }
        public int Tipo { get; set; }
        public int? NumeroIni { get; set; }
        public int? NumeroFin { get; set; }
        public int TipoPesquisaNomePessoa { get; set; } = (int)TipoPesquisaString.ComecaCom;
        public string NomePessoa { get; set; }
        public int Serie { get; set; }
        public DateTime? DtHrLancamentoIni { get; set; }
        public DateTime? DtHrLancamentoFin { get; set; }
        public decimal Valor { get; set; }
        public bool GeradoPorContrato { get; set; }
        public string ChaveEletronica { get; set; }
        public bool Denegada { get; set; }
        public long IdHistorico { get; set; }
        public long? IdPlanoDeConta { get; set; }
        public long? IdCentroDeCusto { get; set; }
        public long? IdTipoDeOperacao { get; set; }
        public long IdFormulario { get; set; }
        public CentroDeCustoModel CentroDeCusto { get; set; } = new CentroDeCustoModel();
        public FormularioModel Formulario { get; set; } = new FormularioModel();
        public HistoricoModel Historico { get; set; } = new HistoricoModel();
        public PlanoDeContaModel PlanoDeConta { get; set; } = new PlanoDeContaModel();
        public TipoDeOperacaoModel TipoDeOperacao { get; set; } = new TipoDeOperacaoModel();
        public EnderecoPessoaModel Endereco { get; set; } = new EnderecoPessoaModel { Cidade = new CidadeModel() };
        public int QtdRegistros { get; set; }
        public string Ordem { get; set; }
    }
}
