﻿using GAFNETLibrary.Enums;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.Models;

public partial class PesquisaPessoaModel
{
    public int TipoPesquisaNome { get; set; } = (int)TipoPesquisaString.ComecaCom;
    public string Nome { get; set; }
    public long IdHistorico { get; set; }
    public long? IdPlanoDeConta { get; set; }
    public long? IdCentroDeCusto { get; set; }
    public long? IdTipoDeOperacao { get; set; }
    public bool EhFornecedor { get; set; }
    public bool EhTransportadora { get; set; }
    public bool EhCliente { get; set; }
    public bool EhVendedor { get; set; }
    public bool Ativo { get; set; }
    public bool MEI { get; set; }
    public CentroDeCustoModel CentroDeCusto { get; set; } = new CentroDeCustoModel();
    public HistoricoModel Historico { get; set; } = new HistoricoModel();
    public PlanoDeContaModel PlanoDeConta { get; set; } = new PlanoDeContaModel();
    public TipoDeOperacaoModel TipoDeOperacao { get; set; } = new TipoDeOperacaoModel();
    public EnderecoPessoaModel Endereco { get; set; } = new EnderecoPessoaModel { Cidade = new CidadeModel() };
    public int QtdRegistros { get; set; }
    public string Ordem { get; set; }
}
