﻿using GAFNETLibrary.Enums;
using System.Collections.Generic;

namespace GAFNETBlazor.Models
{
    public class PlanoDeContaModel
    {
        public long Id { get; set; }

        public string Descricao { get; set; }

        public int Tipo { get; set; }

        public int Classificacao1 { get; set; }

        public int? Classificacao2 { get; set; }

        public int? Classificacao3 { get; set; }

        public int DebitoCredito { get; set; }

        public int? CodigoContabil { get; set; }

        public long? IdContaContrapartida { get; set; }

        public int? CodigoHistoricoContabil { get; set; }

        public int TipoDespesa { get; set; }

        public bool CompoeRelatorio { get; set; }

        public bool Ativo { get; set; }

        public ICollection<PessoaModel> Pessoas { get; }
        public PlanoDeContaModel ContaContrapartida { get; set; }

        public string DescricaoAtivo => Ativo ? "Sim" : "Não";

        public string DescricaoDebitoCredito =>
            DebitoCredito switch
            {
                (int)TipoDebitoCreditoConta.Debito => "Débito",
                (int)TipoDebitoCreditoConta.Credito => "Crédito",
                (int)TipoDebitoCreditoConta.Ambas => "Ambas",
                _ => ""
            };

        public string DescricaoTipo =>
            Tipo switch
            {
                (int)TipoContaPlano.Analitica => "Analítica",
                (int)TipoContaPlano.Sintetica => "Sintética",
                _ => string.Empty
            };

        public string DescricaoTipoDespesa =>
            (TipoDespesaContaPlano)TipoDespesa switch
            {
                TipoDespesaContaPlano.Administrativa => "Administrativa",
                TipoDespesaContaPlano.CustoVenda => "Custo Venda",
                TipoDespesaContaPlano.Financeira => "Financeira",
                TipoDespesaContaPlano.NaoAplicavel => "Não Aplicável",
                _ => string.Empty
            };
    }
}
