﻿using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace GAFNETBlazor.Models
{
    public class ProdutoFornecedorModel : INotifyPropertyChanged
    {
        public long Id { get; set; }
        public long IdPessoa { get; set; }
        public long IdProduto { get; set; }
        [Column(TypeName = "numeric(18, 7)")]
        public decimal VlrCusto { get; set; }
        public decimal _fatorConversao { get; set; }
        [Column(TypeName = "numeric(18, 7)")]
        public decimal FatorConversao
        {
            get { return _fatorConversao; }
            set
            {
                this._fatorConversao = value;
                NotifyPropertyChanged("FatorConversao");
            }
        }
        [StringLength(60)]
        public string CdProdForn { get; set; } // código do produto no fornecedor
        [StringLength(100)]
        public string DescProdForn { get; set; } // descrição do produto no fornecedor
        [StringLength(6)]
        public string CdUnidadeForn { get; set; } // unidade do produto vindo na nota do fornecedor
        [NotMapped]
        public string CdUnidadeFornAnt { get; set; } // unidade do produto do fornecedor já gravado no GAF
        public PessoaModel Pessoa { get; set; }
        private ProdutoModel _produto;
        public ProdutoModel Produto
        {
            get { return _produto; }
            set
            {
                this._produto = value;
                NotifyPropertyChanged("Produto");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
