﻿using FluentValidation;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.Models.Validations
{
    public class AlteraSenhaUsuarioModelValidator : AbstractValidator<UsuarioModel>
    {
        public AlteraSenhaUsuarioModelValidator()
        {
            RuleFor(p => p.PasswordHash).NotEmpty().When(p => string.IsNullOrEmpty(p.Id)).WithMessage("O usuário deve ser informado");
            RuleFor(p => p.PasswordHash).NotEmpty().When(p => string.IsNullOrEmpty(p.PasswordHash)).WithMessage("A senha deve ser informada");
            RuleFor(p => p.PasswordHash).MaximumLength(256).WithMessage("A senha deve conter no máximo 256 caracteres");
            RuleFor(p => p.ConfirmPassword).NotEmpty().When(p => string.IsNullOrEmpty(p.Id)).WithMessage("A confirmação da senha deve ser informada");
            RuleFor(p => p.ConfirmPassword).Equal(s => s.PasswordHash).WithMessage("A senha e a confirmação diferem");
        }
    }
}