﻿using FluentValidation;
using GAFNETBlazor.Models;

namespace GAFNETBlazor.Models.Validations
{
    public class ClaimModelValidator : AbstractValidator<ClaimModel>
    {
        public ClaimModelValidator()
        {
            RuleFor(p => p.Nome).NotEmpty().WithMessage("O nome da Claim deve ser informado");
            RuleFor(p => p.Nome).MaximumLength(128).WithMessage("O nome da Claim deve conter no máximo 128 caracteres");
        }
    }
}