﻿using FluentValidation;

namespace GAFNETBlazor.Models.Validations
{
    public class CondicaoDePagamentoModelValidator : AbstractValidator<CondicaoDePagamentoModel>
    {
        int tamanhoDescricao = 50;
        public CondicaoDePagamentoModelValidator()
        {
            RuleFor(p => p.Descricao).NotEmpty().WithMessage("A descrição deve ser informada");
            RuleFor(p => p.Descricao).MaximumLength(tamanhoDescricao).WithMessage($"A descrição deve conter no máximo {tamanhoDescricao} caracteres");
        }
    }
}