﻿using FluentValidation;

namespace GAFNETBlazor.Models.Validations
{
    public class EmbalagemModelValidator : AbstractValidator<EmbalagemModel>
    {
        readonly int tamanhoNome = 50;
        public EmbalagemModelValidator()
        {
            RuleFor(p => p.Descricao).NotEmpty().WithMessage("A descrição deve ser informada");
            RuleFor(p => p.Descricao).MaximumLength(tamanhoNome).WithMessage($"A descrição deve conter no máximo {tamanhoNome} caracteres");
        }
    }
}