﻿using FluentValidation;

namespace GAFNETBlazor.Models.Validations
{
    public class FormularioModelValidator : AbstractValidator<FormularioModel>
    {
        readonly int tamanhoNome = 50;
        
        
        public FormularioModelValidator()
        {
            RuleFor(p => p.Nome).NotEmpty().WithMessage("O nome deve ser informado");
            RuleFor(p => p.Nome).MaximumLength(tamanhoNome).WithMessage($"O nome deve conter no máximo {tamanhoNome} caracteres");
            RuleFor(p => p.Serie).NotEmpty().WithMessage("A série deve ser informada");
        }
    }
}