﻿using FluentValidation;

namespace GAFNETBlazor.Models.Validations
{
    public class GeneroProdutoModelValidator : AbstractValidator<GeneroProdutoModel>
    {
        int tamanhoDescricao = 500;
        
        public GeneroProdutoModelValidator()
        {
            RuleFor(p => p.Codigo).GreaterThan(0).WithMessage("O código deve ser informado");
            RuleFor(p => p.Descricao).NotEmpty().WithMessage("A descrição deve ser informada");
            RuleFor(p => p.Descricao).MaximumLength(tamanhoDescricao).WithMessage($"A descrição deve conter no máximo {tamanhoDescricao} caracteres");
        }
    }
}