﻿using FluentValidation;

namespace GAFNETBlazor.Models.Validations
{
    public class ParametrizacaoModelValidator : AbstractValidator<ParametrizacaoModel>
    {
        readonly int tamanhoSenha = 4;
        readonly int tamanhoCertificadoNFe = 200;
        readonly int tamanhoDANFENFe = 200;
        public ParametrizacaoModelValidator()
        {
            RuleFor(p => p.SenhaCertificadoNFe).MaximumLength(tamanhoSenha).WithMessage($"A senha deve conter no máximo {tamanhoSenha} caracteres");
            RuleFor(p => p.CertificadoNFe).MaximumLength(tamanhoCertificadoNFe).WithMessage($"O caminho/nome do certificado deve conter no máximo {tamanhoCertificadoNFe} caracteres");
            RuleFor(p => p.DANFENFe).MaximumLength(tamanhoDANFENFe).WithMessage($"O caminho/nome da DANFE da NFe deve conter no máximo {tamanhoDANFENFe} caracteres");
        }
    }
}