﻿using FluentValidation;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.Models.Validations
{
    public class RepresentanteModelValidator : AbstractValidator<RepresentanteModel>
    {
        public RepresentanteModelValidator()
        {
            RuleFor(p => p.Nome).NotEmpty().WithMessage("O nome do representante deve ser informado");
            RuleFor(p => p.Nome).MaximumLength(100).WithMessage("O nome do representante deve conter no máximo 100 caracteres");
            RuleFor(p => p.Cnpj).NotEmpty().WithMessage("O CNPJ do representante deve ser informado");
            RuleFor(p => p.Cnpj).MaximumLength(14).WithMessage("O CNPJ do representante deve conter no máximo 14 caracteres");
            RuleFor(p => p.IdUsuario).NotNull().WithMessage("O usuário deve ser informado");
        }
    }
}