﻿using FluentValidation;
using GAFNETBlazor.Models;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.Models.Validations
{
    public class RoleModelValidator : AbstractValidator<RoleModel>
    {
        public RoleModelValidator()
        {
            RuleFor(p => p.Nome).NotEmpty().WithMessage("O nome da Role deve ser informado");
            RuleFor(p => p.Nome).MaximumLength(256).WithMessage("O nome da Role deve conter no máximo 256 caracteres");
        }
    }
}