﻿using FluentValidation;

namespace GAFNETBlazor.Models.Validations
{
    public class SubgrupoProdutoModelValidator : AbstractValidator<SubgrupoProdutoModel>
    {
        int tamanhoNome = 50;
        public SubgrupoProdutoModelValidator()
        {
            RuleFor(p => p.IdGrupo).GreaterThan(0).WithMessage("O grupo deve ser informado");
            RuleFor(p => p.Nome).NotEmpty().WithMessage("O nome deve ser informado");
            RuleFor(p => p.Nome).MaximumLength(tamanhoNome).WithMessage($"O nome deve conter no máximo {tamanhoNome} caracteres");
        }
    }
}