﻿using FluentValidation;

namespace GAFNETBlazor.Models.Validations
{
    public class UFICMSModelValidator : AbstractValidator<UFICMSModel>
    {
        public UFICMSModelValidator()
        {
            RuleFor(p => p.UF).NotEmpty().WithMessage("A UF deve ser informada");
            RuleFor(p => p.Percentual).GreaterThan(0).WithMessage("O percentual do ICMS deve ser informado.");
        }
    }
}