﻿using FluentValidation;

namespace GAFNETBlazor.Models.Validations
{
    public class UnidadeProdutoModelValidator : AbstractValidator<UnidadeProdutoModel>
    {
        int tamanhoDescricao = 20;
        int tamanhoCodigo = 3;
        public UnidadeProdutoModelValidator()
        {
            RuleFor(p => p.Descricao).NotEmpty().WithMessage("A descrição deve ser informada");
            RuleFor(p => p.Descricao).MaximumLength(tamanhoDescricao).WithMessage($"A descrição deve conter no máximo {tamanhoDescricao} caracteres");
            RuleFor(p => p.Codigo).NotEmpty().WithMessage("O código deve ser informado");
            RuleFor(p => p.Codigo).MaximumLength(tamanhoCodigo).WithMessage($"O código da unidade deve conter no máximo {tamanhoCodigo} caracteres");
        }
    }
}