﻿using GAFNETBlazor.ViewModels.Interfaces.Administrativo;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Administrativo.Cadastros.Claims
{
    public class CadastroClaimBase : MeuComponentBase
    {
        [Inject]
        protected ICadastroClaimVM ViewModel { get; set; }
        protected SfDialog Dlg { get; set; }
        protected SfTextBox NomeTextBox;
        protected override void OnAfterRender(bool firstRender)
        {
            ViewModel.Dlg = this.Dlg;
            ViewModel.NomeTextBox = NomeTextBox;
        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            if (!LoginStore.EhAdmin)
            {
                NavigationManager.NavigateTo("/Login");
                return;
            }
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
        }
    }
}
