﻿using GAFNETBlazor.ViewModels.Interfaces.Administrativo;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Administrativo.Cadastros.Empresas
{
    public class CadastroEmpresaBase : MeuComponentBase
    {
        [Inject]
        protected ICadastroEmpresaVM ViewModel { get; set; }
        protected SfDialog Dlg { get; set; }
        protected SfTextBox NomeTextBox;
        protected SfMaskedTextBox CEPTextBox;
        protected SfSpinner SpinnerPrincipal;
        public Dictionary<string, object> HtmlAttributeLogradouro { get; set; }
        public Dictionary<string, object> HtmlAttributeNumero { get; set; }
        public Dictionary<string, object> HtmlAttributeBairro { get; set; }
        public Dictionary<string, object> HtmlAttributeComplemento { get; set; }
        protected override void OnAfterRender(bool firstRender)
        {
            ViewModel.Dlg = this.Dlg;
            ViewModel.NomeTextBox = NomeTextBox;
            ViewModel.CEPTextBox = CEPTextBox;
            ViewModel.SpinnerPrincipal = SpinnerPrincipal; 
            HtmlAttributeLogradouro = new Dictionary<string, object>()
            {
                {"maxlength", "255" }
            };
            HtmlAttributeNumero = new Dictionary<string, object>()
            {
                {"maxlength", "60" }
            };
            HtmlAttributeBairro = new Dictionary<string, object>()
            {
                {"maxlength", "60" }
            };
            HtmlAttributeComplemento = new Dictionary<string, object>()
            {
                {"maxlength", "60" }
            };
        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();

            if (!LoginStore.EhAdmin)
            {
                NavigationManager.NavigateTo("/Login");
                return;
            }
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
        }
    }
}
