﻿using GAFNETBlazor.ViewModels.Interfaces.Administrativo;
using Microsoft.AspNetCore.Components;
using Microsoft.AspNetCore.Components.Forms;
using Syncfusion.Blazor;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Administrativo.Cadastros.Usuarios
{
    public class CadastroUsuarioBase : MeuComponentBase
    {
        [Inject]
        protected ICadastroUsuarioVM ViewModel { get; set; }
        protected SfDialog Dialogo { get; set; }
        protected SfDialog DialogoClaims { get; set; }
        protected SfTextBox NomeTextBox;
        protected override void OnAfterRender(bool firstRender)
        {
            ViewModel.Dialogo = this.Dialogo;
            ViewModel.NomeTextBox = NomeTextBox;

        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            if (!LoginStore.EhAdmin)
            {
                NavigationManager.NavigateTo("/Login");
                return;
            }
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
        }
    }
}
