﻿using GAFNETBlazor.ViewModels.Interfaces;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.SplitButtons;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Login
{
    public class LoginBase : ComponentBase
    {
        [Inject]
        public ILoginViewModel LoginViewModel { get; set; }
        [Inject]
        protected NavigationManager NavigationManager { get; set; }
        protected SfDialog dialogObj;
        protected SfTextBox email;
        protected bool EnviarDisabled { get; set; } = false;
        protected SfProgressButton EnviarBtn { get; set; }

        protected async void Enviar()
        {
            await LoginViewModel.Enviar();

            if (string.IsNullOrEmpty(LoginViewModel.MensagemErro))
            {
                NavigationManager.NavigateTo("/");
            }
        }

        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            LoginViewModel.PropertyChanged += (o, e) => StateHasChanged();
        }

        protected async void OnCreateEMail(object args)
        {
            await email.FocusAsync();
        }

    }
}
