﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Representante;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Spinner;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Representante
{
    public class DownloadsPageBase : MeuComponentBase
    {
        [Inject]
        protected IDownloadsVM ViewModel { get; set; }
        protected SfSpinner SpinnerPrincipal;
        protected MeuToast MeuToast;
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            if (!LoginStore.EhAdmin && !LoginStore.EhRepresentante)
            {
                NavigationManager.NavigateTo("/Login");
                return;
            }
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
        }

        protected override void OnAfterRender(bool firstRender)
        {
            ViewModel.SpinnerPrincipal = SpinnerPrincipal;
            ViewModel.MeuToast = MeuToast;
            if (firstRender)
            {
                ViewModel.GetArquivosParaDownload();
            }
        }
    }
}
