﻿using GAFNETBlazor.ViewModels.Interfaces.Representante;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Representante
{
    public class ManutencaoEmpresaBase : MeuComponentBase
    {
        [Inject]
        protected IManutencaoEmpresaVM ViewModel { get; set; }
        protected SfDialog Dlg { get; set; }
        protected SfTextBox NomeTextBox;
        protected override void OnAfterRender(bool firstRender)
        {
            ViewModel.Dlg = Dlg;
        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();

            if (!(LoginStore.EhAdmin || LoginStore.EhRepresentante))
            {
                NavigationManager.NavigateTo("/Login");
                return;
            }
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
        }
    }
}
