﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Representante;
using GAFNETBlazor.Stores.Interfaces;
using Microsoft.AspNetCore.Components;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Representante
{
    public class RepresentantePageBase : ComponentBase
    {
        protected List<ItemPageModel> itens = new List<ItemPageModel>();
        [Inject]
        ILoginStore LoginStore { get; set; }
        [Inject]
        NavigationManager NavigationManager { get; set; }
        protected override async Task OnInitializedAsync()
        {
            if (LoginStore.EhAdmin || LoginStore.EhRepresentante)
            {
                itens = await ItensRepresentanteService.Itens();
            }
            else
            {
                NavigationManager.NavigateTo("/Login");
            }

        }
    }
}
