﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Cadastros.Aliquotas
{
    public partial class CadastroAliquotaPage : MeuComponentBase
    {
        [Inject]
        public ICadastroAliquotaVM ViewModel { get; set; }
        private Dictionary<string, object> HtmlAttributeDescricao { get; set; }
        private Dictionary<string, object> HtmlAttributeEnqIPI { get; set; }
        protected SfDialog Dlg { get; set; }
        protected SfTextBox DescricaoTextBox { get; set; }

        protected SfSpinner SpinnerPrincipal;
        
        protected MeuToast MeuToast;
        protected override void OnAfterRender(bool firstRender)
        {
            ViewModel.Dlg = this.Dlg;
            ViewModel.DescricaoTextBox = DescricaoTextBox;
            ViewModel.SpinnerPrincipal = SpinnerPrincipal;
            ViewModel.MeuToast = MeuToast;
            HtmlAttributeDescricao = new Dictionary<string, object>()
            {
                {"maxlength", "100" }
            };
            HtmlAttributeEnqIPI = new Dictionary<string, object>()
            {
                {"maxlength", "3" }
            };
        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            if (!string.IsNullOrEmpty(ViewModel.UrlRedirecionamento))
            {
                NavigationManager.NavigateTo(ViewModel.UrlRedirecionamento);
                return;
            }
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
        }

    }
}
