﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Cadastros.CentrosDeCusto;

public partial class CadastroCentroDeCustoPage : MeuComponentBase
{
    [Inject]
    public ICadastroCentroDeCustoVM ViewModel { get; set; }
    private Dictionary<string, object> HtmlAttributeNome { get; set; }
    protected SfNumericTextBox<long> IdTextBox;
    protected SfTextBox NomeTextBox;
    protected SfSpinner SpinnerPrincipal;
    protected MeuToast MeuToast;

    protected override async void OnAfterRender(bool firstRender)
    {
        ViewModel.SpinnerPrincipal = SpinnerPrincipal;
        ViewModel.IdTextBox = IdTextBox;
        ViewModel.NomeTextBox = NomeTextBox;
        ViewModel.MeuToast = MeuToast;

        if (firstRender)
        {
            await NomeTextBox.FocusAsync();
        }

        HtmlAttributeNome = new Dictionary<string, object>()
        {
            {"maxlength", "50" }
        };
    }
    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();
        if (!string.IsNullOrEmpty(ViewModel.UrlRedirecionamento.ToString()))
        {
            NavigationManager.NavigateTo(ViewModel.UrlRedirecionamento.ToString());
            return;
        }
        ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
    }
}
