﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Cadastros.ClassificacoesFiscais
{
    public partial class CadastroClassificacaoFiscalPage : MeuComponentBase
    {
        [Inject]
        public ICadastroClassificacaoFiscalVM ViewModel { get; set; }
        private Dictionary<string, object> HtmlAttributeDescricao { get; set; }
        private Dictionary<string, object> HtmlAttributeEX { get; set; }
        private Dictionary<string, object> HtmlAttributeNumero { get; set; }
        private Dictionary<string, object> HtmlAttributeCEST { get; set; }
        protected SfDialog Dlg { get; set; }
        protected SfNumericTextBox<int> NumeroTextBox;
        protected SfTextBox DescricaoTextBox;
        protected SfSpinner SpinnerPrincipal;
        protected MeuToast MeuToast;

        protected override async void OnAfterRender(bool firstRender)
        {
            ViewModel.Dlg = this.Dlg;
            ViewModel.SpinnerPrincipal = SpinnerPrincipal;
            ViewModel.NumeroTextBox = NumeroTextBox;
            ViewModel.DescricaoTextBox = DescricaoTextBox;
            ViewModel.MeuToast = MeuToast;
            HtmlAttributeDescricao = new Dictionary<string, object>()
            {
                {"maxlength", "80" }
            };
            HtmlAttributeEX = new Dictionary<string, object>()
            {
                {"maxlength", "3" }
            };
            HtmlAttributeNumero = new Dictionary<string, object>()
            {
                {"maxlength", "8" }
            };
            HtmlAttributeCEST = new Dictionary<string, object>()
            {
                {"maxlength", "7" }
            };
            
            if (ViewModel.ClassFiscal.Numero == 0)
            {
                await ViewModel.NumeroTextBox.FocusAsync();
                StateHasChanged();
            }
        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            if (!string.IsNullOrEmpty(ViewModel.UrlRedirecionamento.ToString()))
            {
                NavigationManager.NavigateTo(ViewModel.UrlRedirecionamento.ToString());
                return;
            }
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
        }
    }
}
