﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Cadastros.CondicoesDePagamento;

public partial class CadastroCondicaoDePagamentoPage : MeuComponentBase
{
    [Inject]
    public ICadastroCondicaoDePagamentoVM ViewModel { get; set; }
    private Dictionary<string, object> HtmlAttributeDescricao { get; set; }
    private Dictionary<string, object> HtmlAttributeDescricaoParcelas { get; set; }
    protected SfNumericTextBox<long> CodigoTextBox;
    protected SfTextBox DescricaoParcelasTextBox;
    protected SfSpinner SpinnerPrincipal;
    protected MeuToast MeuToast;

    protected override async void OnAfterRender(bool firstRender)
    {
        ViewModel.SpinnerPrincipal = SpinnerPrincipal;
        ViewModel.CodigoTextBox = CodigoTextBox;
        ViewModel.DescricaoParcelasTextBox = DescricaoParcelasTextBox;
        ViewModel.MeuToast = MeuToast;

        if (firstRender)
        {
            await DescricaoParcelasTextBox.FocusAsync();
        }

        HtmlAttributeDescricao = new Dictionary<string, object>()
        {
            {"maxlength", "200" }
        };
        HtmlAttributeDescricaoParcelas = new Dictionary<string, object>()
        {
            {"maxlength", "200" }
        };

    }
    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();
        if (!string.IsNullOrEmpty(ViewModel.UrlRedirecionamento.ToString()))
        {
            NavigationManager.NavigateTo(ViewModel.UrlRedirecionamento.ToString());
            return;
        }
        ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
    }
}
