﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Cadastros.GruposProduto
{
    public partial class CadastroGrupoProdutoPage : MeuComponentBase
    {
        [Inject]
        public ICadastroGrupoProdutoVM ViewModel { get; set; }
        private Dictionary<string, object> HtmlAttributeNome { get; set; }
        protected SfDialog Dlg { get; set; }
        protected SfTextBox NomeTextBox;
        protected SfSpinner SpinnerPrincipal;
        protected MeuToast MeuToast;

        protected override void OnAfterRender(bool firstRender)
        {
            ViewModel.Dlg = this.Dlg;
            ViewModel.SpinnerPrincipal = SpinnerPrincipal;
            ViewModel.NomeTextBox = NomeTextBox;
            ViewModel.MeuToast = MeuToast;
            HtmlAttributeNome = new Dictionary<string, object>()
            {
                {"maxlength", "50" }
            };
        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            if (!string.IsNullOrEmpty(ViewModel.UrlRedirecionamento.ToString()))
            {
                NavigationManager.NavigateTo(ViewModel.UrlRedirecionamento.ToString());
                return;
            }
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
        }
    }
}
