﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Cadastros.Historicos
{
    public partial class CadastroHistoricoPage : MeuComponentBase
    {
        [Inject]
        public ICadastroHistoricoVM ViewModel { get; set; }
        private Dictionary<string, object> HtmlAttributeDescricao { get; set; }
        private Dictionary<string, object> HtmlAttributeDescricaoNF { get; set; }
        private Dictionary<string, object> HtmlAttributeObsNFDentroUF { get; set; }
        private Dictionary<string, object> HtmlAttributeObsNFForaUF { get; set; }
        protected SfDialog Dlg { get; set; }
        protected SfTextBox DescricaoTextBox;
        protected SfSpinner SpinnerPrincipal;
        protected SfNumericTextBox<long?> IdHistoricoEstornoInput;
        protected MeuToast MeuToast;
        protected override void OnAfterRender(bool firstRender)
        {
            ViewModel.Dlg = this.Dlg;
            ViewModel.SpinnerPrincipal = SpinnerPrincipal;
            ViewModel.DescricaoTextBox = DescricaoTextBox;
            ViewModel.IdHistoricoEstornoInput = IdHistoricoEstornoInput;
            ViewModel.MeuToast = MeuToast;
            HtmlAttributeDescricao = new Dictionary<string, object>()
            {
                {"maxlength", "50" }
            };
            HtmlAttributeDescricaoNF = new Dictionary<string, object>()
            {
                {"maxlength", "60" }
            };
            HtmlAttributeObsNFDentroUF = new Dictionary<string, object>()
            {
                {"maxlength", "2000" }
            };
            HtmlAttributeObsNFForaUF = new Dictionary<string, object>()
            {
                {"maxlength", "2000" }
            };
        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            if (!string.IsNullOrEmpty(ViewModel.UrlRedirecionamento.ToString()))
            {
                NavigationManager.NavigateTo(ViewModel.UrlRedirecionamento.ToString());
                return;
            }
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
        }

    }
}
