﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Cadastros.Parametrizacoes
{
    public partial class ParametrizacaoPage : MeuComponentBase
    {
        [Inject]
        public IParametrizacaoVM ViewModel { get; set; }
        private Dictionary<string, object> HtmlAttributeCertificadoNFe { get; set; }
        private Dictionary<string, object> HtmlAttributeSenhaCertificadoNFe { get; set; }
        private Dictionary<string, object> HtmlAttributeDANFENFe { get; set; }
        private Dictionary<string, object> HtmlAttributeEMail { get; set; }
        public Dictionary<string, object> HtmlAttributeSMTP { get; private set; }
        public Dictionary<string, object> HtmlAttributeSenhaEMail { get; private set; }
        protected SfDialog Dlg { get; set; }
        protected SfTextBox DescricaoTextBox;
        protected SfSpinner SpinnerPrincipal;
        protected SfNumericTextBox<long?> IdHistoricoEstornoInput;
        protected MeuToast MeuToast;
        protected override void OnAfterRender(bool firstRender)
        {
            ViewModel.SpinnerPrincipal = SpinnerPrincipal;
            ViewModel.MeuToast = MeuToast;
            HtmlAttributeSenhaCertificadoNFe = new Dictionary<string, object>()
            {
                {"maxlength", "4" }
            };
            HtmlAttributeCertificadoNFe = new Dictionary<string, object>()
            {
                {"maxlength", "200" }
            };
            HtmlAttributeDANFENFe = new Dictionary<string, object>()
            {
                {"maxlength", "200" }
            };

            HtmlAttributeEMail = new Dictionary<string, object>()
            {
                {"maxlength", "254" }
            };

            HtmlAttributeSMTP = new Dictionary<string, object>()
            {
                {"maxlength", "200" }
            };

            HtmlAttributeSenhaEMail = new Dictionary<string, object>()
            {
                {"maxlength", "200" }
            };
        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            if (!string.IsNullOrEmpty(ViewModel.UrlRedirecionamento.ToString()))
            {
                NavigationManager.NavigateTo(ViewModel.UrlRedirecionamento.ToString());
                return;
            }
            ViewModel.GetTiposAmbienteNFe();
            ViewModel.GetTiposEmissaoNFe();
            await ViewModel.GetParametrizacao();
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
        }

    }
}
