﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;
using Syncfusion.Blazor.DropDowns;
using GAFNETBlazor.Models;

namespace GAFNETBlazor.Pages.Usuario.Cadastros.Pessoas
{
    public partial class CadastroPessoaPage : MeuComponentBase
    {
        [Inject]
        public ICadastroPessoaVM ViewModel { get; set; }
        private Dictionary<string, object> HtmlAttributeNome { get; set; }
        private Dictionary<string, object> HtmlAttributeNomeFantasia { get; set; }
        protected SfDialog Dlg { get; set; }
        protected SfDialog DialogoClaims { get; set; }
        protected SfMaskedTextBox CNPJTextBox;
        protected SfDropDownList<int?, ListaModel> TipoPessoaDropDownList;
        protected SfTextBox NomeTextBox;
        protected SfSpinner SpinnerPrincipal;
        protected MeuToast MeuToast;

        protected override async Task OnAfterRenderAsync(bool firstRender)
        {
            ViewModel.CNPJTextBox = CNPJTextBox;
            ViewModel.TipoPessoaDropDownList = TipoPessoaDropDownList;
            ViewModel.NomeTextBox = NomeTextBox; 
            ViewModel.Dlg = this.Dlg;
            ViewModel.SpinnerPrincipal = SpinnerPrincipal;
            ViewModel.MeuToast = MeuToast;

            HtmlAttributeNome = new Dictionary<string, object>()
            {
                {"maxlength", "60" }
            };
            HtmlAttributeNomeFantasia = new Dictionary<string, object>()
            {
                {"maxlength", "60" }
            };

            if (firstRender)
            {
                await ViewModel.TipoPessoaDropDownList.FocusAsync();
            }
        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            if (!string.IsNullOrEmpty(ViewModel.UrlRedirecionamento))
            {
                NavigationManager.NavigateTo(ViewModel.UrlRedirecionamento);
                return;
            }
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
        }

    }
}
