﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Cadastros.PlanoDeContas;

public partial class CadastroPlanoDeContaPage : MeuComponentBase
{
    [Inject]
    public ICadastroPlanoDeContaVM ViewModel { get; set; }
    private Dictionary<string, object> HtmlAttributeDescricao { get; set; }
    protected SfTextBox DescricaoTextBox;
    protected SfNumericTextBox<long?> IdContaContrapartidaInput;
    protected SfSpinner SpinnerPrincipal;
    protected MeuToast MeuToast;

    protected override async Task OnAfterRenderAsync(bool firstRender)
    {
        ViewModel.SpinnerPrincipal = SpinnerPrincipal;
        ViewModel.DescricaoTextBox = DescricaoTextBox;
        ViewModel.IdContaContrapartidaInput = IdContaContrapartidaInput;
        ViewModel.MeuToast = MeuToast;
        HtmlAttributeDescricao = new Dictionary<string, object>()
        {
            {"maxlength", "50" }
        };
        if (firstRender)
        {
            await ViewModel.DescricaoTextBox.FocusAsync();
        }
    }
    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();
        if (!string.IsNullOrEmpty(ViewModel.UrlRedirecionamento.ToString()))
        {
            NavigationManager.NavigateTo(ViewModel.UrlRedirecionamento.ToString());
            return;
        }
        ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
    }
}
