﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Cadastros.Produtos
{
    public partial class CadastroProdutoPage : MeuComponentBase
    {
        [Inject]
        public ICadastroProdutoVM ViewModel { get; set; }
        private Dictionary<string, object> HtmlAttributeNome { get; set; }
        private Dictionary<string, object> HtmlAttributeCodigoProduto { get; set; }
        private Dictionary<string, object> HtmlAttributeCodigoDeBarras { get; set; }
        private Dictionary<string, object> HtmlAttributeObservacoes { get; set; }
        public Dictionary<string, object> HtmlAttributeNumeroClassificacaoFiscal { get; private set; }
        public Dictionary<string, object> HtmlAttributeCodigoUnidade { get; private set; }
        protected SfDialog Dlg { get; set; }
        protected SfTextBox NomeTextBox;
        protected SfTextBox CodigoProdutoTextBox;
        protected SfSpinner SpinnerPrincipal;
        protected SfNumericTextBox<long> IdAliquotaInput;
        protected SfNumericTextBox<long> IdSubgrupoInput;
        protected SfNumericTextBox<long> IdClassFiscalInput;
        protected SfNumericTextBox<long> IdUnidadeInput;
        protected SfNumericTextBox<decimal> VlrVendaInput;
        protected MeuToast MeuToast;
        protected override void OnAfterRender(bool firstRender)
        {
            ViewModel.Dlg                  = this.Dlg;
            ViewModel.SpinnerPrincipal     = SpinnerPrincipal;
            ViewModel.NomeTextBox          = NomeTextBox;
            ViewModel.IdAliquotaInput      = IdAliquotaInput;
            ViewModel.IdSubgrupoInput      = IdSubgrupoInput;
            ViewModel.IdClassFiscalInput   = IdClassFiscalInput;
            ViewModel.IdUnidadeInput       = IdUnidadeInput;
            ViewModel.VlrVendaInput        = VlrVendaInput;
            ViewModel.CodigoProdutoTextBox = CodigoProdutoTextBox;
            ViewModel.MeuToast             = MeuToast;
            HtmlAttributeNome = new Dictionary<string, object>()
            {
                {"maxlength", "120" }
            };
            HtmlAttributeCodigoProduto = new Dictionary<string, object>()
            {
                {"maxlength", "20" }
            };
            HtmlAttributeCodigoDeBarras = new Dictionary<string, object>()
            {
                {"maxlength", "15" }
            };
            HtmlAttributeObservacoes = new Dictionary<string, object>()
            {
                {"maxlength", "100" }
            };
            HtmlAttributeNumeroClassificacaoFiscal = new Dictionary<string, object>()
            {
                {"maxlength", "8" }
            };
            HtmlAttributeCodigoUnidade = new Dictionary<string, object>()
            {
                {"maxlength", "3" }
            };
        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            if (!string.IsNullOrEmpty(ViewModel.UrlRedirecionamento.ToString()))
            {
                NavigationManager.NavigateTo(ViewModel.UrlRedirecionamento.ToString());
                return;
            }
            
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
            await ViewModel.GetParametrizacoes();
            if (ViewModel.Parametrizacao.CodigoAutomaticoNoProduto)
            {
                await Task.Delay(500);
                await ViewModel.NomeTextBox.FocusAsync();
                ViewModel.Produto.Codigo = "0";
            }
        }

    }
}
