﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.DropDowns;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Cadastros.UFICMS
{
    public partial class CadastroUFICMSPage : MeuComponentBase
    {
        [Inject]
        public ICadastroUFICMSVM ViewModel { get; set; }
        protected SfDialog Dlg { get; set; }
        protected SfDropDownList<string, string> UFDropDownList { get; set; }

        protected SfSpinner SpinnerPrincipal;

        protected MeuToast MeuToast;
        protected override void OnAfterRender(bool firstRender)
        {
            ViewModel.Dlg = this.Dlg;
            ViewModel.UFDropDownList = UFDropDownList;
            ViewModel.SpinnerPrincipal = SpinnerPrincipal;
            ViewModel.MeuToast = MeuToast;
        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            if (!string.IsNullOrEmpty(ViewModel.UrlRedirecionamento))
            {
                NavigationManager.NavigateTo(ViewModel.UrlRedirecionamento);
                return;
            }
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
        }

    }
}
