﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Cadastros.UnidadesProduto
{
    public partial class CadastroUnidadeProdutoPage : MeuComponentBase
    {
        [Inject]
        public ICadastroUnidadeProdutoVM ViewModel { get; set; }
        private Dictionary<string, object> HtmlAttributeDescricao { get; set; }
        private Dictionary<string, object> HtmlAttributeCodigo { get; set; }
        protected SfDialog Dlg { get; set; }
        protected SfTextBox CodigoTextBox;
        protected SfTextBox DescricaoTextBox;
        protected SfSpinner SpinnerPrincipal;
        protected MeuToast MeuToast;

        protected override void OnAfterRender(bool firstRender)
        {
            ViewModel.Dlg = this.Dlg;
            ViewModel.SpinnerPrincipal = SpinnerPrincipal;
            ViewModel.CodigoTextBox = CodigoTextBox;
            ViewModel.DescricaoTextBox = DescricaoTextBox;
            ViewModel.MeuToast = MeuToast;
            HtmlAttributeDescricao = new Dictionary<string, object>()
            {
                {"maxlength", "20" }
            };
            HtmlAttributeCodigo = new Dictionary<string, object>()
            {
                {"maxlength", "3" }
            };
            
        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            if (!string.IsNullOrEmpty(ViewModel.UrlRedirecionamento.ToString()))
            {
                NavigationManager.NavigateTo(ViewModel.UrlRedirecionamento.ToString());
                return;
            }
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
        }
    }
}
