﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using GAFNETLibrary.Enums;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Movimentacoes.Compras
{
    public partial class CompraPage : MeuComponentBase
    {
        [Inject]
        public ICompraVM ViewModel { get; set; }
        [Inject]
        public IPesquisaFaturamentoVM PesquisaViewModel { get; set; }
        protected SfDialog Dlg { get; set; }
        protected SfSpinner SpinnerPrincipal;
        protected MeuToast MeuToast;
        protected SfNumericTextBox<long> IdPessoaInput { get; set; }
        protected SfNumericTextBox<long> IdHistoricoInput { get; set; }

        protected SfNumericTextBox<int> SerieInput { get; set; }

        protected override void OnAfterRender(bool firstRender)
        {

            ViewModel.Dlg = this.Dlg;
            ViewModel.IdPessoaInput = IdPessoaInput;
            ViewModel.IdHistoricoInput = IdHistoricoInput;
            ViewModel.SpinnerPrincipal = SpinnerPrincipal;
            ViewModel.SerieInput = SerieInput;
            ViewModel.MeuToast = MeuToast;

            if (firstRender)
            {
                ViewModel.SerieInput.FocusAsync();
            }
        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            if (!string.IsNullOrEmpty(ViewModel.UrlRedirecionamento))
            {
                NavigationManager.NavigateTo(ViewModel.UrlRedirecionamento);
                return;
            }
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
        }

    }
}
