﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Spinner;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Movimentacoes.ContasPagarReceber;

public partial class PagarReceberPage : MeuComponentBase
{
    [Inject]
    public IPagarReceberVM ViewModel { get; set; }
    protected SfSpinner SpinnerPrincipal;
    protected MeuToast MeuToast;
    

    protected override async Task OnAfterRenderAsync(bool firstRender)
    {
        ViewModel.SpinnerPrincipal = SpinnerPrincipal;
        ViewModel.MeuToast = MeuToast;

        if (firstRender && ViewModel.PagarReceber.IdPessoa == 0)
        {
            await Task.Delay(500);
            await ViewModel.NDoctoInput.FocusAsync();
        }
    }
    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();
        if (!string.IsNullOrEmpty(ViewModel.UrlRedirecionamento))
        {
            NavigationManager.NavigateTo(ViewModel.UrlRedirecionamento);
            return;
        }
        ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
    }

}
