﻿using GAFNETBlazor.Components;
using GAFNETBlazor.Constantes;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Spinner;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Movimentacoes.Devolucoes
{
    public partial class Devolucao : MeuComponentBase
    {
        [Inject]
        public IDevolucaoVM ViewModel { get; set; }
        [Inject]
        public IFormulariosService FormulariosService { get; set; }
        protected SfNumericTextBox<long> IdFormularioInput { get; set; }
        protected SfNumericTextBox<long> IdHistoricoInput { get; set; }
        SfGrid<ItemFaturamentoModel> Grid { get; set; }
        protected SfSpinner SpinnerPrincipal;
        protected MeuToast MeuToast;
        protected override void OnAfterRender(bool firstRender)
        {

            ViewModel.IdFormularioInput = IdFormularioInput;
            ViewModel.IdHistoricoInput = IdHistoricoInput;
            ViewModel.SpinnerPrincipal = SpinnerPrincipal;
            ViewModel.MeuToast = MeuToast;

            if (firstRender)
            {
                ViewModel.ItensDevolucaoGrid = Grid;
            }
            StateHasChanged();
        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
            var resposta = await FormulariosService.GetPadraoAsync(URIsFormularios.GetAsync);
            if (resposta.Sucesso)
            {
                ViewModel.FaturamentoEmDevolucao.Formulario = (FormularioModel)resposta.Objeto;
                ViewModel.FaturamentoEmDevolucao.IdFormulario = ViewModel.FaturamentoEmDevolucao.Formulario.Id;
            }
            
        }

    }
}
