﻿using GAFNETBlazor.Components;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using GAFNETLibrary.Enums;
using Microsoft.AspNetCore.Components;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Movimentacoes.Faturamentos
{
    public partial class FaturamentoPage : MeuComponentBase
    {
        [Inject]
        public IFaturamentoVM ViewModel { get; set; }
        [Inject]
        public IPesquisaFaturamentoVM PesquisaViewModel { get; set; }
        public bool ExibirChaveEletronica => ViewModel.Faturamento.Tipo == (int)TipoFaturamento.NotaFiscal && ViewModel.Faturamento.Formulario.NFEletronica;

        protected SfDialog Dlg { get; set; }
        protected SfSpinner SpinnerPrincipal;
        protected MeuToast MeuToast;
        protected SfNumericTextBox<long> IdPessoaInput { get; set; }
        protected SfNumericTextBox<long> IdFormularioInput { get; set; }
        protected SfNumericTextBox<long> IdHistoricoInput { get; set; }

        protected SfNumericTextBox<long> IdVendedorInput { get; set; }
        protected SfNumericTextBox<long> IdTipoDeOperacaoInput { get; set; }

        protected override async Task OnAfterRenderAsync(bool firstRender)
        {

            ViewModel.Dlg = this.Dlg;
            ViewModel.IdPessoaInput = IdPessoaInput;
            ViewModel.IdFormularioInput = IdFormularioInput;
            ViewModel.IdHistoricoInput = IdHistoricoInput;
            ViewModel.IdVendedorInput = IdVendedorInput;
            ViewModel.IdTipoDeOperacaoInput = IdTipoDeOperacaoInput;
            ViewModel.SpinnerPrincipal = SpinnerPrincipal;
            ViewModel.MeuToast = MeuToast;

            if (firstRender && ViewModel.Faturamento.IdPessoa == 0)
            {
                await Task.Delay(500);
                await ViewModel.IdPessoaInput.FocusAsync();
            }
        }
        protected override async Task OnInitializedAsync()
        {
            await base.OnInitializedAsync();
            if (!string.IsNullOrEmpty(ViewModel.UrlRedirecionamento))
            {
                NavigationManager.NavigateTo(ViewModel.UrlRedirecionamento);
                return;
            }
            if (ViewModel.Faturamento.Formulario.Id == 0)
            {
                await ViewModel.LimparTela();
            }
            if (ViewModel.Faturamento.Formulario != null)
            {
                ViewModel.Faturamento.IdFormulario = ViewModel.Faturamento.Formulario.Id;
            }
            await ViewModel.PreencherFormularioPadrao();
            await ViewModel.GetParametrizacoes();
            //ViewModel.InicializarFaturamentos();
            ViewModel.PropriedadeMudou += (o, e) => StateHasChanged();
        }

    }
}
