﻿using GAFNETBlazor.Constantes;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.Services.Usuario;
using Microsoft.AspNetCore.Components;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Pages.Usuario.Movimentacoes
{
    public partial class Movimentacoes : MeuComponentBase
    {
        [Inject]
        public IFormulariosService FormulariosService { get; set; }

        protected List<ItemPageModel> itens = new();
        protected override async Task OnInitializedAsync()
        {
            if (!string.IsNullOrEmpty(LoginStore.Token))
            {
                itens = await ItensMovimentacaoService.Itens();
                _ = await FormulariosService.GetPadraoAsync(URIsFaturamentos.GetFormulariosAsync); // feito somente para agilizar a inicialização
            }
            else
            {
                NavigationManager.NavigateTo("/Login");
            }

        }
    }
}
