﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;

namespace GAFNETBlazor.Services
{
    public class AcoesFaturamentoService : IAcoesFaturamentoService
    {
        public List<ListaModel> Itens()
        {
            List<ListaModel> itensTipo = new()
            {
                new ListaModel{Valor = (int)TipoAcaoFaturamento.Faturar, Descricao = "Faturar", Icone = "fas fa-clipboard" },
                new ListaModel{Valor = (int)TipoAcaoFaturamento.Devolver, Descricao = "Devolver", Icone = "fas fa-redo" },
                new ListaModel{Valor = (int)TipoAcaoFaturamento.Retornar, Descricao = "Retornar", Icone = "fas fa-recycle" },
                new ListaModel{Valor = (int)TipoAcaoFaturamento.Cancelar, Descricao = "Cancelar", Icone = "far fa-window-close" },
                new ListaModel {Valor = (int)TipoAcaoFaturamento.Inutilizar, Descricao = "Inutilizar", Icone = "far fa-file-excel" },
                new ListaModel{Valor = (int)TipoAcaoFaturamento.Excluir, Descricao = "Excluir", Icone = "fas fa-trash-alt" },
                new ListaModel {Valor = (int)TipoAcaoFaturamento.ImprimirDANFE, Descricao = "Imprimir", Icone = "fas fa-print" },
                new ListaModel {Valor = (int)TipoAcaoFaturamento.Duplicar, Descricao = "Duplicar", Icone = "far fa-clone" },
                new ListaModel {Valor = (int)TipoAcaoFaturamento.Informacao, Descricao = "Informações", Icone = "fas fa-info" },
            };
            return itensTipo;
        }

        public List<ListaModel> ItensPedido()
        {
            List<ListaModel> itensTipo = new()
            {
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Faturar, Descricao = "Faturar", Icone = "fas fa-clipboard" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Cancelar, Descricao = "Cancelar", Icone = "far fa-window-close" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.ImprimirDANFE, Descricao = "Imprimir", Icone = "fas fa-print" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Duplicar, Descricao = "Duplicar", Icone = "far fa-clone" },
            };
            return itensTipo;
        }

        public List<ListaModel> ItensPedidoGrid()
        {
            List<ListaModel> itensTipo = new()
            {
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Informacao, Descricao = "Informação", Icone = "fas fa-info" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.ImprimirDANFE, Descricao = "Imprimir", Icone = "fas fa-print" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Duplicar, Descricao = "Duplicar", Icone = "far fa-clone" },
            };
            return itensTipo;
        }

        public List<ListaModel> ItensNotaFiscal()
        {
            List<ListaModel> itensTipo = new()
            {
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Retornar, Descricao = "Retornar", Icone = "fas fa-recycle" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Cancelar, Descricao = "Cancelar", Icone = "far fa-window-close" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Inutilizar, Descricao = "Inutilizar", Icone = "far fa-file-excel" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Estornar, Descricao = "Estornar", Icone = "fab fa-creative-commons-sa" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Excluir, Descricao = "Excluir", Icone = "fas fa-trash-alt" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.ImprimirDANFE, Descricao = "Imprimir", Icone = "fas fa-print" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.EnviarEMail, Descricao = "Enviar e-mail", Icone = "far fa-envelope" },
                new ListaModel {Valor = (int)TipoAcaoFaturamento.Informacao, Descricao = "Informações", Icone = "fas fa-info" },
            };
            return itensTipo;
        }

        public List<ListaModel> ItensNotaFiscalGrid()
        {
            List<ListaModel> itensTipo = new()
            {
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Informacao, Descricao = "Informação", Icone = "fas fa-info" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.ImprimirDANFE, Descricao = "Imprimir", Icone = "fas fa-print" },
                new ListaModel{Valor = (int)TipoAcaoFaturamento.Faturar, Descricao = "Faturar", Icone = "fas fa-clipboard" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.EnviarEMail, Descricao = "Enviar e-mail", Icone = "far fa-envelope" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Cancelar, Descricao = "Cancelar", Icone = "far fa-window-close" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Inutilizar, Descricao = "Inutilizar", Icone = "far fa-file-excel" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Estornar, Descricao = "Estornar", Icone = "fab fa-creative-commons-sa" },
            };
            return itensTipo;
        }

        public List<ListaModel> ItensOrcamento()
        {
            List<ListaModel> itensTipo = new()
            {
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Faturar, Descricao = "Faturar", Icone = "fas fa-clipboard" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Cancelar, Descricao = "Cancelar", Icone = "far fa-window-close" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.ImprimirDANFE, Descricao = "Imprimir", Icone = "fas fa-print" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Duplicar, Descricao = "Duplicar", Icone = "far fa-clone" },
            };
            return itensTipo;
        }

        public List<ListaModel> ItensOrdemDeServico()
        {
            List<ListaModel> itensTipo = new()
            {
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Faturar, Descricao = "Faturar", Icone = "fas fa-clipboard" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Cancelar, Descricao = "Cancelar", Icone = "far fa-window-close" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.ImprimirDANFE, Descricao = "Imprimir", Icone = "fas fa-print" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Duplicar, Descricao = "Duplicar", Icone = "far fa-clone" },
            };
            return itensTipo;
        }

        public List<ListaModel> ItensPedidoDeCompra()
        {
            List<ListaModel> itensTipo = new()
            {
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Cancelar, Descricao = "Cancelar", Icone = "far fa-window-close" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.ImprimirDANFE, Descricao = "Imprimir", Icone = "fas fa-print" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Duplicar, Descricao = "Duplicar", Icone = "far fa-clone" },
            };
            return itensTipo;
        }

        public List<ListaModel> ItensCompra()
        {
            List<ListaModel> itensTipo = new()
            {
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Devolver, Descricao = "Devolver", Icone = "fas fa-redo" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Retornar, Descricao = "Retornar", Icone = "fas fa-recycle" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Excluir, Descricao = "Excluir", Icone = "fas fa-trash-alt" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.ImprimirDANFE, Descricao = "Imprimir", Icone = "fas fa-print" },
            };
            return itensTipo;
        }

        public List<ListaModel> ItensCompraGrid()
        {
            List<ListaModel> itensTipo = new()
            {
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Devolver, Descricao = "Devolver", Icone = "fas fa-redo" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Retornar, Descricao = "Retornar", Icone = "fas fa-recycle" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.Excluir, Descricao = "Excluir", Icone = "fas fa-trash-alt" },
                new ListaModel { Valor = (int)TipoAcaoFaturamento.ImprimirDANFE, Descricao = "Imprimir", Icone = "fas fa-print" },
            };
            return itensTipo;
        }

    }
}
