﻿using GAFNETBlazor.Constantes;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System;
using System.Net.Http;
using System.Threading.Tasks;

namespace GAFNETBlazor.Services.Administrativo
{
    public class ClaimsService : IClaimsService
    {
        private readonly IHttpClientComToken _httpClientComToken;
        public ClaimsService(IHttpClientComToken httpClientComToken)
        {
            _httpClientComToken = httpClientComToken;
        }

        public Task<HttpResponseMessage> CriarClaim(ClaimModel claim)
        {
            return _httpClientComToken.Enviar(HttpMethod.Post, URIsClaims.Post, claim);
        }

        public Task<HttpResponseMessage> AlterarClaim(ClaimModel claim)
        {
            return _httpClientComToken.Enviar(HttpMethod.Put, URIsClaims.Put, claim);
        }

        public Task<HttpResponseMessage> GetClaims()
        {
            return _httpClientComToken.GetResposta(URIsClaims.Get);
        }

        public Task<HttpResponseMessage> GetClaimByName(string nome)
        {
            Uri uri = new Uri($"{URIsClaims.GetByName}nome={nome}");
            return _httpClientComToken.HttpClient.GetAsync(uri);
        }
    }
}
