﻿using GAFNETBlazor.Models;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Services.Administrativo
{
    public static class ItensAdminCadastrosService
    {
        public static Task<List<ItemPageModel>> Itens()
        {
            List<ItemPageModel> itens = new()
            {
                new ItemPageModel()
                {
                    Caption = "Usuários",
                    Link = "/Administrativo/Cadastros/CadastroUsuario",
                    Icon = "fas fa-user fa-3x"
                },
                new ItemPageModel()
                {
                    Caption = "Representantes",
                    Link = "/Administrativo/Cadastros/Representantes",
                    Icon = "fas fa-phone fa-3x"
                },
                new ItemPageModel()
                {
                    Caption = "Empresas",
                    Link = "/Administrativo/Cadastros/Empresas",
                    Icon = "fas fa-building fa-3x"
                },
                new ItemPageModel()
                {
                    Caption = "Claims",
                    Link = "/Administrativo/Cadastros/Claims",
                    Icon = "fas fa-tasks fa-3x"
                },
                new ItemPageModel()
                {
                    Caption = "Roles",
                    Link = "/Administrativo/Cadastros/Roles",
                    Icon = "fas fa-boxes fa-3x"
                },
                new ItemPageModel()
                {
                    Caption = "Definição de Senha",
                    Link = "/Administrativo/Cadastros/SetaSenhaUsuario",
                    Icon = "fas fa-key fa-3x fa-3x"
                },
                new ItemPageModel()
                {
                    Caption = "Tabelas IBPT",
                    Link = "/Administrativo/Manutencao/TabelasIBPT",
                    Icon = "fas fa-upload fa-3x fa-3x"
                }
            };

            return Task.FromResult(itens);
        }
    }
}
