﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.Constantes;
using System;
using System.Net.Http;
using System.Threading.Tasks;
using GAFNETLibrary.Enums;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.Services.Administrativo
{
    public class RepresentantesService : IRepresentantesService
    {
        private readonly IHttpClientComToken _httpClientComToken;
        public RepresentantesService(IHttpClientComToken httpClientComToken)
        {
            _httpClientComToken = httpClientComToken;
        }

        public async Task<HttpResponseMessage> CriarRepresentante(RepresentanteModel representante)
        {
            return await _httpClientComToken.Enviar(HttpMethod.Post, URIsRepresentantes.Post, representante);
        }

        public Task<HttpResponseMessage> AlterarRepresentante(RepresentanteModel representante)
        {
            return _httpClientComToken.Enviar(HttpMethod.Put, URIsRepresentantes.Put, representante);
        }

        public Task<HttpResponseMessage> GetRepresentantes(StatusAtivo status)
        {
            return _httpClientComToken.GetResposta(new Uri(URIsRepresentantes.Get.ToString() + "?status=" + status));
        }

        public Task<HttpResponseMessage> GetRepresentanteById(long id, StatusAtivo status)
        {
            return _httpClientComToken.GetResposta(new Uri(URIsRepresentantes.GetById + "id=" + id + "&status=" + status));
        }
    }
}
