﻿using GAFNETBlazor.Constantes;
using GAFNETBlazor.Services.Interfaces;
using GAFNETLibrary.Models;
using System;
using System.Net.Http;
using System.Threading.Tasks;

namespace GAFNETBlazor.Services.Administrativo
{
    public class RolesService : IRolesService
    {
        private readonly IHttpClientComToken _httpClientComToken;
        public RolesService(IHttpClientComToken httpClientComToken)
        {
            _httpClientComToken = httpClientComToken;
        }

        public Task<HttpResponseMessage> CriarRole(RoleModel role)
        {
            return _httpClientComToken.Enviar(HttpMethod.Post, URIsRoles.Post, role);
        }

        public Task<HttpResponseMessage> AlterarRole(RoleModel role)
        {
            return _httpClientComToken.Enviar(HttpMethod.Put, URIsRoles.Put, role);
        }

        public Task<HttpResponseMessage> GetRoles()
        {
            return _httpClientComToken.GetResposta(URIsRoles.Get);
        }

        public Task<HttpResponseMessage> GetRoleByName(string nome)
        {
            Uri uri = new Uri($"{URIsRoles.GetByName}nome={nome}");
            return _httpClientComToken.HttpClient.GetAsync(uri);
        }
    }
}
