﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using Microsoft.AspNetCore.WebUtilities;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.Services.Administrativo
{
    public class UsuariosService : IUsuariosService
    {
        private readonly IHttpClientComToken _httpClientComToken;
        public UsuariosService(IHttpClientComToken httpClientComToken)
        {
            _httpClientComToken = httpClientComToken;
        }

        public Task<HttpResponseMessage> CriarUsuario(UsuarioModel usuario)
        {
            return _httpClientComToken.Enviar(HttpMethod.Post, URIsUsuarios.Post, usuario);
        }

        public Task<HttpResponseMessage> AlterarUsuario(UsuarioModel usuario)
        {
            return _httpClientComToken.Enviar(HttpMethod.Put, URIsUsuarios.Put, usuario);
        }

        public Task<HttpResponseMessage> GetUsuarios()
        {
            return _httpClientComToken.GetResposta(URIsUsuarios.Get);
        }

        public Task<HttpResponseMessage> GetUsuarioByEMail(string email, StatusAtivo status)
        {
            var queryParams = new Dictionary<string, string>()
            {
                {"email", email },
                {"status", status.ToString() }
            };
            var uri = new Uri(QueryHelpers.AddQueryString(URIsUsuarios.GetByEMail.ToString(), queryParams));
            return _httpClientComToken.GetResposta(uri);
        }

        public Task<HttpResponseMessage> AlterarSenhaUsuario(AlteraSenhaUsuarioModel usuario)
        {
            return _httpClientComToken.Enviar(HttpMethod.Put, URIsUsuarios.AlterarSenha, usuario);
        }
    }
}
