﻿using GAFNETBlazor.Constantes;
using GAFNETBlazor.Services.Interfaces;
using GAFNETLibrary.Enums;
using GAFNETLibrary.Models;
using System.Threading.Tasks;

namespace GAFNETBlazor.Services
{
    public class DadosRelatService : IDadosRelatService
    {
        private readonly IPessoasService _pessoasService;
        public DadosRelatService(IPessoasService pessoasService)
        {
            _pessoasService = pessoasService;
        }
        public async Task<RespostaAPIModel> Dados(ServicoDados servicoDados, string campos, string filtros, string order, string top)
        {
            RespostaAPIModel resposta = new RespostaAPIModel { Status = System.Net.HttpStatusCode.NotFound, MensagemErro = "Não implementado ainda" };
            switch (servicoDados)
            {
                case ServicoDados.PessoasService:
                    resposta = await _pessoasService.GetAsync(URIsPessoas.GetAsync, campos, filtros, order, top);
                    break;
                    
                case ServicoDados.FaturamentosService:
                    break;
                default:
                    break;
            }
            return resposta;
        }
    }
}
