﻿using GAFNETBlazor.Constantes;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETLibrary.Enums;
using GAFNETLibrary.Models;
using Newtonsoft.Json;
using System;
using System.Net.Http;
using System.Threading.Tasks;

namespace GAFNETBlazor.Services
{
    public class DuplicacaoFaturamentoService : IDuplicacaoFaturamentoService
    {
        private readonly IHttpClientComToken _httpClientComToken;
        public DuplicacaoFaturamentoService(IHttpClientComToken httpClientComToken)
        {
            _httpClientComToken = httpClientComToken;
        }
        public async Task<ResultadoModel> EnviarDuplicacaoAsync(FaturamentoModel faturamento)
        {
            var uri = URIsFaturamentos.UriDuplicacao((TipoFaturamento)faturamento.Tipo);
            uri = new Uri(uri + $"?id={faturamento.Id}");
            var retorno = await _httpClientComToken.Enviar(HttpMethod.Post, uri, null);
            var respostaAPI = new RespostaAPIModel(retorno);
            if (!respostaAPI.Sucesso)
            {
                return new ResultadoModel { Sucesso = false, Retorno = respostaAPI.MensagemErro };
            }

            var faturamentoRetorno = JsonConvert.DeserializeObject<FaturamentoModel>(respostaAPI.ConteudoRetorno);
            return new ResultadoModel { Sucesso = true, Retorno = faturamentoRetorno };
        }
    }
}
