﻿using GAFNETBlazor.Constantes;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETLibrary.Models;
using System;
using System.Threading.Tasks;

namespace GAFNETBlazor.Services
{
    public class EnderecoPeloCEPService : IEnderecoPeloCEPService
    {
        private readonly ICorreiosService _correiosService;
        private readonly IPaisesService _paisesService;

        public EnderecoPeloCEPService(ICorreiosService correiosService, IPaisesService paisesService)
        {
            _correiosService = correiosService;
            _paisesService = paisesService;
        }
        public async Task<RespostaAPIModel> Endereco(string cep)
        {
            if (string.IsNullOrEmpty(cep)) return null;
            var retorno = await _correiosService?.GetEnderecoByCEPAsync(cep);

            if (string.IsNullOrEmpty(retorno.MensagemErro))
            {
                ((EnderecoPessoaModel)retorno.Objeto).Pais = (PaisModel)(await _paisesService?.GetPadraoAsync(URIsPessoas.GetPaisesAsync)).Objeto;
                ((EnderecoPessoaModel)retorno.Objeto).IdPais = ((EnderecoPessoaModel)retorno.Objeto).Pais.Id;
            }
            return retorno;
        }
    }
}
