﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using GAFNETBlazor.ViewModels.Usuario.FaturamentoBase;
using System.Threading.Tasks;

namespace GAFNETBlazor.Services
{
    public class ExibicaoProdutoFaturamentoService : IExibicaoProdutoFaturamentoService
    {
        private readonly IProdutosService _produtosService;
        private readonly IPreenchimentoCSTCFOPCompraService _preenchimentoCSTCFOPCompraService;
        public ExibicaoProdutoFaturamentoService(IProdutosService produtosService, IPreenchimentoCSTCFOPCompraService preenchimentoCSTCFOPCompraService)
        {
            _produtosService = produtosService;
            _preenchimentoCSTCFOPCompraService = preenchimentoCSTCFOPCompraService;
        }
        public async Task ExibirByCodigo(IFaturamentoBaseVM viewModel, string codigo)
        {
            
            var itemFaturamento = viewModel.ItemFaturamento;
            itemFaturamento.Produto = new ProdutoModel { Aliquota = new AliquotaModel() };
            if (codigo == null) return;
            var produto = await ProdutoByCodigo.Get(viewModel, _produtosService, codigo);
            if (produto != null)
            {
                itemFaturamento.Produto = produto;
                itemFaturamento.IdProduto = produto.Id;
                itemFaturamento.VlrUnit = produto.VlrVenda;
            }
            if (viewModel is ICompraVM && itemFaturamento.Produto.Id > 0)
            {
                _preenchimentoCSTCFOPCompraService.Preencher((ICompraVM)viewModel);
            }
            viewModel.AoMudarPropriedade("ItemFaturamento");
        }
    }
}
