﻿using GAFNETBlazor.Models;
using GAFNETLibrary.Models;
using System;
using System.IO;
using System.Threading.Tasks;

namespace GAFNETBlazor.Services.Interfaces
{
    public interface IComprasService : IFaturamentoBaseService
    {
        Task<RespostaAPIModel> GetByNumeroAndSerieAndPessoaAndTipoAsync(int numero, int serie, long idPessoa, int tipo);
        Task<RespostaAPIModel> ImportaXMLAsync(MemoryStream memoryStream, string fileName, DateTime dtRecebimento, long idHistorico);
        Task<RespostaAPIModel> GravarNotaImportadaAsync(FaturamentoModel faturamento);
        Task<ResultadoModel> GetNotaDeXMLAsync(string cnpjEmpresa, MemoryStream memoryStream, string fileName, DateTime? dtEntrada, long? idHistorico);
    }
}
