﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using System;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.Services.Interfaces
{
    public interface INFeService
    {
        Task<ResultadoModel> Enviar(FaturamentoModel faturamento);
        Task<ResultadoModel> EnviarEMail(string chaveEletronica, TipoAnexoEMailNFe tipoAnexoEMail);
        Task<ResultadoModel> ImprimirDANFE(string chaveEletronica);
        Task<ResultadoModel> Consultar(string chave);
        Task<ResultadoModel> CancelarNFeAsync(string chaveEletronica, string justificativa);
        Task<ResultadoModel> InutilizarNFeAsync(ParamInutilizacaoNFeModel p);

        event Action<string> OnEtapaEnvioNFe;
        event Action<string> OnEtapaCancelamentoNFe;
        event Action<string> OnEtapaInutilizacaoNFe;

    }
}
