﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using System;
using System.Net.Http;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.Services.Interfaces
{
    public interface IPessoasService : IGravaConsultaService
    {
        Task<HttpResponseMessage> GetClientesAsync(StatusAtivo statusAtividade = StatusAtivo.Todos);
        Task<HttpResponseMessage> GetFornecedoresAsync(StatusAtivo statusAtividade);
        Task<HttpResponseMessage> GetTransportadorasAsync(StatusAtivo statusAtividade);
        Task<RespostaAPIModel> GetByIdAsync(Uri uriBase, long id, string campos, string filtros);
        Task<RespostaAPIModel> GetByCNPJAsync(string cnpj, StatusAtivo statusAtividade = StatusAtivo.Todos);
        PessoaModel GetPessoaVazia();
        Task<RespostaAPIModel> GetAsync(PesquisaPessoaModel parametros);
    }
}
