﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using Newtonsoft.Json;
using System;

namespace GAFNETBlazor.Services
{

    class AuxiliarItemRetorno
    {
        public string TpAmb { get; set; }

        public string VerAplic { get; set; }

        public string ChDFe { get; set; }

        public DateTime DhRecbto { get; set; }

        public string NProt { get; set; }

        public string DigVal { get; set; }

        public int CStat { get; set; }

        public string XMotivo { get; set; }

        public string XML { get; set; }
    }
    class AuxiliarRetorno
    {
        public string Protocolo { get; set; }
        public AuxiliarItemRetorno ItemRetorno { get; set; }
    }

    class LeituraRetorno
    {
        public AuxiliarRetorno Retorno { get; set; }
        //public AuxiliarItemRetorno ItemRetorno { get; set; }
    }

    public class LeituraRetornoNFeService : ILeituraRetornoNFeService
    {
        public RetornoNFeModel LerRetorno(string resposta)
        {
            string primJson = resposta.Substring(0, resposta.IndexOf("} }") + 3);
            //string segJson = resposta.Substring(primJson.Length, resposta.Length - primJson.Length);
            string segJson = resposta[primJson.Length..];
            int posNDocto = segJson.IndexOf("\"NFe");
            int finNDocto = segJson.IndexOf("\"", posNDocto + 1);
            string nDocto = segJson.Substring(posNDocto + 1, finNDocto - posNDocto - 1); //acrescentado 1 na posição inicial para não pegar a aspa e tirado um na posição final pelo mesmo motivo
            nDocto = nDocto[3..]; //deixado somente o número do documento sem o "NFe" inicial
            segJson = segJson.Replace($"NFe{nDocto}", "ItemRetorno");
            var ret = JsonConvert.DeserializeObject<LeituraRetorno>(segJson);
            return new RetornoNFeModel
            {
                ChDFe = ret.Retorno.ItemRetorno.ChDFe,
                CStat = ret.Retorno.ItemRetorno.CStat,
                DhRecbto = ret.Retorno.ItemRetorno.DhRecbto,
                DigVal = ret.Retorno.ItemRetorno.DigVal,
                NProt = ret.Retorno.ItemRetorno.NProt,
                Protocolo = ret.Retorno.Protocolo,
                TpAmb = ret.Retorno.ItemRetorno.TpAmb,
                VerAplic = ret.Retorno.ItemRetorno.VerAplic,
                XML = ret.Retorno.ItemRetorno.XML,
                XMotivo = ret.Retorno.ItemRetorno.XMotivo
            };
        }
    }
}
