﻿using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Administrativo;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;

namespace GAFNETBlazor.Services
{
    public class LogoutService : ILogoutService
    {
        private readonly ICadastroClassificacaoFiscalVM _classFiscalVM;
        private readonly ICadastroAliquotaVM _aliquotaVM;
        private readonly ICadastroUFICMSVM _UFICMSVM;
        private readonly ICadastroEmbalagemVM _embalagemVM;
        private readonly ICadastroUnidadeProdutoVM _unidadeProdutoVM;
        private readonly ICadastroGrupoProdutoVM _grupoProdutoVM;
        private readonly ICadastroSubgrupoProdutoVM _subgrupoProdutoVM;
        private readonly ICadastroHistoricoVM _historicoVM;
        private readonly ICadastroPessoaVM _pessoaVM;
        private readonly ICadastroClaimVM _claimVM;
        private readonly ICadastroEmpresaVM _empresaVM;
        private readonly ICadastroRepresentanteVM _representanteVM;
        private readonly ICadastroRoleVM _roleVM;
        private readonly ICadastroUsuarioVM _usuarioVM;
        private readonly ICadastroGeneroProdutoVM _generoProdutoVM;
        private readonly ICadastroProdutoVM _produtoVM;
        private readonly IFaturamentoVM _faturamentoVM;
        private readonly ICompraVM _compraVM;
        //private readonly ICadastroClienteUsuarioMobileVM _clienteUsuarioMobileVM;
        public LogoutService(ICadastroClassificacaoFiscalVM classFiscalVM,
            ICadastroAliquotaVM aliquotaVM,
            ICadastroEmbalagemVM embalagemVM,
            ICadastroUnidadeProdutoVM unidadeProdutoVM,
            ICadastroGrupoProdutoVM grupoProdutoVM,
            ICadastroSubgrupoProdutoVM subgrupoProdutoVM,
            ICadastroHistoricoVM historicoVM,
            ICadastroPessoaVM pessoaVM,
            ICadastroClaimVM claimVM,
            ICadastroEmpresaVM empresaVM,
            ICadastroRepresentanteVM representanteVM,
            ICadastroRoleVM roleVM,
            ICadastroUsuarioVM usuarioVM,
            ICadastroGeneroProdutoVM generoProdutoVM,
            ICadastroProdutoVM produtoVM,
            IFaturamentoVM faturamentoVM,
            ICadastroUFICMSVM UFICMSVM,
            ICompraVM compraVM)
        {
            _classFiscalVM = classFiscalVM;
            _aliquotaVM = aliquotaVM;
            _UFICMSVM = UFICMSVM;
            _embalagemVM = embalagemVM;
            _unidadeProdutoVM = unidadeProdutoVM;
            _grupoProdutoVM = grupoProdutoVM;
            _subgrupoProdutoVM = subgrupoProdutoVM;
            _historicoVM = historicoVM;
            _pessoaVM = pessoaVM;
            _claimVM = claimVM;
            _empresaVM = empresaVM;
            _representanteVM = representanteVM;
            _roleVM = roleVM;
            _usuarioVM = usuarioVM;
            _generoProdutoVM = generoProdutoVM;
            _produtoVM = produtoVM;
            _faturamentoVM = faturamentoVM;
            _compraVM = compraVM;
            //_clienteUsuarioMobileVM = clienteUsuarioMobileVM;

        }
        public void ResetViewModels()
        {
            _classFiscalVM.LimparTela();
            _aliquotaVM.LimparTela();
            _UFICMSVM.LimparTela();
            _embalagemVM.LimparTela();
            _unidadeProdutoVM.LimparTela();
            _grupoProdutoVM.LimparTela();
            _subgrupoProdutoVM.LimparTela();
            _historicoVM.LimparTela();
            _pessoaVM.LimparTelaAsync();
            _claimVM.LimparTela();
            _empresaVM.LimparTela();
            _representanteVM.LimparTela();
            _roleVM.LimparTela();
            _usuarioVM.LimparTela();
            _generoProdutoVM.LimparTela();
            _produtoVM.LimparTela();
            _faturamentoVM.LimparTela();
            _compraVM.LimparTela();
        }
    }
}
