﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.Services
{
    public class ParametrizacoesService : IParametrizacoesService
    {
        private readonly IHttpClientComToken _httpClientComToken;

        public ParametrizacaoModel Parametrizacao { get; set; }

        public ParametrizacoesService(IHttpClientComToken httpClientComToken)
        {
            _httpClientComToken = httpClientComToken;
            Parametrizacao = new ParametrizacaoModel();
        }

        public async Task<RespostaAPIModel> GetAsync(Uri uriBase)
        {
            string select = uriBase.ToString();

            select += "?$count=true";
            var resposta = await _httpClientComToken.GetResposta(new Uri(select));
            var retornoAPI = new RespostaAPIModel(resposta);

            if (!resposta.IsSuccessStatusCode)
            {
                return retornoAPI;
            }

            
            var parametros = JsonConvert.DeserializeObject<List<ParametrizacaoModel>>(retornoAPI.ConteudoRetorno);
            retornoAPI.Objeto = parametros.FirstOrDefault();
            retornoAPI.Status = parametros.Any() ? HttpStatusCode.OK : HttpStatusCode.NoContent;
            if (retornoAPI.Objeto != null)
            {
                Parametrizacao = (ParametrizacaoModel)retornoAPI.Objeto;
            }
            return retornoAPI;
        }

        public Task<RespostaAPIModel> GetAsync(Uri uriBase, string campos, string filtros, string order, string top)
        {
            throw new NotImplementedException();
        }

        public async Task<RespostaAPIModel> PostAsync<T>(T entity)
        {
            var retorno = await _httpClientComToken.Enviar(HttpMethod.Post, URIsParametrizacoes.PostAsync, entity);
            return new RespostaAPIModel(retorno);
        }

        public Task<RespostaAPIModel> GetByIdAsync(Uri uriBase, long id, StatusAtivo status)
        {
            throw new NotImplementedException();
        }

        public Task<RespostaAPIModel> GetAsync(Uri uriBase, StatusAtivo status)
        {
            throw new NotImplementedException();
        }

        public Task<RespostaAPIModel> PutAsync<T>(T entity)
        {
            throw new NotImplementedException();
        }
    }
}
