﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETLibrary.Enums;
using System.Collections.Generic;

namespace GAFNETBlazor.Services.Relatorios;

public class NomesRelatoriosService : INomesRelatoriosService
{
    public List<ListaModel> Itens(EntidadeRelatorio entidade)
    {
        return entidade switch
        {
            EntidadeRelatorio.Pessoa => ItensPessoa(),
            _ => new List<ListaModel>()
        };
    }

    private static List<ListaModel> ItensPessoa()
    {
        List<ListaModel> nomes = new()
        {
            new ListaModel { StrValor = "listagem-clientes-sintetica.rdlc", Descricao = "Listagem de Clientes Sintética" },
        };
        return nomes;
    }
}
