﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.Stores.Interfaces;
using System.Collections.Generic;

namespace GAFNETBlazor.Services
{
    public class SideMenuService : ISideMenuService
    {
        private readonly ILoginStore _loginStore;
        public SideMenuService(ILoginStore loginStore)
        {
            _loginStore = loginStore;
        }
        public List<SideMenuItemModel> ItensMenu()
        {
            List<SideMenuItemModel> itens = new List<SideMenuItemModel>();

            if (string.IsNullOrEmpty(_loginStore.Token))
            {
                return itens;
            }

            itens.Add(new SideMenuItemModel { Id = "01", Text = "Home", IconCSS = "fas fa-home", Url = "/" });
            itens.Add(new SideMenuItemModel { Id = "02", Text = "Manutenção", IconCSS = "fas fa-tools", Url = "/Usuario/Manutencao" });

            if (_loginStore.EhRepresentante || _loginStore.EhAdmin)
            {
                if (_loginStore.EhAdmin)
                {
                    itens.Add(new SideMenuItemModel { Id = "03", Text = "Administrativo", IconCSS = "fas fa-user-cog", HasChild = true, Url = null });

                    itens.Add(new SideMenuItemModel { Id = "03-01", Text = "Cadastros", IconCSS = "fas fa-folder-plus", ParentId = "03", Url = "Administrativo/Cadastros" });
                    itens.Add(new SideMenuItemModel { Id = "03-02", Text = "Relatórios", IconCSS = "fas fa-newspaper", ParentId = "03" });
                }
                //itens.Add(new SideMenuItemModel { Id = "04", Text = "Representantes", IconCSS = "far fa-address-card", HasChild = true });
                //itens.Add(new SideMenuItemModel { Id = "04-01", Text = "Manutenção", IconCSS = "fas fa-building", ParentId = "04", Url = "Representante/Manutencao/Empresas" });
                itens.Add(new SideMenuItemModel { Id = "04", Text = "Representantes", IconCSS = "far fa-address-card", Url = "Representante" });

            }

            itens.Add(new SideMenuItemModel { Id = "06", Text = "Movimentações", IconCSS = "fas fa-exchange-alt", Url = "Usuario/Movimentacoes" });
            itens.Add(new SideMenuItemModel { Id = "05", Text = "Cadastros", IconCSS = "fas fa-folder-plus", Url = "Usuario/Cadastros" });
            itens.Add(new SideMenuItemModel { Id = "07", Text = "Relatórios", IconCSS = "fas fa-newspaper", Url = "Usuario/Relatorios" });
            itens.Add(new SideMenuItemModel { Id = "08", Text = "Parametrizações", IconCSS = "fas fa-cog", Url = "Usuario/Cadastros/Parametrizacao" });
 
            return itens;
        }
    }
}
