﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;

namespace GAFNETBlazor.Services
{
    public class SitTribIPIService : ISitTribIPIService
    {
        public List<ListaModel> Itens()
        {
            List<ListaModel> itensSitTribPISCOFINS = new()
            {
                new ListaModel{Valor = (int)CSTIPI.EntradaComRecupCred, Descricao = "00 - Entrada com Recuperação de Crédito"},
                new ListaModel{Valor = (int)CSTIPI.EntradaTribAliqZero, Descricao = "01 - Entrada Tributada Alíquota Zero"},
                new ListaModel{Valor = (int)CSTIPI.EntradaIsenta, Descricao = "02 - Entrada Isenta"},
                new ListaModel{Valor = (int)CSTIPI.EntradaNaoTrib, Descricao = "03 - Entrada Não Tributada"},
                new ListaModel{Valor = (int)CSTIPI.EntradaImune, Descricao = "04 - Entrada Imune"},
                new ListaModel{Valor = (int)CSTIPI.EntradaSuspensao, Descricao = "05 - Entrada Suspensão"},
                new ListaModel{Valor = (int)CSTIPI.OutrasEntradas, Descricao = "49 - Outras Entradas"},
                new ListaModel{Valor = (int)CSTIPI.SaidaTrib, Descricao = "50 - Saída Tributada"},
                new ListaModel{Valor = (int)CSTIPI.SaidaTribComAliqZero, Descricao = "51 - Saída Tributada com Alíquota Zero"},
                new ListaModel{Valor = (int)CSTIPI.SaidaIsenta, Descricao = "52 - Saída Isenta"},
                new ListaModel{Valor = (int)CSTIPI.SaidaNaoTrib, Descricao = "53 - Saída Não Tributada"},
                new ListaModel{Valor = (int)CSTIPI.SaidaImune, Descricao = "54 - Saída Imune"},
                new ListaModel{Valor = (int)CSTIPI.SaidaSuspensao, Descricao = "55 - Saída Suspensão"},
                new ListaModel{Valor = (int)CSTIPI.OutrasSaidas, Descricao = "99 - Outras Saídas"}
                
            };
            return itensSitTribPISCOFINS;
        }
    }
}
