﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;

namespace GAFNETBlazor.Services
{
    public class SitTribPISCOFINSEntradaService : ISitTribPISCOFINSEntradaService
    {
        public List<ListaModel> Itens()
        {
            List<ListaModel> itensLista = new List<ListaModel>
            {
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.OpDirCredVincExcRecTribMercInt, StrValor = ((int)CSTPISCOFINSEntrada.OpDirCredVincExcRecTribMercInt).ToString("00"), Descricao = "50 - Operação com Direito a Crédito - Vinculada Exclusivamente a Receita Tributada no Mercado Interno"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.OpDirCredVincExcRecNaoTribMercInt, StrValor = ((int)CSTPISCOFINSEntrada.OpDirCredVincExcRecNaoTribMercInt).ToString("00"), Descricao = "51 - Operação com Direito a Crédito - Vinculada Exclusivamente a Receita Não Tributada no Mercado Interno"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.OpDirCredVincExcRecExp, StrValor = ((int)CSTPISCOFINSEntrada.OpDirCredVincExcRecExp).ToString("00"), Descricao = "52 - Operação com Direito a Crédito - Vinculada Exclusivamente a Receita de Exportação"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.OpDirCredVincRecTribENaoTribMercInt, StrValor = ((int)CSTPISCOFINSEntrada.OpDirCredVincRecTribENaoTribMercInt).ToString("00"), Descricao = "53 - Operação com Direito a Crédito - Vinculada a Receitas Tributadas e Não-Tributadas no Mercado Interno"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.OpDirCredVincRecTribMercIntEExp, StrValor = ((int)CSTPISCOFINSEntrada.OpDirCredVincRecTribMercIntEExp).ToString("00"), Descricao = "54 - Operação com Direito a Crédito - Vinculada a Receitas Tributadas no Mercado Interno e de Exportação"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.OpDirCredVincRecNaoTribMercIntEExp, StrValor = ((int)CSTPISCOFINSEntrada.OpDirCredVincRecNaoTribMercIntEExp).ToString("00"), Descricao = "55 - Operação com Direito a Crédito - Vinculada a Receitas Não-Tributadas no Mercado Interno e de Exportação"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.OpDirCredVincRecTribENaoTribMercIntEExp, StrValor = ((int)CSTPISCOFINSEntrada.OpDirCredVincRecTribENaoTribMercIntEExp).ToString("00"), Descricao = "56 - Operação com Direito a Crédito - Vinculada a Receitas Tributadas e Não-Tributadas no Mercado Interno, e de Exportação"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.CredPresOpAqVincExcRecTribMercadoInt, StrValor = ((int)CSTPISCOFINSEntrada.CredPresOpAqVincExcRecTribMercadoInt).ToString("00"), Descricao = "60 - Crédito Presumido - Operação de Aquisição Vinculada Exclusivamente a Receita Tributada no Mercado Interno"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.CredPresOpAqVincExcRecNaoTribMercInt, StrValor = ((int)CSTPISCOFINSEntrada.CredPresOpAqVincExcRecNaoTribMercInt).ToString("00"), Descricao = "61 - Crédito Presumido - Operação de Aquisição Vinculada Exclusivamente a Receita Não-Tributada no Mercado Interno"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.CredPresOpAqVincExcRecExp, StrValor = ((int)CSTPISCOFINSEntrada.CredPresOpAqVincExcRecExp).ToString("00"), Descricao = "62 - Crédito Presumido - Operação de Aquisição Vinculada Exclusivamente a Receita de Exportação"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.CredPresOpAqVincRecTribENaoTribMercInt, StrValor = ((int)CSTPISCOFINSEntrada.CredPresOpAqVincRecTribENaoTribMercInt).ToString("00"), Descricao = "63 - Crédito Presumido - Operação de Aquisição Vinculada a Receitas Tributadas e Não-Tributadas no Mercado Interno"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.CredPresOpAqVincRecTribMercIntEExp, StrValor = ((int)CSTPISCOFINSEntrada.CredPresOpAqVincRecTribMercIntEExp).ToString("00"), Descricao = "64 - Crédito Presumido - Operação de Aquisição Vinculada a Receitas Tributadas no Mercado Interno e de Exportação"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.CredPresOpAqVincRecNaoTribMercIntEExp, StrValor = ((int)CSTPISCOFINSEntrada.CredPresOpAqVincRecNaoTribMercIntEExp).ToString("00"), Descricao = "65 - Crédito Presumido - Operação de Aquisição Vinculada a Receitas Não-Tributadas no Mercado Interno e de Exportação"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.CredPresOpAqVincRecTribENaoTribMercIntEExp, StrValor = ((int)CSTPISCOFINSEntrada.CredPresOpAqVincRecTribENaoTribMercIntEExp).ToString("00"), Descricao = "66 - Crédito Presumido - Operação de Aquisição Vinculada a Receitas Tributadas e Não-Tributadas no Mercado Interno, e de Exportação"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.CredPresOutOp, StrValor = ((int)CSTPISCOFINSEntrada.CredPresOutOp).ToString("00"), Descricao = "67 - Crédito Presumido - Outras Operações"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.OpAqSemDireitoACred, StrValor = ((int)CSTPISCOFINSEntrada.OpAqSemDireitoACred).ToString("00"), Descricao = "70 - Operação de Aquisição sem Direito a Crédito"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.OpAqComIsencao, StrValor = ((int)CSTPISCOFINSEntrada.OpAqComIsencao).ToString("00"), Descricao = "71 - Operação de Aquisição com Isenção"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.OpAqComSuspensao, StrValor = ((int)CSTPISCOFINSEntrada.OpAqComSuspensao).ToString("00"), Descricao = "72 - Operação de Aquisição com Suspensão"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.OpAqAliquotaZero, StrValor = ((int)CSTPISCOFINSEntrada.OpAqAliquotaZero).ToString("00"), Descricao = "73 - Operação de Aquisição a Alíquota Zero"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.OpAqSemIncidenciaDaContrib, StrValor = ((int)CSTPISCOFINSEntrada.OpAqSemIncidenciaDaContrib).ToString("00"), Descricao = "74 - Operação de Aquisição sem Incidência da Contribuição"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.OpAqSubstituicaoTributaria, StrValor = ((int)CSTPISCOFINSEntrada.OpAqSubstituicaoTributaria).ToString("00"), Descricao = "75 - Operação de Aquisição por Substituição Tributária"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.OutrasOperaçõesDeEntrada, StrValor = ((int)CSTPISCOFINSEntrada.OutrasOperaçõesDeEntrada).ToString("00"), Descricao = "98 - Outras Operações de Entrada"},
                new ListaModel{Valor = (int)CSTPISCOFINSEntrada.OutrasOperacoes, StrValor = ((int)CSTPISCOFINSEntrada.OutrasOperacoes).ToString("00"), Descricao = "99 - Outras Operações"},
                
            };
            return itensLista;
        }
    }
}
