﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;

namespace GAFNETBlazor.Services
{
    public class SitTribPISCOFINSService : ISitTribPISCOFINSService
    {
        public List<ListaModel> Itens()
        {
            List<ListaModel> itensSitTribPISCOFINS = new()
            {
                new ListaModel{Valor = (int)CSTPISCOFINSSaida.OperTribAliNormal, Descricao = "01 - Operação Tributável (base de cálculo = valor de operação alíquota normal (cumulativo/não cumulativo)", StrValor = ((int)CSTPISCOFINSSaida.OperTribAliNormal).ToString("00")},
                new ListaModel{Valor = (int)CSTPISCOFINSSaida.OperTribAliqDiferenciada, Descricao = "02 - Operação Tributável (base de cálculo = valor de operação (alíquota diferenciada))", StrValor = ((int)CSTPISCOFINSSaida.OperTribAliqDiferenciada).ToString("00")},
                new ListaModel{Valor = (int)CSTPISCOFINSSaida.OperTribQtdVendAliqUnidade, Descricao = "03 - Operação Tributável (base de cálculo = quantidade vendida X alíquota por unidade do produto.)", StrValor = ((int)CSTPISCOFINSSaida.OperTribQtdVendAliqUnidade).ToString("00")},
                new ListaModel{Valor = (int)CSTPISCOFINSSaida.OperTribMonoAliqZero, Descricao = "04 - Operação Tributável (tributação monofásica (alíquota zero)", StrValor = ((int)CSTPISCOFINSSaida.OperTribMonoAliqZero).ToString("00")},
                new ListaModel{Valor = (int)CSTPISCOFINSSaida.OperTribAliqZero, Descricao = "06 - Operação Tributável (alíquota zero)", StrValor = ((int)CSTPISCOFINSSaida.OperTribAliqZero).ToString("00")},
                new ListaModel{Valor = (int)CSTPISCOFINSSaida.OperIsentaDeContrib, Descricao = "07 - Operação Isenta de Contribuição", StrValor = ((int)CSTPISCOFINSSaida.OperIsentaDeContrib).ToString("00")},
                new ListaModel{Valor = (int)CSTPISCOFINSSaida.OperSemIncidDeContrib, Descricao = "08 - Operação Sem Incidência de Contribuição", StrValor = ((int)CSTPISCOFINSSaida.OperSemIncidDeContrib).ToString("00")},
                new ListaModel{Valor = (int)CSTPISCOFINSSaida.OperComSuspDeContrib, Descricao = "09 - Operação Com Suspensão de Contribuição", StrValor = ((int)CSTPISCOFINSSaida.OperComSuspDeContrib).ToString("00")},
                new ListaModel{Valor = (int)CSTPISCOFINSSaida.OutrasSaidas, Descricao = "49 - Outras Saídas", StrValor = ((int)CSTPISCOFINSSaida.OutrasSaidas).ToString("00")},
                new ListaModel{Valor = (int)CSTPISCOFINSSaida.OutrasOperacoes, Descricao = "99 - Outras Operações", StrValor = ((int)CSTPISCOFINSSaida.OutrasOperacoes).ToString("00")}
            };
            return itensSitTribPISCOFINS;
        }
    }
}
