﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;

namespace GAFNETBlazor.Services
{
    public class SitTribService : ISitTribService
    {
        public List<ListaModel> Itens()
        {
            List<ListaModel> itensSitTrib = new List<ListaModel>
            {
                new ListaModel{Valor = (int)SituacaoTributaria.Trib_Integralmente, Descricao = "00 - Tributado integralmente"},
                new ListaModel{Valor = (int)SituacaoTributaria.Isento, Descricao = "40 - Isento"},
                new ListaModel{Valor = (int)SituacaoTributaria.ICMS_Cobrado_Ant_ST, Descricao = "60 - ICMS cobrado anteriormente por substituição tributária"},
                new ListaModel{Valor = (int)SituacaoTributaria.Com_Red_Base_Calc, Descricao = "20 - Com redução de base de cálculo"},
                new ListaModel{Valor = (int)SituacaoTributaria.Nao_Tributado, Descricao = "41 - Não tributado"},
                new ListaModel{Valor = (int)SituacaoTributaria.Suspencao, Descricao = "50 - Suspensão"},
                new ListaModel{Valor = (int)SituacaoTributaria.Diferimento, Descricao = "51 - Diferimento"},
                new ListaModel{Valor = (int)SituacaoTributaria.Trib_Com_Cob_ICMS_Por_ST, Descricao = "10 - Trib. e c/ Cobrança do ICMS por Substituição Tributária"},
                new ListaModel{Valor = (int)SituacaoTributaria.Com_Red_Base_Calc_Cob_ICMS_Por_ST, Descricao = "70 - C/ Red. de Base de Cálc. e Cob. do ICMS por Sub. Trib."},
                new ListaModel{Valor = (int)SituacaoTributaria.Isenta_Ou_Nao_Trib_Com_Cob_ICMS_Por_ST, Descricao = "30 - Isenta ou não tributada e com cobrança do ICMS por substituição tributária"},
                new ListaModel{Valor = (int)SituacaoTributaria.ICMS_Outros_90, Descricao = "90 - ICMS Outros"},
                new ListaModel{Valor = (int)SituacaoTributaria.Trib_Simples_Nac_Com_Perm_Cred, Descricao = "101 - Tributada pelo Simples Nacional com permissão de crédito"},
                new ListaModel{Valor = (int)SituacaoTributaria.Trib_Simples_Nac_Sem_Perm_Cred, Descricao = "102 - Tributada pelo Simples Nacional sem permissão de crédito"},
                new ListaModel{Valor = (int)SituacaoTributaria.Isencao_ICMS_No_Simples_Nac_Faixa_Rec_Bruta, Descricao = "103 - Isenção do ICMS no Simples Nacional para faixa de receita bruta"},
                new ListaModel{Valor = (int)SituacaoTributaria.Trib_Simples_Nac_Com_Perm_Cred_Com_Cob_ICMS_Por_ST, Descricao = "201 - Tributada pelo Simples Nacional com permissão de crédito e com cobrança do ICMS por Substituição Tributária"},
                new ListaModel{Valor = (int)SituacaoTributaria.Trib_Simples_Nac_Sem_Perm_Cred_Com_Cob_ICMS_Por_ST, Descricao = "202 - Tributada pelo Simples Nacional sem permissão de crédito e com cobrança do ICMS por Substituição Tributária"},
                new ListaModel{Valor = (int)SituacaoTributaria.Isencao_ICMS_No_Simples_Nac_Faixa_Rec_Bruta_Cob_ICMS_Por_ST, Descricao = "203 - Isenção do ICMS no Simples Nacional para faixa de receita bruta e com cobrança do ICMS por Substituição Tributária"},
                new ListaModel{Valor = (int)SituacaoTributaria.Imune, Descricao = "300 - Imune"},
                new ListaModel{Valor = (int)SituacaoTributaria.Nao_Trib_Simples_Nac, Descricao = "400 - Não tributada pelo Simples Nacional"},
                new ListaModel{Valor = (int)SituacaoTributaria.ICMS_Cob_Ant_Por_ST_Substituido_Ou_Por_Antecip, Descricao = "500 - ICMS cobrado anteriormente por substituição tributária (substituído) ou por antecipação"},
                new ListaModel{Valor = (int)SituacaoTributaria.ICMS_Outros_900, Descricao = "900 - ICMS Outros"}
            };
            return itensSitTrib;
        }
    }
}
