﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;

namespace GAFNETBlazor.Services
{
    public class TabelaAService : ITabelaAService
    {
        public List<ListaModel> Itens()
        {
            List<ListaModel> itensTabela = new()
            {
                new ListaModel{Valor = (int)TabelaA.Nac_Exceto_Ind_Cod_3_a_5, Descricao = "0 - Nacional, exceto as indicadas nos códigos 3 a 5"},
                new ListaModel{Valor = (int)TabelaA.Est_Imp_Dir_Exceto_Ind_Cod_6, Descricao = "1 - Estrangeira - Importação direta, exceto a indicada no código 6"},
                new ListaModel{Valor = (int)TabelaA.Est_Adq_Merc_Interno_Exceto_Ind_Cod_7, Descricao = "2 - Estrangeira - Adquirida no mercado interno, exceto a indicada no código 7"},
                new ListaModel{Valor = (int)TabelaA.Nac_Merc_Ou_Bem_Com_Conteudo_Imp_Sup_40_Perc, Descricao = "3 - Nacional, mercadoria ou bem com Conteúdo de Importação superior a 40%"},
                new ListaModel{Valor = (int)TabelaA.Nac_Prod_Conf_Proc_Prod_Basicos_Legis_Ajustes, Descricao = "4 - Nacional, cuja produção tenha sido feita em conformidade com os processos produtivos básicos de que tratam as legislações citadas nos Ajustes"},
                new ListaModel{Valor = (int)TabelaA.Nac_Merc_Ou_Bem_Com_Conteudo_Imp_Inf_Ou_Igual_40_Perc, Descricao = "5 - Nacional, mercadoria ou bem com Conteúdo de Importação inferior ou igual a 40%"},
                new ListaModel{Valor = (int)TabelaA.Est_Imp_Dir_Sem_Sim_Nac_Lista_CAMEX, Descricao = "6 - Estrangeira - Importação direta, sem similar nacional, constante em lista da CAMEX"},
                new ListaModel{Valor = (int)TabelaA.Est_Adq_Merc_Interno_Sem_Sim_Nac_Lista_CAMEX, Descricao = "7 - Estrangeira - Adquirida no mercado interno, sem similar nacional, constante em lista da CAMEX"},
                new ListaModel{Valor = (int)TabelaA.Nac_Merc_Ou_Bem_Com_Conteudo_De_Imp_Sup_70_Perc, Descricao = "8 - Nacional, mercadoria ou bem com Conteúdo de Importação superior a 70%"}
            };
            return itensTabela;
        }
    }
}
