﻿using GAFNETBlazor.Services.Interfaces;
using System;

namespace GAFNETBlazor.Services
{
    public sealed class TimeZoneService : ITimeZoneService
    {
        private readonly string _timeZoneName;

        public TimeZoneService()
        {
            _timeZoneName = "E. South America Standard Time";
        }

        public DateTime GetLocalDateTime(DateTime dateTime)
        {
            var dtUTC = DateTime.SpecifyKind(dateTime, DateTimeKind.Utc);
            TimeZoneInfo tz = TimeZoneInfo.FindSystemTimeZoneById(_timeZoneName);
            return TimeZoneInfo.ConvertTimeFromUtc(dtUTC, tz);
        }
    }
}
