﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;

namespace GAFNETBlazor.Services
{
    public class TiposFaturamentoService : ITiposFaturamentoService
    {
        public List<ListaModel> Itens()
        {
            List<ListaModel> tiposFaturamento = new()
            {
                new ListaModel{Valor = (int)TipoFaturamento.PedidoDeVenda, Descricao = "Pedido de Venda"},
                new ListaModel{Valor = (int)TipoFaturamento.OrdemDeServico, Descricao = "Ordem de Serviço"},
                new ListaModel{Valor = (int)TipoFaturamento.Orcamento, Descricao = "Orçamento"},
                new ListaModel{Valor = (int)TipoFaturamento.NotaFiscal, Descricao = "Nota Fiscal"},
                new ListaModel{Valor = (int)TipoFaturamento.NotaCompra, Descricao = "Compra"},
                new ListaModel{Valor = (int)TipoFaturamento.PedidoDeCompra, Descricao = "Pedido de Compra"},
            };
            return tiposFaturamento;
        }

        public List<ListaModel> ItensSaida()
        {
            List<ListaModel> tiposFaturamento = new()
            {
                new ListaModel { Valor = (int)TipoFaturamento.PedidoDeVenda, Descricao = "Pedido de Venda" },
                new ListaModel { Valor = (int)TipoFaturamento.OrdemDeServico, Descricao = "Ordem de Serviço" },
                new ListaModel { Valor = (int)TipoFaturamento.Orcamento, Descricao = "Orçamento" },
                new ListaModel { Valor = (int)TipoFaturamento.NotaFiscal, Descricao = "Nota Fiscal" },
            };
            return tiposFaturamento;
        }

        public List<ListaModel> ItensEntrada()
        {
            List<ListaModel> tiposFaturamento = new()
            {
                new ListaModel { Valor = (int)TipoFaturamento.NotaCompra, Descricao = "Compra" },
                new ListaModel { Valor = (int)TipoFaturamento.PedidoDeCompra, Descricao = "Pedido de Compra" },
            };
            return tiposFaturamento;
        }
    }
}
