﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Services.Usuario
{
    public static class ItensCadastroService
    {
        public static Task<List<ItemPageModel>> Itens()
        {
            List<ItemPageModel> itens = new()
            {
                new ItemPageModel()
                {
                    Caption = "Pessoas",
                    Link = "/Usuario/Cadastros/PesquisaPessoa/true",
                    Icon = "fas fa-address-card fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.CadastroPessoa
                },
                new ItemPageModel()
                {
                    Caption = "Formulários",
                    Link = "/Usuario/Cadastros/Formulario",
                    Icon = "fas fa-book fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.CadastroConfiguracao
                },
                new ItemPageModel()
                {
                    Caption = "Históricos",
                    Link = "/Usuario/Cadastros/Historico",
                    Icon = "fas fa-list fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.CadastroConfiguracao
                },
                new ItemPageModel()
                {
                    Caption = "Alíquotas",
                    Link = "/Usuario/Cadastros/Aliquota",
                    Icon = "fas fa-percentage fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.CadastroFinanceiro
                },
                new ItemPageModel()
                {
                    Caption = "UF ICMS",
                    Link = "/Usuario/Cadastros/uficms",
                    Icon = "fas fa-chart-pie fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.CadastroFinanceiro
                },
                new ItemPageModel()
                {
                    Caption = "Condições de Pagamento",
                    Link = "/Usuario/Cadastros/CondicaoDePagamento",
                    Icon = "fas fa-solid fa-comments-dollar fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.CadastroFinanceiro
                },
                new ItemPageModel()
                {
                    Caption = "Centros de Custo",
                    Link = "/Usuario/Cadastros/CentroDeCusto",
                    Icon = "fas fa-solid fa-chart-pie fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.CadastroFinanceiro
                },
                new ItemPageModel()
                {
                    Caption = "Planos de Conta",
                    Link = "/Usuario/Cadastros/PlanoDeConta",
                    Icon = "fas fa-solid fa-network-wired fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.CadastroFinanceiro
                },
                new ItemPageModel()
                {
                    Caption = "Unidades",
                    Link = "/Usuario/Cadastros/UnidadeProduto",
                    Icon = "fab fa-buffer fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.CadastroProduto
                },
                new ItemPageModel()
                {
                    Caption = "Grupos",
                    Link = "/Usuario/Cadastros/GrupoProduto",
                    Icon = "fas fa-boxes fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.CadastroProduto
                },
                new ItemPageModel()
                {
                    Caption = "Subgrupos",
                    Link = "/Usuario/Cadastros/SubgrupoProduto",
                    Icon = "fas fa-code-branch fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.CadastroProduto
                },
                //new ItemPageModel()
                //{
                //    Caption = "Embalagens",
                //    Link = "/Usuario/Cadastros/Embalagem",
                //    Icon = "fas fa-box-open fa-3x",
                //    GrupoMenu = TipoGrupoMenuPage.CadastroProduto
                //},
                new ItemPageModel()
                {
                    Caption = "NCM's",
                    Link = "/Usuario/Cadastros/ClassificacaoFiscal",
                    Icon = "fas fa-clipboard-list fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.CadastroProduto
                },
                //new ItemPageModel()
                //{
                //    Caption = "Gêneros",
                //    Link = "/Usuario/Cadastros/GeneroProduto",
                //    Icon = "fas fa-suitcase-rolling fa-3x",
                //    GrupoMenu = TipoGrupoMenuPage.CadastroProduto
                //},
                new ItemPageModel()
                {
                    Caption = "Itens",
                    Link = "/Usuario/Cadastros/Produto",
                    Icon = "fas fa-cubes fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.CadastroProduto
                }
            };
            return Task.FromResult(itens);
        }
    }
}
