﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.Services.Usuario
{
    public static class ItensMovimentacaoService
    {
        public static Task<List<ItemPageModel>> Itens()
        {
            List<ItemPageModel> itens = new()
            {
                new ItemPageModel()
                {
                    Caption = "Faturamentos",
                    Link = "/Usuario/Movimentacoes/PesquisaFaturamento/true",
                    Icon = "fas fa-clipboard fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.MovimentacaoFaturamento
                },
                new ItemPageModel()
                {
                    Caption = "Compras",
                    Link = "/Usuario/Movimentacoes/PesquisaCompra/true",
                    Icon = "fas fa-cart-arrow-down fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.MovimentacaoFaturamento
                },
                new ItemPageModel()
                {
                    Caption = "Pagar/Receber",
                    Link = "/Usuario/Movimentacoes/PesquisaPagarReceber/true",
                    Icon = "fas fa-money-check-alt fa-3x",
                    GrupoMenu = TipoGrupoMenuPage.MovimentacaoFinanceiro
                },

            };
            return Task.FromResult(itens);
        }
    }
}
