﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.Stores.Interfaces;
using Microsoft.AspNetCore.Components;
using Microsoft.JSInterop;
using Syncfusion.Blazor.Navigations;
using System.Collections.Generic;

namespace GAFNETBlazor.Shared
{
    public partial class SideMenu : ComponentBase
    {
        [Inject]
        IJSRuntime JSRuntime { get; set; }
        [Inject]
        NavigationManager NavigationManager { get; set; }
        [Inject]
        ISideMenuService SideMenuService { get; set; }
        [Inject]
        ILoginStore LoginStore { get; set; }
        [Inject]
        ILogoutService LogoutService { get; set; }
        public bool SidebarToggle { get; set; } = true;
        public bool Logado => !string.IsNullOrEmpty(LoginStore.Token);
        public ExpandAction Expand = ExpandAction.Click;

        readonly Dictionary<string, object> HtmlAttribute = new()
        {
            { "class", "sidebar-treeview" }
        };

        public void Toggle()
        {
            SidebarToggle = !SidebarToggle;
        }
        private List<SideMenuItemModel> treedata;
        protected override void OnInitialized()
        {
            base.OnInitialized();
            treedata = SideMenuService.ItensMenu();
            LoginStore.OnChange += () =>
            {
                treedata = SideMenuService.ItensMenu();
                base.InvokeAsync(StateHasChanged);
            };
        }
        public void LogoutClicked()
        {
            LoginStore.RealizarLogout();
            LogoutService.ResetViewModels();
            NavigationManager.NavigateTo("/Login");
        }
    }
}
