﻿using GAFNETLibrary.Models;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Security.Claims;
using System.Threading.Tasks;

namespace GAFNETBlazor.Stores.Interfaces
{
    public interface ILoginStore
    {
        event Action OnChange;
        string Token { get; set; }
        string ErroLogin { get; set; }
        List<Claim> Claims { get; }
        bool EhAdmin { get; }
        bool EhRepresentante { get; }
        List<EmpresaModel> EmpresasUsuario { get; }
        EmpresaModel EmpresaLogada { get; set; }
        public string EMailLogado { get; set; }
        Task<HttpResponseMessage> RealizarLogin(LoginUserModel loginUserModel);
        bool LogadoEmEmpresa { get; }
        long? IdRepresentante { get; set; }

        void RealizarLogout();
    }
}
