﻿using GAFNETBlazor.Models;
using System;
using System.Collections.Generic;
using System.Linq;

namespace GAFNETBlazor.Utilitarios
{
    public static class UIExtensions
    {
        public static IEnumerable<ListaModel> EnumDataSource<T>(T valorPadrao) where T : struct
        {
            var dataSource = (from T value in Enum.GetValues(typeof(T)) select new ItemDataListaModel<T>(value))
                .OrderBy(x => x.Description)
                .AsEnumerable()
                .Select(l => new ListaModel
                {
                    Descricao = l.Description,
                    Valor = Convert.ToInt32(Enum.Parse(typeof(T), l.Content.ToString()) as Enum)
                });
                

            return dataSource;
        }
    }
}
