﻿using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Administrativo;
using System;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Administrativo.CadastroClaim
{
    public static class EnvioDadosCadastroClaimVM
    {
        public static async Task Enviar(ICadastroClaimVM viewModel, IClaimsService service)
        {
            viewModel.Enviando = true;
            var retorno = viewModel.Claim.Id == Guid.Empty ? await service.CriarClaim(viewModel.Claim) : await service.AlterarClaim(viewModel.Claim);
            viewModel.Mensagem = retorno.IsSuccessStatusCode ? string.Empty : await retorno.Content.ReadAsStringAsync();
            viewModel.MensagemResultadoEnvio = retorno.StatusCode == System.Net.HttpStatusCode.Created ? "Claim criada com sucesso" :
                retorno.StatusCode == System.Net.HttpStatusCode.OK ? "Claim alterada com sucesso" : viewModel.Mensagem;
            if (retorno.IsSuccessStatusCode)
            {
                LimpaTelaCadastroClaimVM.Limpar(viewModel);
            }
            viewModel.Enviando = false;
            viewModel.DlgVisible = true;
        }
    }
}
