﻿using FluentValidation;
using GAFNETBlazor.ViewModels.Interfaces.Administrativo;
using GAFNETBlazor.Models.Validations;
using System.Collections.Generic;

namespace GAFNETBlazor.ViewModels.Administrativo.CadastroClaim
{
    public static class ValidaCadastroClaimVM
    {
        public static bool Validar(ICadastroClaimVM viewModel)
        {
            ClaimModelValidator validator = new ();
            viewModel.ErrosValidacaoFormulario.Clear();
            List<string> erros = new List<string>();

            var results = validator.Validate(viewModel.Claim);
            if (!results.IsValid)
            {
                foreach (var erro in results.Errors)
                {
                    erros.Add(erro.ErrorMessage);
                }
                viewModel.ErrosValidacaoFormulario.AddRange(erros);
                return false;
            }
            return true;
        }
    }
}
