﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Administrativo.CadastroEmpresa
{
    public static class EnderecoPeloCEPCadastroEmpresa
    {
        public async static Task Endereco(CadastroEmpresaVM viewModel, string cep, IEnderecoPeloCEPService enderecoPeloCEPService)
        {
            if (string.IsNullOrEmpty(cep)) return;
            await viewModel.SpinnerPrincipal.ShowAsync();
            var retorno = await enderecoPeloCEPService.Endereco(cep);

            if (string.IsNullOrEmpty(retorno.MensagemErro))
            {
                var endereco = (EnderecoPessoaModel)retorno.Objeto;
                viewModel.Empresa.IdCidade            = endereco.IdCidade;
                viewModel.Empresa.Cidade              = endereco.Cidade;
                viewModel.Empresa.Logradouro          = endereco.Logradouro;
                viewModel.Empresa.NumeroEndereco      = endereco.Numero;
                viewModel.Empresa.Bairro              = endereco.Bairro;
                viewModel.Empresa.ComplementoEndereco = endereco.Complemento;
            }

            await viewModel.SpinnerPrincipal.HideAsync();

            viewModel.Mensagem = retorno.MensagemErro;
            if (!string.IsNullOrEmpty(viewModel.Mensagem))
            {
                viewModel.DlgVisible = true;
            }
            return;

        }
    }
}
