﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Administrativo;
using GAFNETLibrary.Models;
using Newtonsoft.Json;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Administrativo.CadastroRole
{
    public static class CarregaRolesCadastroRoleVM
    {
        public static async Task Carregar(ICadastroRoleVM viewModel, IRolesService service)
        {
            var retorno = await service.GetRoles();

            if (!retorno.IsSuccessStatusCode)
            {
                viewModel.Mensagem = await retorno.Content.ReadAsStringAsync();
            }
            else
            {
                viewModel.Mensagem = string.Empty;
                var dados = await retorno.Content.ReadAsStringAsync();
                viewModel.Roles = JsonConvert.DeserializeObject<List<RoleModel>>(dados);
            }
        }
    }
}
