﻿using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Administrativo;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Administrativo.CadastroRole
{
    public static class EnvioDadosCadastroRoleVM
    {
        public static async Task Enviar(ICadastroRoleVM viewModel, IRolesService service)
        {
            viewModel.Enviando = true;
            viewModel.Role.Usuarios?.Clear();
            var retorno = string.IsNullOrEmpty(viewModel.Role.Id) ? await service.CriarRole(viewModel.Role) : await service.AlterarRole(viewModel.Role);
            viewModel.Mensagem = retorno.IsSuccessStatusCode ? string.Empty : await retorno.Content.ReadAsStringAsync();
            viewModel.MensagemResultadoEnvio = retorno.StatusCode == System.Net.HttpStatusCode.Created ? "Role criada com sucesso" :
                retorno.StatusCode == System.Net.HttpStatusCode.OK ? "Role alterada com sucesso" : viewModel.Mensagem;
            if (retorno.IsSuccessStatusCode)
            {
                LimpaTelaCadastroRoleVM.Limpar(viewModel);
            }
            viewModel.Enviando = false;
            viewModel.DlgVisible = true;
        }
    }
}
