﻿using FluentValidation;
using GAFNETBlazor.ViewModels.Interfaces.Administrativo;
using GAFNETBlazor.Models.Validations;
using System.Collections.Generic;

namespace GAFNETBlazor.ViewModels.Administrativo.CadastroRole
{
    public static class ValidaCadastroRoleVM
    {
        public static bool Validar(ICadastroRoleVM viewModel)
        {
            var validator = new RoleModelValidator();
            viewModel?.ErrosValidacaoFormulario.Clear();
            List<string> erros = new List<string>();

            var results = validator.Validate(viewModel.Role);
            if (!results.IsValid)
            {
                foreach (var erro in results.Errors)
                {
                    erros.Add(erro.ErrorMessage);
                }
                viewModel.ErrosValidacaoFormulario.AddRange(erros);
                return false;
            }
            return true;
        }
    }
}
