﻿using GAFNETBlazor.Models;
using GAFNETLibrary.Models;
using System.Linq;

namespace GAFNETBlazor.ViewModels.Administrativo.CadastroUsuario
{
    public static class AddClaimCadastroUsuarioVM
    {
        public static void Add(CadastroUsuarioVM viewModel)
        {
            if (string.IsNullOrEmpty(viewModel.ClaimSelecionada))
            {
                return;
            }
            var claim = viewModel.UsuarioModel.Claims.FirstOrDefault(c => c.ClaimType == viewModel.ClaimSelecionada);
            if (claim != null)
            {
                return;
            }
            viewModel.UsuarioModel.Claims.Add(new UsuarioClaimModel
            {
                ClaimType = viewModel.ClaimSelecionada,
                ClaimValue = "True",
                IdUsuario = viewModel.UsuarioModel.Id
            });
            viewModel.ClaimUsuarioSelecionada = string.Empty;
        }
    }
}
