﻿using GAFNETLibrary.Models;
using System.Linq;

namespace GAFNETBlazor.ViewModels.Administrativo.CadastroUsuario
{
    public static class AddEmpresaCadastroUsuarioVM
    {
        public static void Add(CadastroUsuarioVM viewModel)
        {
            if (viewModel?.EmpresaSelecionada == null || viewModel.EmpresaSelecionada.Id == 0)
            {
                return;
            }
            var empresa = viewModel.UsuarioModel.Empresas.FirstOrDefault(c => c.IdEmpresa == viewModel.EmpresaSelecionada.Id);
            if (empresa != null)
            {
                viewModel.UsuarioModel.Empresas.Remove(empresa);
            }
            viewModel.UsuarioModel.Empresas.Add(new UsuarioEmpresaModel
            {
                Empresa = viewModel.EmpresaUsuarioSelecionada.Empresa,
                IdEmpresa = viewModel.EmpresaUsuarioSelecionada.IdEmpresa,
                IdUsuario = viewModel.UsuarioModel.Id,
                UsaGafmobile = viewModel.EmpresaUsuarioSelecionada.UsaGafmobile,
                ValorRepasseGafmobile = viewModel.EmpresaUsuarioSelecionada.ValorRepasseGafmobile
            });
        }
    }
}
