﻿using GAFNETLibrary.Models;
using System.Linq;

namespace GAFNETBlazor.ViewModels.Administrativo.CadastroUsuario
{
    public static class AddRoleCadastroUsuarioVM
    {
        public static void Add(CadastroUsuarioVM viewModel)
        {
            if (viewModel.RoleSelecionada == null || string.IsNullOrEmpty(viewModel.RoleSelecionada.Id))
            {
                return;
            }
            var role = viewModel.UsuarioModel.Roles.FirstOrDefault(c => c.IdRole == viewModel.RoleSelecionada.Id);
            if (role != null)
            {
                return;
            }
            viewModel.UsuarioModel.Roles.Add(new UsuarioRoleModel
            {
                IdRole = viewModel.RoleSelecionada.Id,
                IdUsuario = viewModel.UsuarioModel.Id,
                Role = new RoleModel { Id = viewModel.RoleSelecionada.Id, Nome = viewModel.RoleSelecionada.Nome }

            });
        }
    }
}
