﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using Newtonsoft.Json;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Administrativo.CadastroUsuario
{
    public static class CarregaClaimsCadastroUsuarioVM
    {
        public static async Task Carregar(CadastroUsuarioVM viewModel, IClaimsService service)
        {
            var retorno = await service.GetClaims();

            if (!retorno.IsSuccessStatusCode)
            {
                viewModel.Mensagem = await retorno.Content.ReadAsStringAsync();
            }
            else
            {
                viewModel.Mensagem = string.Empty;
                var dados = await retorno.Content.ReadAsStringAsync();
                viewModel.Claims = JsonConvert.DeserializeObject<List<ClaimModel>>(dados);
            }
        }
    }
}
