﻿using GAFNETBlazor.Services.Interfaces;
using GAFNETLibrary.Enums;
using GAFNETLibrary.Models;
using Newtonsoft.Json;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Administrativo.CadastroUsuario
{
    public static class CarregaEmpresasCadastroUsuarioVM
    {
        public static async Task Carregar(CadastroUsuarioVM viewModel, IEmpresasService service)
        {
            var retorno = await service.GetEmpresas(StatusAtivo.Ativos);
            if (!retorno.IsSuccessStatusCode)
            {
                viewModel.Mensagem = await retorno.Content.ReadAsStringAsync();
            }
            else
            {
                viewModel.Mensagem = string.Empty;
                var dados = await retorno.Content.ReadAsStringAsync();
                viewModel.Empresas = JsonConvert.DeserializeObject<List<EmpresaModel>>(dados);
            }
        }
    }
}
