﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETLibrary.Models;
using Newtonsoft.Json;
using System.Collections.Generic;
using System.Net.Http;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Administrativo.CadastroUsuario
{
    public static class CarregaRolesCadastroUsuarioVM
    {
        public static async Task Carregar(CadastroUsuarioVM viewModel, IRolesService service)
        {
            var retorno = await service.GetRoles();
            if (!retorno.IsSuccessStatusCode)
            {
                viewModel.Mensagem = await retorno.Content.ReadAsStringAsync();
            }
            else
            {
                viewModel.Mensagem = string.Empty;
                var dados = await retorno.Content.ReadAsStringAsync();
                viewModel.Roles = JsonConvert.DeserializeObject<List<RoleModel>>(dados);
            }
        }
    }
}
