﻿using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Administrativo;
using System;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Administrativo.CadastroUsuario
{
    public static class EnvioDadosCadastroUsuarioVM
    {
        public static async Task Enviar(ICadastroUsuarioVM viewModel, IUsuariosService service)
        {
            if (viewModel.UsuarioModel.Empresas != null)
            {
                foreach (var empresaUsuario in viewModel.UsuarioModel.Empresas)
                {
                    empresaUsuario.Empresa.Representante = null;
                }
            }

            viewModel.Enviando = true;
            viewModel.UsuarioModel.DataCadastro = string.IsNullOrEmpty(viewModel.UsuarioModel.Id) ? DateTime.Now : viewModel.UsuarioModel.DataCadastro; // se estiver inserindo, preenche a data de cadastro com a data do dia
            var retorno = string.IsNullOrEmpty(viewModel.UsuarioModel.Id) ? await service.CriarUsuario(viewModel.UsuarioModel) : await service.AlterarUsuario(viewModel.UsuarioModel);
            viewModel.Mensagem = retorno.IsSuccessStatusCode ? string.Empty : await retorno.Content.ReadAsStringAsync();
            viewModel.MensagemResultadoEnvio = retorno.StatusCode == System.Net.HttpStatusCode.Created ? "Usuário criado com sucesso" :
                retorno.StatusCode == System.Net.HttpStatusCode.OK ? "Usuário alterado com sucesso" : viewModel.Mensagem;
            if (retorno.IsSuccessStatusCode)
            {
                LimpaTelaCadastroUsuarioVM.Limpar(viewModel);
            }
            viewModel.Enviando = false;
            viewModel.DlgVisible = true;
        }
    }
}
