﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Administrativo;
using GAFNETLibrary.Models;
using Syncfusion.Blazor.Inputs;
using System.Net.Http;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Administrativo
{
    public class SetaSenhaUsuarioVM : UsuarioBaseVM, ISetaSenhaUsuarioVM
    {
        public SetaSenhaUsuarioVM(IUsuariosService usuariosService) : base(usuariosService)
        {
        }

        public SfTextBox SenhaTextBox { get; set; }

        new public void AoFecharDialogoGridUsuarios(object e)
        {
            Localizando = false;
            DialogoUsuariosVisible = false;
            SenhaTextBox.FocusAsync();
        }

        public override async void Enviar()
        {
            if (!DadosValidos())
            {
                return;
            }

            Enviando = true;

            string mensagemSucesso = "Senha alterada com sucesso";

            HttpResponseMessage retorno;
            AlteraSenhaUsuarioModel model = new()
            {
                EMailUsuario = UsuarioModel.Email,
                NovaSenha = UsuarioModel.PasswordHash
            };
            retorno = await _usuariosService.AlterarSenhaUsuario(model);

            if (!retorno.IsSuccessStatusCode)
            {
                Mensagem = await retorno.Content.ReadAsStringAsync();
                MensagemResultadoEnvio = Mensagem;
            }
            else
            {
                Mensagem = string.Empty;
                MensagemResultadoEnvio = mensagemSucesso;
                UsuarioModel = new UsuarioModel();
            }
            Enviando = false;
            DlgVisible = true;
        }

        public void AoCriarSenhaTextBox(object e)
        {
            SenhaTextBox.FocusAsync();
        }
        public void AoFecharDlg(object e)
        {
            DlgVisible = false;
            SenhaTextBox.FocusAsync();
        }

        public void LimparTela()
        {
            UsuarioModel = new UsuarioModel();
        }
    }
}
