﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces;
using GAFNETLibrary.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.Grids;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.CadastroClienteUsuarioMobile
{
    public class CadastroClienteUsuarioMobileVM : CadastroBaseVM, ICadastroClienteUsuarioMobileVM
    {
        private readonly IClienteUsuarioMobileService _clienteUsuarioMobileService;

        private bool _dlgUsuariosVisible;
        private bool _dlgCidadesVisible;
        private bool _dlgVendedoresVisible;

        public List<UsuarioModel> Usuarios { get; set; } = new List<UsuarioModel>();
        public List<PessoaModel> Vendedores { get; set; } = new List<PessoaModel>();
        public List<CidadeModel> Cidades { get; set; } = new List<CidadeModel>();
        public List<PessoaModel> Clientes { get; set; } = new List<PessoaModel>();
        public List<ClienteUsuarioMobileModel> ClientesUsuariosMobile => new();

        public CidadeModel CidadeSelecionada { get; set; }
        public PessoaModel VendedorSelecionado { get; set; }
        public UsuarioModel UsuarioSelecionado { get; set; }
        public ClienteUsuarioMobileModel ClienteUsuarioMobileSelecionado { get; set; }
        public bool DlgUsuariosVisible
        {
            get { return _dlgUsuariosVisible; }
            set
            {
                _dlgUsuariosVisible = value;
                AoMudarPropriedade(nameof(DlgUsuariosVisible));
            }
        }

        public bool DlgCidadesVisible
        {
            get { return _dlgCidadesVisible; }
            set
            {
                _dlgCidadesVisible = value;
                AoMudarPropriedade(nameof(DlgCidadesVisible));
            }
        }

        public bool DlgVendedoresVisible
        {
            get { return _dlgVendedoresVisible; }
            set
            {
                _dlgVendedoresVisible = value;
                AoMudarPropriedade(nameof(DlgVendedoresVisible));
            }
        }

        public bool CidadesBtnEnabled { get; set; } = true;
        public bool VendedoresBtnEnabled { get; set; } = true;

        private List<PessoaModel> clientesSelecionados;

        public List<PessoaModel> GetClientesSelecionados()
        {
            return clientesSelecionados;
        }

        public void SetClientesSelecionados(List<PessoaModel> value)
        {
            clientesSelecionados = value;
        }

        public CadastroClienteUsuarioMobileVM(IClienteUsuarioMobileService clienteUsuarioMobileService)
        {
            //_cidadesService = cidadesService;
            //_usuariosService = usuariosService;
            //_pessoasService = pessoasService;
            _clienteUsuarioMobileService = clienteUsuarioMobileService;
            _dlgUsuariosVisible = false;
            MensagemResultadoEnvio = " ";
        }
        public async void Enviar()
        {
            if (!DadosValidos())
            {
                return;
            }

            await EnvioDadosCadastroClienteUsuarioMobileVM.Enviar(this, _clienteUsuarioMobileService);
        }


        public void AoFecharDialogoEmpresas()
        {
            VendedoresBtnEnabled = true;
            DlgCidadesVisible = false;
        }

        public void AoFecharDlg(object e)
        {
            DlgVisible = false;
        }

        public void AoClicarNovoRegistroBtn()
        {
            LimparTela();
        }

        public void AoSelecionarVendedor(RowSelectEventArgs<PessoaModel> e)
        {
            throw new System.NotImplementedException();
        }

        public void AoSelecionarCidade(RowSelectEventArgs<CidadeModel> e)
        {
            throw new System.NotImplementedException();
        }

        public void AoSelecionarClientesParaInserir(RowSelectEventArgs<PessoaModel> e)
        {
            throw new System.NotImplementedException();
        }

        public void AoSelecionarClientesParaRetirar(RowSelectEventArgs<PessoaModel> e)
        {
            throw new System.NotImplementedException();
        }

        public void AoClicarVendedoresBtn(MouseEventArgs e)
        {
            throw new System.NotImplementedException();
        }

        public void AoClicarCidadesBtn(MouseEventArgs e)
        {
            throw new System.NotImplementedException();
        }

        public void AoClicarRetirarClienteBtn(MouseEventArgs e)
        {
            throw new System.NotImplementedException();
        }

        public void AoClicarInserirClienteBtn(MouseEventArgs e)
        {
            throw new System.NotImplementedException();
        }

        public void AoFecharDialogoVendedores(object e)
        {
            throw new System.NotImplementedException();
        }

        public void AoFecharDialogoCidades(object e)
        {
            throw new System.NotImplementedException();
        }

        public void AoClicarOkBtnDialogoVendedores(MouseEventArgs e)
        {
            throw new System.NotImplementedException();
        }

        public void AoClicarOkBtnDialogoCidades(MouseEventArgs e)
        {
            throw new System.NotImplementedException();
        }

        public bool DadosValidos()
        {
            throw new System.NotImplementedException();
        }

        public void LimparTela()
        {
            LimpaTelaCadastroClienteUsuarioMobileVM.Limpar(this);
        }
    }
}
