﻿using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces;
using System;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.CadastroClienteUsuarioMobile
{
    public static class EnvioDadosCadastroClienteUsuarioMobileVM
    {
        public static async Task Enviar(ICadastroClienteUsuarioMobileVM viewModel, IClienteUsuarioMobileService service)
        {
            viewModel.Enviando = true;
            var retorno = await service.CriarAtualizar(viewModel.ClientesUsuariosMobile);
            viewModel.Mensagem = retorno.IsSuccessStatusCode ? string.Empty : await retorno.Content.ReadAsStringAsync();
            viewModel.MensagemResultadoEnvio = "Clientes/usuários criados com sucesso";
            if (retorno.IsSuccessStatusCode)
            {
                LimpaTelaCadastroClienteUsuarioMobileVM.Limpar(viewModel);
            }
            viewModel.Enviando = false;
            viewModel.DlgVisible = true;
        }
    }
}
