﻿using GAFNETBlazor.Models;
using GAFNETLibrary.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;

namespace GAFNETBlazor.ViewModels.Interfaces.Administrativo
{
    public interface ICadastroEmpresaVM : ICadastroBaseVM
    {
        bool DlgRepresentantesVisible { get; set; }
        bool DlgEmpresasVisible { get; set; }
        bool DlgCidadesVisible { get; set; }
        bool RepresentantesBtnEnabled { get; set; }
        bool CidadesBtnEnabled { get; set; }
        EmpresaModel Empresa { get; set; }
        EmpresaModel EmpresaSelecionada { get; set; }
        List<EmpresaModel> Empresas { get; set; }
        List<RepresentanteModel> Representantes { get; set; }
        List<CidadeModel> Cidades { get; set; }
        RepresentanteModel Representante { get; set; }
        RepresentanteModel RepresentanteSelecionado { get; set; }
        CidadeModel CidadeSelecionada { get; set; }
        int? TipoRegimeTributacaoSelecionado { get; set; }
        List<ListaModel> TiposRegimeTributacao { get; }
        SfTextBox NomeTextBox { get; set; }
        SfMaskedTextBox CEPTextBox { get; set; }
        void AoSelecionarEmpresa(RowSelectEventArgs<EmpresaModel> e);
        void AoSelecionarRepresentante(RowSelectEventArgs<RepresentanteModel> e);
        void AoClicarLocalizarBtn(MouseEventArgs e);
        void AoClicarRepresentantesBtn(MouseEventArgs e);
        void AoClicarNovoRegistroBtn(MouseEventArgs e);
        void AoFecharDlgEmpresas(object e);
        void AoFecharDlgRepresentantes(object e);
        void AoCriarNomeTextBox(object e);
        void AoClicarOkBtnDlgEmpresas(MouseEventArgs e);
        void AoClicarOkBtnDlgRepresentantes(MouseEventArgs e);
        SfDialog Dlg { get; set; }
        public bool PesquisandoCidades { get; set; }
        void AoSelecionarCidade(RowSelectEventArgs<CidadeModel> e);
        void AoClicarCidadesBtnAsync(MouseEventArgs e);
        void AoFecharDlgCidades(object e);
        void AoClicarOkBtnDlgCidades(MouseEventArgs e);
        void CEPAoSairAsync(MaskBlurEventArgs args);

    }
}
