﻿using GAFNETBlazor.Models;
using GAFNETLibrary.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using System.Collections.Generic;

namespace GAFNETBlazor.ViewModels.Interfaces.Administrativo
{
    public interface ICadastroRepresentanteVM : ICadastroBaseVM
    {
        bool DlgUsuariosVisible { get; set; }
        bool DlgRepresentantesVisible { get; set; }
        bool UsuariosBtnEnabled { get; set; }
        RepresentanteModel Representante { get; set; }
        RepresentanteModel RepresentanteSelecionado { get; set; }
        List<RepresentanteModel> Representantes { get; set; }
        List<UsuarioModel> Usuarios { get; set; }
        UsuarioModel Usuario { get; set; }
        UsuarioModel UsuarioSelecionado { get; set; }
        SfTextBox NomeTextBox { get; set; }
        void AoSelecionarRepresentante(RowSelectEventArgs<RepresentanteModel> e);
        void AoSelecionarUsuario(RowSelectEventArgs<UsuarioModel> e);
        void AoClicarLocalizarBtn(MouseEventArgs e);
        void AoClicarUsuariosBtn(MouseEventArgs e);
        void AoClicarNovoRegistroBtn(MouseEventArgs e);
        void AoFecharDlgRepresentantes(object e);
        void AoFecharDlgUsuarios(object e);
        void AoCriarNomeTextBox(object e);
        void AoClicarOkBtnDlgRepresentantes(MouseEventArgs e);
        void AoClicarOkBtnDlgUsuarios(MouseEventArgs e);
        SfDialog Dlg { get; set; }
    }
}
