﻿using GAFNETBlazor.Models;
using GAFNETLibrary.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using System;
using System.Collections.Generic;
using ChangeEventArgs = Microsoft.AspNetCore.Components.ChangeEventArgs;

namespace GAFNETBlazor.ViewModels.Interfaces.Administrativo
{
    public interface ICadastroUsuarioVM : IUsuarioBaseVM
    {
        bool DlgClaimsVisible { get; set; }
        bool DlgEmpresasVisible { get; set; }
        bool DlgRolesVisible { get; set; }
        bool ClaimsBtnEnabled { get; set; }
        bool EmpresasBtnEnabled { get; set; }
        bool RolesBtnEnabled { get; set; }
        string ClaimUsuarioSelecionada { get; set; }
        RoleModel RoleUsuarioSelecionada { get; set; }
        UsuarioEmpresaModel EmpresaUsuarioSelecionada { get; set; }
        List<ClaimModel> Claims { get; set; }
        List<EmpresaModel> Empresas { get; set; }
        List<RoleModel> Roles { get; set; }
        SfTextBox NomeTextBox { get; set; }
        void AoSelecionarClaimUsuario(RowSelectEventArgs<UsuarioClaimModel> e);
        void AoSelecionarClaim(RowSelectEventArgs<ClaimModel> e);
        void AoSelecionarEmpresa(RowSelectEventArgs<EmpresaModel> e);
        void AoSelecionarRole(RowSelectEventArgs<RoleModel> e);
        void AoSelecionarEmpresaUsuario(RowSelectEventArgs<UsuarioEmpresaModel> e);
        void AoSelecionarRoleUsuario(RowSelectEventArgs<UsuarioRoleModel> e);
        void AoClicarClaimsBtn(MouseEventArgs e);
        void AoClicarEmpresasBtn(MouseEventArgs e);
        void AoClicarRolesBtn(MouseEventArgs e);
        void AoClicarRetirarClaimBtn(MouseEventArgs e);
        void AoClicarInserirClaimBtn(MouseEventArgs e);
        void AoClicarInserirEmpresaBtn(MouseEventArgs e);
        void AoClicarInserirRoleBtn(MouseEventArgs e);
        void AoClicarRetirarEmpresaBtn(MouseEventArgs e);
        void AoClicarRetirarRoleBtn(MouseEventArgs e);
        void AoClicarNovoRegistroBtn(MouseEventArgs e);
        void AoFecharDialogoClaims(object e);
        void AoFecharDialogoEmpresas(object e);
        void AoFecharDialogoRoles(object e);
        void AoCriarNomeTextBox(object e);
        void AoClicarOkBtnDialogoClaims(MouseEventArgs e);
        void AoClicarOkBtnDialogoEmpresas(MouseEventArgs e);
        void AoClicarOkBtnDialogoRoles(MouseEventArgs e);
        void AoSetarUsaGafMobile(ChangeEventArgs e);
    }
}
