﻿using GAFNETBlazor.Models;
using GAFNETLibrary.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.Grids;
using System.Collections.Generic;

namespace GAFNETBlazor.ViewModels.Interfaces
{
    public interface ICadastroClienteUsuarioMobileVM : ICadastroBaseVM
    {
        bool DlgVendedoresVisible { get; set; }
        bool DlgCidadesVisible { get; set; }
        bool VendedoresBtnEnabled { get; set; }
        bool CidadesBtnEnabled { get; set; }

        List<PessoaModel> GetClientesSelecionados();

        List<ClienteUsuarioMobileModel> ClientesUsuariosMobile { get; }
        PessoaModel VendedorSelecionado { get; set; }
        CidadeModel CidadeSelecionada { get; set; }
        List<PessoaModel> Vendedores { get; }
        List<CidadeModel> Cidades { get; }
        void AoSelecionarVendedor(RowSelectEventArgs<PessoaModel> e);
        void AoSelecionarCidade(RowSelectEventArgs<CidadeModel> e);
        void AoSelecionarClientesParaInserir(RowSelectEventArgs<PessoaModel> e);
        void AoSelecionarClientesParaRetirar(RowSelectEventArgs<PessoaModel> e);
        void AoClicarVendedoresBtn(MouseEventArgs e);
        void AoClicarCidadesBtn(MouseEventArgs e);
        void AoClicarRetirarClienteBtn(MouseEventArgs e);
        void AoClicarInserirClienteBtn(MouseEventArgs e);
        void AoFecharDialogoVendedores(object e);
        void AoFecharDialogoCidades(object e);
        void AoClicarOkBtnDialogoVendedores(MouseEventArgs e);
        void AoClicarOkBtnDialogoCidades(MouseEventArgs e);
    }
}
