﻿using GAFNETBlazor.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.DropDowns;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Interfaces.Usuario
{
    public interface ICadastroAliquotaVM : ICadastroBaseVM
    {
        AliquotaModel Aliquota { get; set; }
        AliquotaModel AliquotaSelecionada { get; set; }
        AliquotaInterestadualModel AliquotaInterestadual { get; set; }
        List<AliquotaModel> Aliquotas { get; set; }
        SfTextBox DescricaoTextBox { get; set; }
        SfDropDownList<string, string> UFDropDownList { get; set; }
        SfDialog Dlg { get; set; }
        List<ListaModel> ListaTabelaA { get; }
        List<ListaModel> ListaSitTrib { get; }
        List<ListaModel> ListaCSTPISCOFINS { get; }
        List<ListaModel> ListaCSTPISCOFINSEntrada { get; }

        List<ListaModel> ListaSitTribIPI { get; }
        List<ListaModel> ListaTipoReducaoICMS { get; }
        List<ListaModel> ListaTipoReducaoICMSST { get; }
        List<string> ListaUFs { get; }
        bool PodeAcessar { get; }
        bool DlgAliquotasVisible { get; set; }
        string UrlRedirecionamento { get; }
        void AoSelecionarAliquota(RowSelectEventArgs<AliquotaModel> e);
        void AoSelecionarAliquotaInterestadual(RowSelectEventArgs<AliquotaInterestadualModel> e);
        void AoClicarNovoRegistroBtn(MouseEventArgs e);
        void AoCriarDescricaoTextBox(object e);
        void AoClicarLocalizarBtn(MouseEventArgs e);
        void IdAoSairAsync();
        void AoFecharDlgAliquotas(object e);
        void AoClicarOkBtnDlgAliquotas(MouseEventArgs e);
        void AoClicarInserirAliqInterestBtnAsync(MouseEventArgs e);
        void AoClicarRetirarAliqInterestBtnAsync(MouseEventArgs e);
        void AoSelecionarTabelaAEstadual();
        void AoSelecionarSitTribEstadual();
        void AoSelecionarUFAliqInterest();
        void AoClicarSelecionarBtnGridAliquotas(CommandClickEventArgs<AliquotaModel> e);
    }
}
