﻿using GAFNETBlazor.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Interfaces.Usuario
{
    public interface ICadastroClassificacaoFiscalVM : ICadastroBaseVM
    {
        ClassificacaoFiscalModel ClassFiscal { get; set; }
        ClassificacaoFiscalModel ClassFiscalSelecionada { get; set; }
        UnidadeProdutoModel UnidadeTribSelecionada { get; set; }
        List<UnidadeProdutoModel> UnidadesTrib { get; set; }
        List<ClassificacaoFiscalModel> ClassFiscais { get; set; }
        SfNumericTextBox<int> NumeroTextBox { get; set; }
        SfTextBox DescricaoTextBox { get; set; }
        SfDialog Dlg { get; set; }
        bool PodeAcessar { get; }
        bool DlgClassFiscaisVisible { get; set; }
        bool DlgUnidadesTribVisible { get; set; }
        string UrlRedirecionamento { get; }
        bool UnidadesTribBtnEnabled { get; set; }
        bool PesquisandoUnidadesTrib { get; set; }
        void AoSelecionarUnidadeTrib(RowSelectEventArgs<UnidadeProdutoModel> e);
        void AoSelecionarClassFiscal(RowSelectEventArgs<ClassificacaoFiscalModel> e);
        void AoClicarNovoRegistroBtn(MouseEventArgs e);
        void AoCriarNumeroTextBox(object e);
        void AoClicarLocalizarBtn(MouseEventArgs e);
        void IdAoSairAsync();
        void IdUnidadeTribAoSairAsync();
        void AoFecharDlgUnidadesTrib(object e);
        void AoFecharDlgClassFiscais(object e);
        void AoClicarOkBtnDlgUnidadesTrib(MouseEventArgs e);
        void AoClicarOkBtnDlgClassFiscais(MouseEventArgs e);
        void AoClicarUnidadesTribBtnAsync(MouseEventArgs e);
        void AoClicarSelecionarBtnGridClassificacoesFiscais(CommandClickEventArgs<ClassificacaoFiscalModel> e);
        Task AoPressionarTeclaClassificacoesFiscaisGrid(KeyboardEventArgs args);
    }
}
