﻿using GAFNETBlazor.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Interfaces.Usuario
{
    public interface ICadastroHistoricoVM : ICadastroBaseVM
    {
        bool DlgHistoricosVisible { get; set; }
        bool DlgHistoricosEstornoVisible { get; set; }
        bool DlgPlanosDeContaVisible { get; set; }
        HistoricoModel Historico { get; set; }
        HistoricoModel HistoricoSelecionado { get; set; }
        HistoricoModel HistoricoEstornoSelecionado { get; set; }
        PlanoDeContaModel PlanoDeContaSelecionado { get; set; }
        List<HistoricoModel> Historicos { get; set; }
        List<PlanoDeContaModel> PlanosDeConta { get; set; }
        List<ListaModel> ListaEntradaSaida { get; }
        List<ListaModel> ListaTipoCTE { get; }
        List<ListaModel> ListaTipoNF { get; }
        List<ListaModel> ListaFinNFe { get; }
        List<ListaModel> ListaTabelaA { get; }
        List<ListaModel> ListaSitTrib { get; }
        List<ListaModel> ListaSitTribPISCOFINS { get; }
        List<ListaModel> ListaSitTribIPI { get; }

        SfTextBox DescricaoTextBox { get; set; }
        SfDialog Dlg { get; set; }
        bool PodeAcessar { get; }
        string UrlRedirecionamento { get; }
        bool HistoricosEstornoBtnEnabled { get; set; }
        bool PesquisandoHistoricosEstorno { get; set; }

        SfNumericTextBox<long?> IdHistoricoEstornoInput { get; set; }
        void AoSelecionarHistorico(RowSelectEventArgs<HistoricoModel> e);
        bool PlanosDeContaBtnEnabled { get; set; }
        bool PesquisandoPlanosDeConta { get; set; }
        SfNumericTextBox<long?> IdPlanoDeContaInput { get; set; }
        void AoClicarNovoRegistroBtn(MouseEventArgs e);
        void AoCriarDescricaoTextBox(object e);
        void AoClicarOkBtnDlgHistoricos(MouseEventArgs e);
        void AoFecharDlgHistoricos(object e);
        void AoClicarLocalizarBtn(MouseEventArgs e);
        void IdAoSairAsync();
        void AoSelecionarHistoricoEstorno(RowSelectEventArgs<HistoricoModel> e);
        void AoClicarHistoricosEstornoBtnAsync(MouseEventArgs e);
        void AoClicarOkBtnDlgHistoricosEstorno(MouseEventArgs e);
        void AoFecharDlgHistoricosEstorno(object e);
        void IdHistoricoEstornoAoSairAsync();
        Task AoClicarPlanosDeContaBtnAsync(MouseEventArgs e);
        void AoClicarOkBtnDlgPlanosDeConta(MouseEventArgs e);
        void AoFecharDlgPlanosDeContaEstorno(object e);
        void IdPlanoDeContaAoSairAsync();
        Task AoClicarSelecionarBtnGridHistoricos(CommandClickEventArgs<HistoricoModel> e);
        void AoClicarSelecionarBtnGridHistoricosEstorno(CommandClickEventArgs<HistoricoModel> e);
        Task AoPressionarTecla(KeyboardEventArgs args);
    }
}
