﻿using GAFNETBlazor.Models;
using GAFNETLibrary.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.DropDowns;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.Threading.Tasks;
using FocusEventArgs = Microsoft.AspNetCore.Components.Web.FocusEventArgs;

namespace GAFNETBlazor.ViewModels.Interfaces.Usuario
{
    public interface ICadastroPessoaVM : ICadastroBaseVM
    {
        bool DlgPessoasVisible { get; set; }
        bool DlgCidadesVisible { get; set; }
        bool DlgPaisesVisible { get; set; }
        bool DlgVendedoresVisible { get; set; }
        bool DlgTransportadorasVisible { get; set; }
        bool DlgProdutosVisible { get; set; }
        bool DlgHistoricosVisible { get; set; }
        bool DlgTiposDeOperacaoVisible { get; set; }
        bool DlgCondicoesDePagamentoVisible { get; set; }
        bool DlgCentrosDeCustoVisible { get; set; }
        bool DlgPlanosDeContaVisible { get; set; }
        bool CidadesBtnEnabled { get; set; }
        bool PaisesBtnEnabled { get; set; }
        bool VendedoresBtnEnabled { get; set; }
        bool TransportadorasBtnEnabled { get; set; }
        bool HistoricosBtnEnabled { get; set; }
        bool TiposDeOperacaoBtnEnabled { get; set; }
        bool CondicoesDePagamentoBtnEnabled { get; set; }
        bool CentrosDeCustoBtnEnabled { get; set; }
        bool PlanosDeContaBtnEnabled { get; set; }
        bool ProdutosBtnEnabled { get; set; }
        PessoaModel Pessoa { get; set; }
        EnderecoPessoaModel Endereco { get; set; }
        TelefonePessoaModel Telefone { get; set; }
        PessoaModel Transportadora { get; set; }
        VendedorPessoaModel VendedorPessoa { get; set; }
        TransportadoraPessoaModel TransportadoraPessoaSelecionada { get; set; }
        PessoaModel VendedorSelecionado { get; set; }
        PessoaModel TransportadoraSelecionada { get; set; }
        ProdutoModel ProdutoSelecionado { get; set; }
        HistoricoModel HistoricoSelecionado { get; set; }
        TipoDeOperacaoModel TipoDeOperacaoSelecionado { get; set; }
        CondicaoDePagamentoModel CondicaoDePagamentoSelecionada { get; set; }
        CentroDeCustoModel CentroDeCustoSelecionado { get; set; }
        PlanoDeContaModel PlanoDeContaSelecionado { get; set; }
        EMailPessoaModel EMail { get; set; }
        CidadeModel CidadeSelecionada { get; set; }
        PaisModel PaisSelecionado { get; set; }
        ProdutoPessoaModel ProdutoPessoa { get; set; }
        int? TipoRegimeTributacaoSelecionado { get; set; }
        int? IndicadorIESelecionado { get; set; }
        List<ProdutoModel> Produtos { get; set; }
        List<CidadeModel> Cidades { get; set; }
        List<PaisModel> Paises { get; set; }
        List<PessoaModel> Vendedores { get; set; }
        List<PessoaModel> Transportadoras { get; set; }
        List<HistoricoModel> Historicos { get; set; }
        List<TipoDeOperacaoModel> TiposDeOperacao { get; set; }
        List<CondicaoDePagamentoModel> CondicoesDePagamento { get; set; }
        List<CentroDeCustoModel> CentrosDeCusto { get; set; }
        List<PlanoDeContaModel> PlanosDeContas { get; set; }
        SfMaskedTextBox CNPJTextBox { get; set; }
        SfMaskedTextBox CEPTextBox { get; set; }
        SfMaskedTextBox TelefoneTextBox { get; set; }
        SfTextBox NomeTextBox { get; set; }
        public SfTextBox EMailTextBox { get; set; }
        SfDialog Dlg { get; set; }
        SfSpinner SpinnerEndereco { get; set; }
        SfSpinner SpinnerVendedor { get; set; }
        SfSpinner SpinnerTransportadora { get; set; }
        SfSpinner SpinnerProduto { get; set; }
        SfSpinner SpinnerFinanceiro { get; set; }
        SfSpinner SpinnerPlanoDeConta { get; set; }
        List<ListaModel> TiposPessoa { get; }
        SfDropDownList<int?, ListaModel> TipoPessoaDropDownList { get; set; }
        int? TipoPessoaSelecionado { get; set; }
        string MascaraCNPJCPF { get; }
        string CNPJCPFLbl { get; }
        bool PodeAcessar { get; }
        bool PesquisandoCidades { get; set; }
        bool PesquisandoProdutos { get; set; }
        bool PesquisandoVendedores { get; set; }
        bool PesquisandoTransportadoras { get; set; }
        bool PesquisandoPaises { get; set; }
        bool PesquisandoHistoricos { get; set; }
        bool PesquisandoTiposDeOperacao { get; set; }
        bool PesquisandoCondicoesDePagamento { get; set; }
        bool PesquisandoCentrosDeCusto { get; set; }
        bool PesquisandoPlanosDeConta { get; set; }
        string UrlRedirecionamento { get; }
        string NomePessoaLbl { get; set; }
        List<ListaModel> TiposRegimeTributacao { get; }
        List<ListaModel> IndicadoresIE { get; }
        SfNumericTextBox<long?> IdPlanoContaInput { get; set; }
        public SfNumericTextBox<long?> IdCondPgtoInput { get; set; }
        public SfNumericTextBox<long?> IdTipoDeOperacaoInput { get; set; }
        public SfNumericTextBox<long?> IdCentroCustoInput { get; set; }
        public SfNumericTextBox<decimal> ComissaoVendedorInput { get; set; }
        public SfNumericTextBox<long?> IdHistoricoInput { get; set; }
        public SfTextBox CodigoProdutoInput { get; set; }
        void AoSelecionarCidade(RowSelectEventArgs<CidadeModel> e);
        void AoSelecionarPais(RowSelectEventArgs<PaisModel> e);
        void AoSelecionarVendedorPessoa(RowSelectEventArgs<VendedorPessoaModel> e);
        void AoSelecionarTransportadoraPessoa(RowSelectEventArgs<TransportadoraPessoaModel> e);
        void AoSelecionarVendedor(RowSelectEventArgs<PessoaModel> e);
        void AoSelecionarTransportadora(RowSelectEventArgs<PessoaModel> e);
        void AoSelecionarHistorico(RowSelectEventArgs<HistoricoModel> e);
        void AoSelecionarTipoDeOperacao(RowSelectEventArgs<TipoDeOperacaoModel> e);
        void AoSelecionarCondicaoDePagamento(RowSelectEventArgs<CondicaoDePagamentoModel> e);
        void AoSelecionarCentroDeCusto(RowSelectEventArgs<CentroDeCustoModel> e);
        void AoSelecionarPlanoDeConta(RowSelectEventArgs<PlanoDeContaModel> e);
        void AoSelecionarProduto(RowSelectEventArgs<ProdutoModel> e);
        void AoClicarCidadesBtnAsync(MouseEventArgs e);
        void AoClicarPaisesBtnAsync(MouseEventArgs e);
        void AoClicarVendedoresBtnAsync(MouseEventArgs e);
        void AoClicarTransportadorasBtnAsync(MouseEventArgs e);
        void AoClicarProdutosBtnAsync(MouseEventArgs e);
        void AoClicarHistoricosBtnAsync(MouseEventArgs e);
        void AoClicarTiposDeOperacaoBtnAsync(MouseEventArgs e);
        void AoClicarCondicoesDePagamentoBtnAsync(MouseEventArgs e);
        void AoClicarCentrosDeCustoBtnAsync(MouseEventArgs e);
        void AoClicarPlanosDeContaBtnAsync(MouseEventArgs e);
        void AoClicarRetirarEnderecoBtnAsync(MouseEventArgs e);
        void AoClicarRetirarVendedorBtnAsync(MouseEventArgs e);
        void AoClicarRetirarTransportadoraBtnAsync(MouseEventArgs e);
        void AoClicarRetirarEMailBtnAsync(MouseEventArgs e);
        void AoClicarRetirarProdutoBtnAsync(MouseEventArgs e);
        void AoClicarRetirarTelefoneBtnAsync(MouseEventArgs e);
        Task AoClicarInserirEnderecoBtnAsync(MouseEventArgs e);
        Task AoClicarInserirVendedorBtnAsync(MouseEventArgs e);
        Task AoClicarInserirTransportadoraBtnAsync(MouseEventArgs e);
        void AoClicarInserirEMailBtnAsync(MouseEventArgs e);
        void AoClicarInserirProdutoBtnAsync(MouseEventArgs e);
        void AoClicarInserirTelefoneBtnAsync(MouseEventArgs e);
        Task AoClicarNovoRegistroBtn(MouseEventArgs e);
        void AoFecharDlgCidades(object e);
        void AoFecharDlgPaises(object e);
        void AoClicarOkBtnDlgCidades(MouseEventArgs e);
        void AoClicarOkBtnDlgHistoricos(MouseEventArgs e);
        void AoClicarOkBtnDlgTiposDeOperacao(MouseEventArgs e);
        void AoClicarOkBtnDlgCondicoesDePagamento(MouseEventArgs e);
        void AoClicarOkBtnDlgCentrosDeCusto(MouseEventArgs e);
        void AoClicarOkBtnDlgPlanosDeConta(MouseEventArgs e);
        void AoClicarOkBtnDlgPaises(MouseEventArgs e);
        Task AoFecharDlgPessoas(object e);
        void AoFecharDlgVendedores(object e);
        void AoFecharDlgTransportadoras(object e);
        void AoFecharDlgHistoricos(object e);
        void AoFecharDlgTiposDeOperacao(object e);
        void AoFecharDlgCondicoesDePagamento(object e);
        void AoFecharDlgCentrosDeCusto(object e);
        void AoFecharDlgPlanosDeConta(object e);
        void AoFecharDlgProdutos(object e);
        void AoClicarOkBtnDlgVendedores(MouseEventArgs e);
        void AoClicarOkBtnDlgTransportadoras(MouseEventArgs e);
        void AoClicarOkBtnDlgProdutos(MouseEventArgs e);
        void AoSelecionarEndereco(RowSelectEventArgs<EnderecoPessoaModel> e);
        void AoSelecionarTelefone(RowSelectEventArgs<TelefonePessoaModel> e);
        void AoSelecionarProdutoPessoa(RowSelectEventArgs<ProdutoPessoaModel> e);
        void AoSelecionarEMail(RowSelectEventArgs<EMailPessoaModel> e);
        void AoClicarLocalizarBtn(MouseEventArgs e);
        void CEPAoSairAsync(MaskBlurEventArgs args);
        void IdAoSairAsync();
        void IdVendedorAoSairAsync();
        void IdTransportadoraAoSairAsync();
        void IdHistoricoAoSairAsync();
        void IdTipoDeOperacaoAoSairAsync();
        void IdCondicaoDePagamentoAoSairAsync();
        void IdCentroDeCustoAoSairAsync();
        void IdPlanoDeContaAoSairAsync();
        void CNPJAoSairAsync(FocusEventArgs args);
        void CodigoProdutoAoSairAsync();
        //Task InicializarPessoasPesquisa();
        Task ExibirPessoa(long id);
        Task LimparTelaAsync();
    }
}
