﻿using GAFNETBlazor.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Interfaces.Usuario;

public interface ICadastroPlanoDeContaVM : ICadastroBaseVM
{
    PlanoDeContaModel PlanoDeConta { get; set; }
    PlanoDeContaModel PlanoDeContaSelecionado { get; set; }
    PlanoDeContaModel ContaContrapartidaSelecionada { get; set; }
    List<PlanoDeContaModel> PlanosDeConta { get; set; }
    SfTextBox DescricaoTextBox { get; set; }
    SfNumericTextBox<long?> IdContaContrapartidaInput { get; set; }
    bool PodeAcessar { get; }
    bool DlgPlanosDeContaVisible { get; set; }
    bool ContasContrapartidaBtnEnabled { get; set; }
    bool PesquisandoContasContrapartida { get; set; }
    string UrlRedirecionamento { get; }
    List<ListaModel> TiposPlanoDeConta { get; set; }
    List<ListaModel> TiposDebitoCreditoConta { get; set; }
    List<ListaModel> TiposDespesaPlanoDeConta { get; set; }
    bool DlgContasContrapartidaVisible { get; }

    void AoSelecionarPlanoDeConta(RowSelectEventArgs<PlanoDeContaModel> e);
    void AoClicarNovoRegistroBtn(MouseEventArgs e);
    void AoClicarLocalizarBtn(MouseEventArgs e);
    void IdAoSairAsync();
    void AoFecharDlgPlanosDeConta(object e);
    void AoFecharDlgContasContrapartida(object e);
    void AoClicarOkBtnDlgPlanosDeConta(MouseEventArgs e);
    void AoClicarOkBtnDlgContasContrapartida(MouseEventArgs e);
    void IdContaContrapartidaAoSairAsync();
    void AoClicarContasContrapartidaBtnAsync(MouseEventArgs e);
    void AoClicarSelecionarBtnGridPlanosDeConta(CommandClickEventArgs<PlanoDeContaModel> e);
    Task AoPressionarTeclaPlanosDeContaGrid(KeyboardEventArgs args);
    void AoClicarSelecionarBtnGridContasContrapartida(CommandClickEventArgs<PlanoDeContaModel> e);
    Task AoPressionarTeclaContasContrapartidaGrid(KeyboardEventArgs args);
}
