﻿using GAFNETBlazor.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Interfaces.Usuario
{
    public interface ICadastroProdutoVM : ICadastroBaseVM
    {
        bool DlgProdutosVisible { get; set; }
        bool DlgAliquotasVisible { get; set; }
        bool DlgEmbalagensVisible { get; set; }
        bool DlgGenerosVisible { get; set; }
        bool DlgClassFiscaisVisible { get; set; }
        bool DlgSubgruposVisible { get; set; }
        bool DlgUnidadesVisible { get; set; }
        bool AliquotasBtnEnabled { get; set; }
        bool EmbalagensBtnEnabled { get; set; }
        bool GenerosBtnEnabled { get; set; }
        bool ClassFiscaisBtnEnabled { get; set; }
        bool SubgruposBtnEnabled { get; set; }
        bool UnidadesBtnEnabled { get; set; }
        ProdutoModel Produto { get; set; }
        AliquotaModel AliquotaSelecionada { get; set; }
        ClassificacaoFiscalModel ClassFiscalSelecionada { get; set; }
        EmbalagemModel EmbalagemSelecionada { get; set; }
        GeneroProdutoModel GeneroSelecionado { get; set; }
        SubgrupoProdutoModel SubgrupoSelecionado { get; set; }
        UnidadeProdutoModel UnidadeSelecionada { get; set; }
        ProdutoModel ProdutoSelecionado { get; set; }
        ParametrizacaoModel Parametrizacao { get; set; }
        List<ProdutoModel> Produtos { get; set; }
        List<AliquotaModel> Aliquotas { get; set; }
        List<ClassificacaoFiscalModel> ClassFiscais { get; set; }
        List<EmbalagemModel> Embalagens { get; set; }
        List<GeneroProdutoModel> Generos { get; set; }
        List<SubgrupoProdutoModel> Subgrupos { get; set; }
        List<UnidadeProdutoModel> Unidades { get; set; }
        SfTextBox CodigoProdutoTextBox { get; set; }
        SfTextBox NomeTextBox { get; set; }
        SfDialog Dlg { get; set; }
        List<ListaModel> TiposProduto { get; }
        bool PodeAcessar { get; }
        public bool PesquisandoAliquotas { get; set; }
        public bool PesquisandoClassFiscais { get; set; }
        public bool PesquisandoEmbalagens { get; set; }
        public bool PesquisandoGeneros { get; set; }
        public bool PesquisandoSubgrupos { get; set; }
        public bool PesquisandoUnidades { get; set; }
        string UrlRedirecionamento { get; }
        SfNumericTextBox<long> IdAliquotaInput { get; set; }
        public SfNumericTextBox<long> IdClassFiscalInput { get; set; }
        public SfNumericTextBox<long?> IdEmbalagemInput { get; set; }
        public SfNumericTextBox<long?> IdGeneroInput { get; set; }
        public SfNumericTextBox<long> IdSubgrupoInput { get; set; }
        public SfNumericTextBox<long> IdUnidadeInput { get; set; }
        void AoSelecionarAliquota(RowSelectEventArgs<AliquotaModel> e);
        void AoSelecionarClassFiscal(RowSelectEventArgs<ClassificacaoFiscalModel> e);
        void AoSelecionarEmbalagem(RowSelectEventArgs<EmbalagemModel> e);
        void AoSelecionarGenero(RowSelectEventArgs<GeneroProdutoModel> e);
        void AoSelecionarSubgrupo(RowSelectEventArgs<SubgrupoProdutoModel> e);
        void AoSelecionarUnidade(RowSelectEventArgs<UnidadeProdutoModel> e);
        void AoSelecionarProduto(RowSelectEventArgs<ProdutoModel> e);
        void AoClicarAliquotasBtnAsync(MouseEventArgs e);
        void AoClicarClassFiscaisBtnAsync(MouseEventArgs e);
        void AoClicarEmbalagensBtnAsync(MouseEventArgs e);
        void AoClicarGenerosBtnAsync(MouseEventArgs e);
        void AoClicarSubgruposBtnAsync(MouseEventArgs e);
        void AoClicarUnidadesBtnAsync(MouseEventArgs e);
        void AoClicarRetirarMateriaPrimaBtnAsync(MouseEventArgs e);
        Task AoClicarInserirMateriaPrimaBtnAsync(MouseEventArgs e);
        void AoClicarNovoRegistroBtn(MouseEventArgs e);
        void AoFecharDlgAliquotas(object e);
        void AoFecharDlgClassFiscais(object e);
        void AoFecharDlgEmbalagens(object e);
        void AoFecharDlgGeneros(object e);
        void AoFecharDlgSubgrupos(object e);
        void AoFecharDlgUnidades(object e);
        void AoCriarNomeTextBox(object e);
        void AoCriarCodigoProdutoTextBox(object e);
        void AoClicarOkBtnDlgAliquotas(MouseEventArgs e);
        void AoClicarOkBtnDlgClassFiscais(MouseEventArgs e);
        void AoClicarOkBtnDlgEmbalagens(MouseEventArgs e);
        void AoClicarOkBtnDlgGeneros(MouseEventArgs e);
        void AoClicarOkBtnDlgSubgrupos(MouseEventArgs e);
        void AoClicarOkBtnDlgUnidades(MouseEventArgs e);
        void AoClicarOkBtnDlgProdutos(MouseEventArgs e);
        void AoFecharDlgProdutos(object e);
        void AoClicarLocalizarBtn(MouseEventArgs e);
        void IdAoSairAsync();
        void IdAliquotaAoSairAsync();
        void IdClassFiscalAoSairAsync();
        void IdEmbalagemAoSairAsync();
        void IdGeneroAoSairAsync();
        void IdSubgrupoAoSairAsync();
        void IdUnidadeAoSairAsync();
        void CodigoProdutoAoSairAsync();
        void AoClicarSelecionarBtnGridProdutos(CommandClickEventArgs<ProdutoModel> e);
        Task GetParametrizacoes();
        void NumeroClassFiscalAoSairAsync();
        void CodigoUnidadeAoSairAsync();
        void AoClicarSelecionarBtnGridNCMs(CommandClickEventArgs<ClassificacaoFiscalModel> e);
        void AoClicarSelecionarBtnGridUnidades(CommandClickEventArgs<UnidadeProdutoModel> e);
        void AoClicarSelecionarBtnGridAliquotas(CommandClickEventArgs<AliquotaModel> e);
        Task AoPressionarTeclaAliquotasGrid(KeyboardEventArgs args);
        Task AoPressionarTeclaClassificacoesFiscaisGrid(KeyboardEventArgs args);
        void AoClicarSelecionarBtnGridSubgrupos(CommandClickEventArgs<SubgrupoProdutoModel> e);
        Task AoPressionarTeclaSubgruposGrid(KeyboardEventArgs args);
        Task AoPressionarTeclaUnidadesGrid(KeyboardEventArgs args);
        Task AoPressionarTeclaProdutosGrid(KeyboardEventArgs args);

        List<SCANCNFModel> ListaSCANCNF { get; }
        List<SCANCNFModel> ListaSCANCEstoque { get; }
        SfNumericTextBox<decimal> VlrVendaInput { get; set; }
    }
}
