﻿using GAFNETBlazor.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;

namespace GAFNETBlazor.ViewModels.Interfaces.Usuario
{
    public interface ICadastroSubgrupoProdutoVM : ICadastroBaseVM
    {
        SubgrupoProdutoModel Subgrupo { get; set; }
        SubgrupoProdutoModel SubgrupoSelecionado { get; set; }
        GrupoProdutoModel GrupoSelecionado { get; set; }
        List<GrupoProdutoModel> Grupos { get; set; }
        List<SubgrupoProdutoModel> Subgrupos { get; set; }
        SfTextBox NomeTextBox { get; set; }
        SfDialog Dlg { get; set; }
        bool PodeAcessar { get; }
        bool DlgSubgruposVisible { get; set; }
        bool DlgGruposVisible { get; set; }
        string UrlRedirecionamento { get; }
        bool GruposBtnEnabled { get; set; }
        bool PesquisandoGrupos { get; set; }
        void AoSelecionarGrupo(RowSelectEventArgs<GrupoProdutoModel> e);
        void AoSelecionarSubgrupo(RowSelectEventArgs<SubgrupoProdutoModel> e);
        void AoClicarNovoRegistroBtn(MouseEventArgs e);
        void AoCriarNomeTextBox(object e);
        void AoClicarLocalizarBtn(MouseEventArgs e);
        void IdAoSairAsync();
        void IdGrupoAoSairAsync();
        void AoFecharDlgGrupos(object e);
        void AoFecharDlgSubgrupos(object e);
        void AoClicarOkBtnDlgGrupos(MouseEventArgs e);
        void AoClicarOkBtnDlgSubgrupos(MouseEventArgs e);
        void AoClicarGruposBtnAsync(MouseEventArgs e);
    }
}
