﻿using GAFNETBlazor.Models;
using GAFNETLibrary.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Spinner;
using System.ComponentModel;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Interfaces.Usuario
{
    public interface IDeParaCompraImportacaoXMLVM
    {
        bool TabularParaFatorConversao { get; set; }
        bool TabularParaCodigoProduto { get; set; }
        double IndiceLinha { get; set; }
        bool DlgProdutosVisible { get; set; }
        SfGrid<ProdutoFornecedorModel> ProdutoFornecedorGrid { get; set; }
        SfSpinner SpinnerGridProdutoFornecedor { get; set; }
        ProdutoFornecedorModel ProdutoFornecedorAtivo { get; set; }
        bool EditarAoEntrar { get; set; }
        ICompraVM CompraVM { get; set; }
        void AoClicarCommandBtnProdFornGrid(CommandClickEventArgs<ProdutoFornecedorModel> args);
        Task<bool> PodeSelecionarProdutoDePara(string codigo, string cdProdForn);
        Task AoClicarOkBtnDlgProdutos(MouseEventArgs e);
        void AoFecharDlgProdutos(object e);
        void AoClicarSelecionarBtnGridProdutos(CommandClickEventArgs<ProdutoModel> e);
        event PropertyChangedEventHandler PropertyChanged;
        void OnPropertyChanged(string propertyName);
        ResultadoModel DeParaCompleto();
        Task CodigoProdutoGridAoSairAsync(FocusOutEventArgs args);
        void AoSelecionarLinhaGrid(RowSelectEventArgs<ProdutoFornecedorModel> args);
        void AoComecarAcaoDeParaGrid(ActionEventArgs<ProdutoFornecedorModel> args);
        void AoSairFatorConversao(NumericBlurEventArgs<decimal> args);
    }
}
