﻿using GAFNETBlazor.Models;
using GAFNETLibrary.Enums;
using GAFNETLibrary.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.ComponentModel;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Interfaces.Usuario
{
    public interface IDevolucaoVM : IBaseVM
    {
        double IndiceLinha { get; set; }
        public SfNumericTextBox<long> IdFormularioInput { get; set; }
        public SfNumericTextBox<long> IdHistoricoInput { get; set; }
        SfGrid<ItemFaturamentoModel> ItensDevolucaoGrid { get; set; }
        bool HistoricosBtnEnabled { get; set; }
        bool FormulariosBtnEnabled { get; set; }
        bool DlgFormulariosVisible { get; set; }
        bool DlgHistoricosVisible { get; set; }
        bool PesquisandoHistoricos { get; set; }
        bool PesquisandoFormularios { get; set; }
        bool EditarAoEntrar { get; set; }
        TipoAcaoFaturamento TipoAcaoFaturamento { get; set; }
        string DescricaoOperacao { get; }
        bool DlgDevolucaoVisible { get; set; } 
        FormularioModel FormularioSelecionado { get; set; }
        FaturamentoModel FaturamentoEmDevolucao { get; set; }
        FaturamentoModel Faturamento { get; set; }

        List<FormularioModel> Formularios { get; set; }
        HistoricoModel HistoricoSelecionado { get; set; }
        List<HistoricoModel> Historicos { get; set; }

        Task CelulaSalva(CellSaveArgs<ItemFaturamentoModel> args);
        Task DataBound();
        ResultadoModel DevolucaoCompleta();
        void IdHistoricoAoSairAsync();
        void IdFormularioAoSairAsync();
        void AoClicarOkBtnDlgHistoricos(MouseEventArgs e);
        void AoFecharDlgHistoricos(object e);
        void AoClicarOkBtnDlgFormularios(MouseEventArgs e);
        void AoFecharDlgFormularios(object e);
        void AoSelecionarFormulario(RowSelectEventArgs<FormularioModel> e);
        void AoClicarFormulariosBtnAsync(MouseEventArgs e);
        void AoClicarHistoricosBtnAsync(MouseEventArgs e);
        void AoClicarDevolverCompletoBtnAsync(MouseEventArgs e);
        Task AoClicarSelecionarBtnGridHistoricos(CommandClickEventArgs<HistoricoModel> e);
        void AoSelecionarHistorico(RowSelectEventArgs<HistoricoModel> e);
        Task<ResultadoModel> PrepararFaturamentoParaDevolver();

    }
}
