﻿using GAFNETBlazor.Models;
using GAFNETLibrary.Enums;
using GAFNETLibrary.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.DropDowns;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.SplitButtons;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Interfaces.Usuario
{
    public interface IFaturamentoBaseVM : ICadastroBaseVM
    {
        bool DlgLogEnvioFaturamentoVisible { get; set; }
        string LogEnvioFaturamento { get; set; }
        bool DlgTransportadorasVisible { get; set; }
        bool DlgOcorrenciasVisible { get; set; }
        bool DlgProdutosVisible { get; set; }
        bool DlgHistoricosVisible { get; set; }
        bool DlgPessoasVisible { get; set; }
        bool DlgTiposDeOperacaoVisible { get; set; }
        bool DlgCondicoesDePagamentoVisible { get; set; }
        bool DlgCentrosDeCustoVisible { get; set; }
        bool DlgConfirmacaoEnvioVisible { get; set; }
        bool DlgConfirmacaoDuplicacaoVisible { get; set; }
        bool DlgFreteVisible { get; set; }
        bool TipoFaturamentoEnabled { get; set; }
        bool TransportadorasBtnEnabled { get; set; }
        bool HistoricosBtnEnabled { get; set; }
        bool TiposDeOperacaoBtnEnabled { get; set; }
        bool CondicoesDePagamentoBtnEnabled { get; set; }
        bool CentrosDeCustoBtnEnabled { get; set; }
        bool ProdutosBtnEnabled { get; set; }
        bool PessoasBtnEnabled { get; set; }
        bool NomeProdutoImputEnabled { get; }
        bool NomePessoaImputEnabled { get; }
        bool DescricaoHistoricoImputEnabled { get; }
        string CidadePrincipal { get; }
        FaturamentoModel Faturamento { get; set; }
        ItemFaturamentoModel ItemFaturamento { get; set; }
        PessoaModel TransportadoraSelecionada { get; set; }
        ProdutoModel ProdutoSelecionado { get; set; }
        HistoricoModel HistoricoSelecionado { get; set; }
        TipoDeOperacaoModel TipoDeOperacaoSelecionado { get; set; }
        CondicaoDePagamentoModel CondicaoDePagamentoSelecionada { get; set; }
        CentroDeCustoModel CentroDeCustoSelecionado { get; set; }
        PessoaModel PessoaSelecionada { get; set; }
        List<FaturamentoModel> Faturamentos { get; set; }
        List<PessoaModel> Pessoas { get; set; }
        List<ProdutoModel> Produtos { get; set; }
        List<PessoaModel> Transportadoras { get; set; }
        List<HistoricoModel> Historicos { get; set; }
        List<TipoDeOperacaoModel> TiposDeOperacao { get; set; }
        List<CondicaoDePagamentoModel> CondicoesDePagamento { get; set; }
        List<CentroDeCustoModel> CentrosDeCusto { get; set; }
        List<ListaModel> TiposFaturamento { get; set; }
        List<ListaModel> TiposFrete { get; }
        List<ListaModel> AcoesFaturamento { get; set; }
        List<OcorrenciaFaturamentoModel> Ocorrencias { get; set; }
        SfDialog Dlg { get; set; }
        string MascaraCNPJCPF { get; }
        string CNPJCPFLbl { get; }
        bool PodeAcessar { get; }
        bool PesquisandoProdutos { get; set; }
        bool PesquisandoTransportadoras { get; set; }
        bool PesquisandoHistoricos { get; set; }
        bool PesquisandoTiposDeOperacao { get; set; }
        bool PesquisandoCondicoesDePagamento { get; set; }
        bool PesquisandoCentrosDeCusto { get; set; }
        bool PesquisandoPessoas { get; set; }
        bool Calculando { get; set; }
        string UrlRedirecionamento { get; }
        string TextoDlgConfirmacao { get; set; }
        TipoAcaoFaturamento? AcaoFaturamento { get; set; }
        SfNumericTextBox<long> IdPessoaInput { get; set; }
        SfNumericTextBox<long> IdHistoricoInput { get; set; }
        SfNumericTextBox<long> IdCondPgtoInput { get; set; }
        SfNumericTextBox<long> IdTipoDeOperacaoInput { get; set; }
        SfNumericTextBox<long> IdCentroDeCustoInput { get; set; }
        SfNumericTextBox<long> IdTransportadoraInput { get; set; }
        SfNumericTextBox<decimal> QtdItemInput { get; set; }
        SfTextBox CodigoProdutoInput { get; set; }
        ParametrizacaoModel Parametrizacao { get; set; }

        void AoSelecionarTransportadora(RowSelectEventArgs<PessoaModel> e);
        void AoSelecionarHistorico(RowSelectEventArgs<HistoricoModel> e);
        void AoSelecionarTipoDeOperacao(RowSelectEventArgs<TipoDeOperacaoModel> e);
        void AoSelecionarCondicaoDePagamento(RowSelectEventArgs<CondicaoDePagamentoModel> e);
        void AoSelecionarCentroDeCusto(RowSelectEventArgs<CentroDeCustoModel> e);
        void AoSelecionarProduto(RowSelectEventArgs<ProdutoModel> e);
        void AoClicarTransportadorasBtnAsync(MouseEventArgs e);
        void AoClicarProdutosBtnAsync(MouseEventArgs e);
        void AoClicarHistoricosBtnAsync(MouseEventArgs e);
        void AoClicarTiposDeOperacaoBtnAsync(MouseEventArgs e);
        void AoClicarCondicoesDePagamentoBtnAsync(MouseEventArgs e);
        void AoClicarCentrosDeCustoBtnAsync(MouseEventArgs e);
        void AoClicarPessoasBtnAsync(MouseEventArgs e);
        Task AoClicarRetirarItemBtnAsync(MouseEventArgs e);
        Task AoClicarInserirItemBtnAsync(MouseEventArgs e);
        Task AoClicarNovoRegistroBtn(MouseEventArgs e);
        Task AoClicarSimBtnDlgConfirmacaoEnvio(MouseEventArgs e);
        void AoClicarNaoBtnDlgConfirmacaoEnvio(MouseEventArgs e);
        void AoClicarOKBtnDlgHistoricos(MouseEventArgs e);
        void AoClicarOKBtnDlgTiposDeOperacao(MouseEventArgs e);
        void AoClicarOKBtnDlgCondicoesDePagamento(MouseEventArgs e);
        void AoClicarOKBtnDlgCentrosDeCusto(MouseEventArgs e);
        void AoFecharDlgPessoas(object e);
        void AoFecharDlgTransportadoras(object e);
        void AoFecharDlgOcorrencias(object e);
        void AoFecharDlgHistoricos(object e);
        void AoFecharDlgTiposDeOperacao(object e);
        void AoFecharDlgCondicoesDePagamento(object e);
        void AoFecharDlgCentrosDeCusto(object e);
        void AoFecharDlgProdutos(object e);
        void AoClicarOKBtnDlgPessoas(MouseEventArgs e);
        void AoClicarSelecionarBtnGridPessoas(CommandClickEventArgs<PessoaModel> e);
        void AoClicarSelecionarBtnGridHistoricos(CommandClickEventArgs<HistoricoModel> e);
        void AoClicarSelecionarBtnGridCentrosDeCusto(CommandClickEventArgs<CentroDeCustoModel> e);
        void AoClicarSelecionarBtnGridCondPgto(CommandClickEventArgs<CondicaoDePagamentoModel> e);
        void AoClicarSelecionarBtnGridTipoDeOperacao(CommandClickEventArgs<TipoDeOperacaoModel> e);
        void AoClicarOKBtnDlgTransportadoras(MouseEventArgs e);
        void AoClicarOKBtnDlgOcorrencias(MouseEventArgs e);
        Task AoClicarOKBtnDlgProdutos(MouseEventArgs e);
        void AoClicarOKBtnDlgFrete(MouseEventArgs e);
        void AoSelecionarPessoa(RowSelectEventArgs<PessoaModel> e);
        void AoSelecionarItemFaturamento(RowSelectEventArgs<ItemFaturamentoModel> e);
        void AoClicarLocalizarBtn(MouseEventArgs e);
        void NumeroAoSairAsync();
        Task NomeProdutoAoSairAsync();
        Task DescricaoHistoricoAoSairAsync();
        Task NomePessoaAoSairAsync();
        void IdPessoaAoSairAsync();
        void IdTransportadoraAoSairAsync();
        void IdHistoricoAoSairAsync();
        void IdTipoDeOperacaoAoSairAsync();
        void IdCondicaoDePagamentoAoSairAsync();
        void IdCentroDeCustoAoSairAsync();
        void CodigoProdutoAoSairAsync();
        void VlrFreteAoSairAsync();
        void VlrSeguroAoSairAsync();
        void VlrOutDespAcessAoSairAsync();
        Task AoClicarSelecionarBtnGridProdutos(CommandClickEventArgs<ProdutoModel> e);
        Task<bool> AoSelecionarAcao(MenuEventArgs e);
        void AoMudarTipoDeFaturamento(ChangeEventArgs<int, ListaModel> args);

        Task AoClicarSimBtnDlgConfirmacaoDuplicacao(MouseEventArgs e);
        void AoClicarNaoBtnDlgConfirmacaoDuplicacao(MouseEventArgs e);

        Task AoClicarCommandBtnGridItemFaturamento(CommandClickEventArgs<ItemFaturamentoModel> e);
        Task AoPressionarTeclaProdutosGrid(KeyboardEventArgs args);
        Task AoPressionarTeclaPessoasGrid(KeyboardEventArgs args);
        Task AoPressionarTeclaHistoricosGrid(KeyboardEventArgs args);
        void AoFecharDlgLogEnvioFaturamento(object e);
        new Task LimparTela();
        Task GetParametrizacoes();
        Task AoPressionarTeclaTiposDeOperacaoGrid(KeyboardEventArgs args);
        Task AoPressionarTeclaCentrosDeCustoGrid(KeyboardEventArgs args);
        Task AoPressionarTeclaCondicoesDePagamentoGrid(KeyboardEventArgs args);
        Task AoPressionarTeclaTransportadorasGrid(KeyboardEventArgs args);
        void AoClicarSelecionarBtnGridTransportadoras(CommandClickEventArgs<PessoaModel> e);
    }
}
