﻿using GAFNETBlazor.Models;
using GAFNETLibrary.Enums;
using GAFNETLibrary.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Interfaces.Usuario
{
    public interface IFaturamentoVM : IFaturamentoBaseVM
    {
        bool DlgDevolucaoVisible { get; set; }
        bool DlgLogEnvioInutilizacaoVisible { get; set; }
        string LogEnvioInutilizacao { get; set; }
        string LogEnvioCancelamento { get; set; }
        bool DlgLogEnvioCancelamentoVisible { get; set; }
        bool DlgLogEnvioEstornoVisible { get; set; }
        string LogEnvioEstorno { get; set; }
        bool DlgMotivoEstornoVisible { get; set; }
        bool DlgConfirmacaoEnvioEMailNFeVisible { get; set; }
        bool DlgVendedoresVisible { get; set; }
        bool DlgInsercaoVendedoresVisible { get; set; }
        bool DlgFormulariosVisible { get; set; }
        bool DlgMotivoCancelamentoVisible { get; set; }
        bool DlgMotivoInutilizacaoVisible { get; set; }
        bool VendedoresBtnEnabled { get; set; }
        bool FormulariosBtnEnabled { get; set; }
        bool DlgConfirmacaoCancelamentoVisible { get; set; }
        bool DlgConfirmacaoInutilizacaoVisible { get; set; }
        FaturamentoModel FaturamentoEmDevolucao { get; set; }
        VendedorFaturamentoModel VendedorFaturamento { get; set; }
        PessoaModel VendedorSelecionado { get; set; }
        FormularioModel FormularioSelecionado { get; set; }
        List<PessoaModel> Vendedores { get; set; }
        List<FormularioModel> Formularios { get; set; }
        bool PesquisandoVendedores { get; set; }
        bool PesquisandoFormularios { get; set; }
        SfNumericTextBox<long> IdFormularioInput { get; set; }
        SfNumericTextBox<long> IdVendedorInput { get; set; }
        SfNumericTextBox<decimal> ComissaoVendedorInput { get; set; }
        //IDevolucaoVM DevolucaoVM { get; set; }
        void AoSelecionarVendedor(RowSelectEventArgs<PessoaModel> e);
        void AoSelecionarVendedorFaturamento(RowSelectEventArgs<VendedorFaturamentoModel> e);
        void AoSelecionarFormulario(RowSelectEventArgs<FormularioModel> e);
        void AoClicarVendedoresBtnAsync(MouseEventArgs e);
        void AoClicarFormulariosBtnAsync(MouseEventArgs e);
        Task AoClicarInserirVendedorBtnAsync(MouseEventArgs e);
        Task AoClicarRetirarVendedorBtnAsync(MouseEventArgs e);
        void AoClicarOKBtnDlgFormularios(MouseEventArgs e);
        void AoFecharDlgVendedores(object e);
        void AoFecharDlgInsercaoVendedores(object e);
        void AoFecharDlgFormularios(object e);
        void AoClicarOKBtnDlgVendedores(MouseEventArgs e);
        void IdVendedorAoSairAsync();
        void IdFormularioAoSairAsync();
        Task PreencherFormularioPadrao();
        void AoClicarVendedoresBtn();
        void AoClicarRetirarVendedorBtn();
        Task AoClicarSimBtnDlgConfirmacaoEnvioEMailNFe(MouseEventArgs e);
        void AoClicarNaoBtnDlgConfirmacaoEnvioEMailNFe(MouseEventArgs e);
        void AoClicarSimBtnDlgConfirmacaoCancelamento(MouseEventArgs e);
        void AoClicarNaoBtnDlgConfirmacaoCancelamento(MouseEventArgs e);
        void AoClicarOKBtnDlgMotivoCancelamento(MouseEventArgs e);
        void AoClicarOKBtnDlgMotivoEstorno(MouseEventArgs e);
        void AoClicarOKBtnDlgMotivoInutilizacao(MouseEventArgs e);
        void AoClicarSimBtnDlgConfirmacaoInutilizacao(MouseEventArgs e);
        void AoClicarNaoBtnDlgConfirmacaoInutilizacao(MouseEventArgs e);
        void AoFecharDlgDevolucao(object e);
        void AoClicarOKBtnDlgDevolucao(MouseEventArgs e);
        Task DevolverRetornarNota(TipoAcaoFaturamento tipoAcaoFaturamento);
        void AoClicarSelecionarBtnGridVendedores(CommandClickEventArgs<PessoaModel> e);
        Task AoPressionarTeclaVendedoresGrid(KeyboardEventArgs args);
    }
}
