﻿using GAFNETBlazor.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.DropDowns;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Interfaces.Usuario
{
    public interface IPagarReceberVM : ICadastroBaseVM
    {
        PagarReceberModel PagarReceber { get; set; }
        bool DlgPessoasVisible { get; set; }
        bool DlgTiposDeOperacaoVisible { get; set; }
        bool DlgCentrosDeCustoVisible { get; set; }
        bool DlgPlanosDeContaVisible { get; set; }
        bool DlgConfirmacaoEnvioVisible { get; set; }
        bool TiposDeOperacaoBtnEnabled { get; set; }
        bool PlanosDeContaBtnEnabled { get; set; }
        bool CentrosDeCustoBtnEnabled { get; set; }
        bool PessoasBtnEnabled { get; set; }
        List<ListaModel> TiposPagarReceber { get; set; }
        TipoDeOperacaoModel TipoDeOperacaoSelecionado { get; set; }
        CentroDeCustoModel CentroDeCustoSelecionado { get; set; }
        PessoaModel PessoaSelecionada { get; set; }
        PlanoDeContaModel PlanoDeConta { get; set; }
        PlanoDeContaModel ContaApropriacao { get; set; }
        CentroDeCustoModel CentroDeCusto { get; set; }
        TipoDeOperacaoModel TipoDeOperacao { get; set; }
        List<PagarReceberModel> ContasPagarReceber { get; set; }
        List<PessoaModel> Pessoas { get; set; }
        List<TipoDeOperacaoModel> TiposDeOperacao { get; set; }
        List<CentroDeCustoModel> CentrosDeCusto { get; set; }
        List<PlanoDeContaModel> PlanosDeConta { get; set; }
        bool PodeAcessar { get; }
        bool PesquisandoTiposDeOperacao { get; set; }
        bool PesquisandoCentrosDeCusto { get; set; }
        bool PesquisandoPessoas { get; set; }
        bool PesquisandoPlanosDeConta { get; set; }
        string UrlRedirecionamento { get; }
        string TextoDlgConfirmacao { get; set; }
        SfTextBox NDoctoInput { get; set; }
        SfNumericTextBox<long> IdPessoaInput { get; set; }
        SfNumericTextBox<long> IdTipoDeOperacaoInput { get; set; }
        SfNumericTextBox<long> IdCentroDeCustoInput { get; set; }
        DetalhamentoPagarReceberModel DetalhamentoPagarReceber { get; set; }
        SfNumericTextBox<long> IdPlanoDeContaInput { get; set; }
        SfNumericTextBox<long> IdContaApropriacaoInput { get; set; }
        SfGrid<ItemPagarReceberModel> ItensGrid { get; set; }
        ItemPagarReceberModel ItemPagarReceberSelecionado { get; set; }
        PlanoDeContaModel PlanoDeContaSelecionado { get; set; }
        PlanoDeContaModel ContaApropriacaoSelecionado { get; set; }
        bool PesquisandoContasApropriacao { get; set; }
        bool DlgContasApropriacaoVisible { get; set; }
        bool ContasApropriacaoBtnEnabled { get; set; }
        SfGrid<DetalhamentoPagarReceberModel> DetalhamentosGrid { get; set; }

        void AoSelecionarTipoDeOperacao(RowSelectEventArgs<TipoDeOperacaoModel> e);
        void AoSelecionarCentroDeCusto(RowSelectEventArgs<CentroDeCustoModel> e);
        void AoClicarTiposDeOperacaoBtnAsync(MouseEventArgs e);
        void AoClicarPlanosDeContaBtnAsync(MouseEventArgs e);
        void AoClicarContasApropriacaoBtnAsync(MouseEventArgs e);
        void AoClicarCentrosDeCustoBtnAsync(MouseEventArgs e);
        void AoClicarPessoasBtnAsync(MouseEventArgs e);
        Task AoClicarNovoRegistroBtn(MouseEventArgs e);
        Task AoClicarSimBtnDlgConfirmacaoEnvio(MouseEventArgs e);
        void AoClicarNaoBtnDlgConfirmacaoEnvio(MouseEventArgs e);
        void AoClicarOKBtnDlgTiposDeOperacao(MouseEventArgs e);
        void AoClicarOKBtnDlgCentrosDeCusto(MouseEventArgs e);
        void AoClicarGerarItensBtn(MouseEventArgs e);
        void AoFecharDlgPessoas(object e);
        void AoFecharDlgTiposDeOperacao(object e);
        void AoFecharDlgCentrosDeCusto(object e);
        void AoClicarOKBtnDlgPessoas(MouseEventArgs e);
        void AoClicarSelecionarBtnGridPessoas(CommandClickEventArgs<PessoaModel> e);
        void AoClicarSelecionarBtnGridCentrosDeCusto(CommandClickEventArgs<CentroDeCustoModel> e);
        void AoClicarSelecionarBtnGridTipoDeOperacao(CommandClickEventArgs<TipoDeOperacaoModel> e);
        void AoSelecionarPessoa(RowSelectEventArgs<PessoaModel> e);
        void AoSelecionarItemPagarReceber(RowSelectEventArgs<ItemPagarReceberModel> e);
        void AoSelecionarDetalhamentoPagarReceber(RowSelectEventArgs<DetalhamentoPagarReceberModel> e);
        void AoClicarLocalizarBtn(MouseEventArgs e);
        void NDoctoAoSairAsync();
        Task NomePessoaAoSairAsync();
        void IdPessoaAoSairAsync();
        void IdTipoDeOperacaoAoSairAsync();
        void IdCentroDeCustoAoSairAsync();
        void IdPlanoDeContaAoSairAsync();
        void AoMudarTipoPagarReceber(ChangeEventArgs<int, ListaModel> args);
        Task AoClicarCommandBtnGridItemPagarReceber(CommandClickEventArgs<ItemPagarReceberModel> e);
        Task AoClicarCommandBtnGridDetalhamentoPagarReceber(CommandClickEventArgs<DetalhamentoPagarReceberModel> e);
        Task AoPressionarTeclaPessoasGrid(KeyboardEventArgs args);
        new void LimparTela();
        Task AoPressionarTeclaTiposDeOperacaoGrid(KeyboardEventArgs args);
        Task AoPressionarTeclaCentrosDeCustoGrid(KeyboardEventArgs args);
        void IdContaApropriacaoAoSairAsync();
        void AoFecharDlgPlanosDeConta(object e);
        void AoClicarOkBtnDlgPlanosDeConta(MouseEventArgs e);
        void AoSelecionarPlanoDeConta(RowSelectEventArgs<PlanoDeContaModel> e);
        void AoClicarSelecionarBtnGridPlanosDeConta(CommandClickEventArgs<PlanoDeContaModel> e);
        Task AoPressionarTeclaPlanosDeContaGrid(KeyboardEventArgs args);
        void AoFecharDlgContasApropriacao(object e);
        void AoClicarOkBtnDlgContasApropriacao(MouseEventArgs e);
        void AoSelecionarContaApropriacao(RowSelectEventArgs<PlanoDeContaModel> e);
        void AoClicarSelecionarBtnGridContasApropriacao(CommandClickEventArgs<PlanoDeContaModel> e);
        Task AoPressionarTeclaContasApropriacaoGrid(KeyboardEventArgs args);
        void AoComecarAcaoItensGrid(ActionEventArgs<ItemPagarReceberModel> args);
        void AoComecarAcaoDetalhamentosGrid(ActionEventArgs<DetalhamentoPagarReceberModel> args);
        Task IdCentroDeCustoGridAoSairAsync(NumericBlurEventArgs<long> value);
        Task IdPlanoDeContaGridAoSairAsync(NumericBlurEventArgs<long> args);
        Task IdTipoDeOperacaoGridAoSairAsync(NumericBlurEventArgs<long> args);
    }
}
