﻿using GAFNETBlazor.Components;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.DropDowns;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Inputs;
using Syncfusion.Blazor.Popups;
using Syncfusion.Blazor.Spinner;
using System.Collections.Generic;
using System.ComponentModel;
using System.Threading.Tasks;
using Syncfusion.Blazor.SplitButtons;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Interfaces.Usuario
{
    public interface IPesquisaFaturamentoVM : IBaseVM
    {
        bool DlgDevolucaoVisible { get; set; }
        PesquisaFaturamentoModel PesquisaFaturamento { get; set; }
        IFaturamentoBaseVM VMChamador { get; set; }
        bool DlgOcorrenciasVisible { get; set; }
        List<OcorrenciaFaturamentoModel> Ocorrencias { get; set; }
        string LogEnvioCancelamento { get; set; }
        bool DlgLogEnvioCancelamentoVisible { get; set; }
        bool DlgConfirmacaoCancelamentoVisible { get; set; }
        bool DlgMotivoCancelamentoVisible { get; set; }
        string LogEnvioInutilizacao { get; set; }
        bool DlgLogEnvioInutilizacaoVisible { get; set; }
        bool DlgConfirmacaoInutilizacaoVisible { get; set; }
        bool DlgMotivoInutilizacaoVisible { get; set; }
        bool DlgLogEnvioEstornoVisible { get; set; }
        string LogEnvioEstorno { get; set; }
        bool DlgConfirmacaoEnvioEMailNFeVisible { get; set; }
        bool DlgHistoricosVisible { get; set; }
        bool DlgFormulariosVisible { get; set; }
        bool DlgTiposDeOperacaoVisible { get; set; }
        bool DlgCentrosDeCustoVisible { get; set; }
        bool DlgPlanosDeContaVisible { get; set; }
        bool DlgConfirmacaoDuplicacaoVisible { get; set; }
        bool HistoricosBtnEnabled { get; set; }
        bool FormulariosBtnEnabled { get; set; }
        bool TiposDeOperacaoBtnEnabled { get; set; }
        bool CentrosDeCustoBtnEnabled { get; set; }
        bool PlanosDeContaBtnEnabled { get; set; }
        bool PesquisarBtnEnabled { get; set; }
        bool DlgLogEnvioFaturamentoVisible { get; set; }
        string LogEnvioFaturamento { get; set; }
        bool DlgMotivoEstornoVisible { get; set; }
        HistoricoModel HistoricoSelecionado { get; set; }
        FormularioModel FormularioSelecionado { get; set; }
        TipoDeOperacaoModel TipoDeOperacaoSelecionado { get; set; }
        CentroDeCustoModel CentroDeCustoSelecionado { get; set; }
        PlanoDeContaModel PlanoDeContaSelecionado { get; set; }
        FaturamentoModel FaturamentoSelecionado { get; set; }
        List<FaturamentoModel> Faturamentos { get; set; }
        List<HistoricoModel> Historicos { get; set; }
        List<FormularioModel> Formularios { get; set; }
        List<TipoDeOperacaoModel> TiposDeOperacao { get; set; }
        List<CentroDeCustoModel> CentrosDeCusto { get; set; }
        List<PlanoDeContaModel> PlanosDeContas { get; set; }
        List<ListaModel> TiposFaturamento { get; set; }
        List<ListaModel> TiposPesquisaNome { get; }
        SfDialog Dlg { get; set; }
        bool PesquisandoHistoricos { get; set; }
        bool PesquisandoFormularios { get; set; }
        bool PesquisandoTiposDeOperacao { get; set; }
        bool PesquisandoCentrosDeCusto { get; set; }
        bool PesquisandoPlanosDeConta { get; set; }
        SfNumericTextBox<long> IdHistoricoInput { get; set; }
        SfNumericTextBox<long> IdPlanoDeContaInput { get; set; }
        SfNumericTextBox<long> IdFormularioInput { get; set; }
        SfNumericTextBox<long> IdTipoDeOperacaoInput { get; set; }
        SfNumericTextBox<long> IdCentroDeCustoInput { get; set; }
        List<ListaModel> AcoesFaturamentoGrid { get; set; }
        Task AoClicarSimBtnDlgConfirmacaoEnvioEMailNFe(MouseEventArgs e);
        void AoClicarNaoBtnDlgConfirmacaoEnvioEMailNFe(MouseEventArgs e);
        void AoSelecionarHistorico(RowSelectEventArgs<HistoricoModel> e);
        void AoSelecionarFormulario(RowSelectEventArgs<FormularioModel> e);
        void AoSelecionarTipoDeOperacao(RowSelectEventArgs<TipoDeOperacaoModel> e);
        void AoSelecionarCentroDeCusto(RowSelectEventArgs<CentroDeCustoModel> e);
        void AoSelecionarPlanoDeConta(RowSelectEventArgs<PlanoDeContaModel> e);
        void AoClicarHistoricosBtnAsync();
        void AoClicarLimparFiltrosBtnAsync(MouseEventArgs e);
        void AoClicarFormulariosBtnAsync(MouseEventArgs e);
        void AoClicarTiposDeOperacaoBtnAsync(MouseEventArgs e);
        void AoClicarCentrosDeCustoBtnAsync(MouseEventArgs e);
        void AoClicarPlanosDeContaBtnAsync(MouseEventArgs e);
        void AoClicarOkBtnDlgHistoricos(MouseEventArgs e);
        void AoClicarOkBtnDlgFormularios(MouseEventArgs e);
        void AoClicarOkBtnDlgTiposDeOperacao(MouseEventArgs e);

        void AoClicarOkBtnDlgCentrosDeCusto(MouseEventArgs e);
        void AoClicarOkBtnDlgPlanosDeConta(MouseEventArgs e);
        void AoFecharDlgHistoricos(object e);
        void AoFecharDlgFormularios(object e);
        void AoFecharDlgTiposDeOperacao(object e);
        void AoFecharDlgCentrosDeCusto(object e);
        void AoFecharDlgPlanosDeConta(object e);
        void AoSelecionarFaturamento(RowSelectEventArgs<FaturamentoModel> e);
        Task AoSelecionarAcaoGrid(MenuEventArgs e);
        void IdHistoricoAoSairAsync();
        void IdFormularioAoSairAsync();
        void IdTipoDeOperacaoAoSairAsync();
        void IdCentroDeCustoAoSairAsync();
        void IdPlanoDeContaAoSairAsync();
        void AoClicarPesquisarBtn(MouseEventArgs e);

        Task AoClicarSelecionarBtnGridFaturamentos(MouseEventArgs e);
        bool Pesquisando { get; set; }
        Task Pesquisar();
        Task AoPressionarTeclaFaturamentosGrid(KeyboardEventArgs args);
        void AoMudarTipoFaturamento(ChangeEventArgs<int, ListaModel> args);
        Task AoClicarSimBtnDlgConfirmacaoDuplicacao(MouseEventArgs e);
        void AoFecharDlgOcorrencias(object e);
        void AoClicarNaoBtnDlgConfirmacaoDuplicacao(MouseEventArgs e);
        void AoClicarOkBtnDlgOcorrencias(MouseEventArgs e);
        void AoClicarNaoBtnDlgConfirmacaoCancelamento(MouseEventArgs e);
        void AoClicarSimBtnDlgConfirmacaoCancelamento(MouseEventArgs e);
        Task AoClicarOKBtnDlgMotivoCancelamento(MouseEventArgs e);
        Task AoClicarOKBtnDlgMotivoInutilizacao(MouseEventArgs e);
        void AoClicarSimBtnDlgConfirmacaoInutilizacao(MouseEventArgs e);
        void AoClicarNaoBtnDlgConfirmacaoInutilizacao(MouseEventArgs e);
        Task AoClicarOKBtnDlgMotivoEstorno(MouseEventArgs e);
        void AoFecharDlgDevolucao(object e);
        void AoClicarOkBtnDlgDevolucao(MouseEventArgs e);
    }
}
