﻿using GAFNETBlazor.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.DropDowns;
using Syncfusion.Blazor.Grids;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Interfaces.Usuario
{
    public interface IPesquisaPagarReceberVM : IBaseVM
    {
        PesquisaPagarReceberModel Parametros { get; set; }
        bool PesquisarBtnEnabled { get; set; }
        List<PagarReceberModel> ContasPagarReceber { get; set; }
        List<ListaModel> TiposPagarReceber { get; set; }
        List<ListaModel> TiposPesquisaNome { get; }

        event Action<long> OnNavegarParaPagarReceberVM;

        void AoClicarLimparFiltrosBtnAsync(MouseEventArgs e);
        void AoSelecionarPagarReceber(RowSelectEventArgs<PagarReceberModel> e);
        void AoClicarPesquisarBtn(MouseEventArgs e);

        Task AoClicarSelecionarBtnGridPagarReceber(MouseEventArgs e);
        bool Pesquisando { get; set; }
        Task Pesquisar();
        Task AoPressionarTeclaPagarReceberGrid(KeyboardEventArgs args);
        void AoMudarTipoPagarReceber(ChangeEventArgs<int, ListaModel> args);

    }
}
