﻿using GAFNETBlazor.Models;
using Microsoft.AspNetCore.Components.Web;
using Syncfusion.Blazor.Grids;
using Syncfusion.Blazor.Popups;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Interfaces.Usuario
{
    public interface IPesquisaPessoaVM : IBaseVM
    {
        PesquisaPessoaModel PesquisaPessoa { get; set; }
        List<ListaModel> TiposPessoa { get; set; }
        List<ListaModel> TiposPesquisaNome { get; }
        SfDialog Dlg { get; set; }
        void AoClicarLimparFiltrosBtnAsync(MouseEventArgs e);
        void AoClicarNovoBtn(MouseEventArgs e);
        void AoSelecionarPessoa(RowSelectEventArgs<PessoaModel> e);
        void AoClicarPesquisarBtn(MouseEventArgs e);

        void AoClicarSelecionarBtnGridPessoas(CommandClickEventArgs<PessoaModel> e);
        bool Pesquisando { get; set; }
        bool PesquisarBtnEnabled { get; set; }
        List<PessoaModel> Pessoas { get; set; }
        PessoaModel PessoaSelecionada { get; set; }

        Task Pesquisar();
        void AoPressionarTeclaPessoasGrid(KeyboardEventArgs args);

        event Action<PessoaModel> OnSelecionarBtnClick;
        event Action<KeyboardEventArgs> OnPressionarTecla;
        event Action<string> OnNovoBtnClick;
        event Action<PessoaModel> OnSelecionarPessoa;
    }
}
