﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.ObjectModel;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroAliquota
{
    public static class AliquotaByIdCadastroAliquota
    {
        public static async Task<AliquotaModel> Get(CadastroAliquotaVM viewModel, IAliquotasService aliquotasService, long id, StatusAtivo statusAtividade)
        {
            RespostaAPIModel resposta;
            AliquotaModel aliquota = new AliquotaModel();
            try
            {
                viewModel.Localizando = true;
                await viewModel.SpinnerPrincipal.ShowAsync();
                LimpaTelaCadastroAliquota.Limpar(viewModel, false);

                resposta = await aliquotasService.GetByIdAsync(URIsAliquotas.GetAsync, id, statusAtividade);

                if (!resposta.Sucesso)
                {
                    viewModel.Mensagem = resposta.MensagemErro;
                    viewModel.DlgVisible = true;
                }
                else
                {
                    aliquota = (AliquotaModel)resposta.Objeto;
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.Localizando = false;
            }
            aliquota.AliquotasInterestaduais = aliquota.AliquotasInterestaduais ?? new ObservableCollection<AliquotaInterestadualModel>();
            
            return aliquota;
        }
    }
}
