﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroAliquota
{
    public static class EnvioDadosCadastroAliquota
    {
        public static async Task Enviar(CadastroAliquotaVM viewModel, IAliquotasService service)
        {
            viewModel.Enviando = true;
            var retorno = viewModel.Aliquota.Id == 0 ? await service.PostAsync(viewModel.Aliquota) : await service.PutAsync(viewModel.Aliquota);
            viewModel.Mensagem = retorno.Sucesso ? string.Empty : retorno.MensagemErro;
            viewModel.MensagemResultadoEnvio = retorno.Status == System.Net.HttpStatusCode.Created ? "Alíquota criada com sucesso" :
                retorno.Status == System.Net.HttpStatusCode.OK ? "Alíquota alterada com sucesso" : viewModel.Mensagem;
            viewModel.TipoToast = retorno.Sucesso ? TipoToast.Sucesso : TipoToast.Erro;

            if (retorno.Sucesso)
            {
                LimpaTelaCadastroAliquota.Limpar(viewModel, true);
                viewModel.Mensagem = viewModel.MensagemResultadoEnvio;
            }
            viewModel.Enviando = false;
            await viewModel.MeuToast.Show();
        }
    }
}
