﻿using GAFNETBlazor.Constantes;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using GAFNETLibrary.Enums;
using GAFNETLibrary.Models;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroCentroDeCusto;

public static class CentroDeCustoByIdCadastroCentroDeCusto
{
    public static async Task<CentroDeCustoModel> Get(ICadastroCentroDeCustoVM viewModel, ICentrosDeCustoService centrosDeCustoService, long id, StatusAtivo statusAtividade)
    {
        RespostaAPIModel resposta;
        CentroDeCustoModel centroDeCusto = new() { Ativo = true };
        try
        {
            viewModel.Localizando = true;
            await viewModel.SpinnerPrincipal.ShowAsync();
            LimpaTelaCadastroCentroDeCusto.Limpar(viewModel);

            resposta = await centrosDeCustoService.GetByIdAsync(URIsCentrosDeCusto.GetAsync, id, statusAtividade);

            if (!resposta.Sucesso)
            {
                await viewModel.ExibirMensagemToast(resposta.MensagemErro, TipoToast.Aviso);
                return centroDeCusto;
            }

            centroDeCusto = (CentroDeCustoModel)resposta.Objeto;
            return centroDeCusto;
        }
        finally
        {
            await viewModel.SpinnerPrincipal.HideAsync();
            viewModel.Localizando = false;
        }

    }
}
