﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroCentroDeCusto
{
    public static class EnvioDadosCadastroCentroDeCusto
    {
        public static async Task Enviar(CadastroCentroDeCustoVM viewModel, ICentrosDeCustoService service)
        {
            viewModel.Enviando = true;
            var retorno = viewModel.CentroDeCusto.Id == 0 ? await service.PostAsync(viewModel.CentroDeCusto) : await service.PutAsync(viewModel.CentroDeCusto);
            viewModel.Mensagem = retorno.Sucesso ? string.Empty : retorno.MensagemErro;
            viewModel.MensagemResultadoEnvio = retorno.Status == System.Net.HttpStatusCode.Created ? "Centro De Custo criado com sucesso" :
                retorno.Status == System.Net.HttpStatusCode.OK ? "Centro De Custo alterado com sucesso" : viewModel.Mensagem;
            viewModel.TipoToast = retorno.Sucesso ? TipoToast.Sucesso : TipoToast.Erro;
            if (retorno.Sucesso)
            {
                LimpaTelaCadastroCentroDeCusto.Limpar(viewModel);
                viewModel.Mensagem = viewModel.MensagemResultadoEnvio;
            }
            viewModel.Enviando = false;
            await viewModel.MeuToast.Show();
        }
    }
}
