﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroClassificacaoFiscal
{
    public static class ClassFiscalByIdCadastroClassificacaoFiscal
    {
        public static async Task<ClassificacaoFiscalModel> Get(CadastroClassificacaoFiscalVM viewModel, IClassificacoesFiscaisService classFiscaisService, long id, StatusAtivo statusAtividade)
        {
            RespostaAPIModel resposta;
            ClassificacaoFiscalModel classFiscal = new() { UnidadeTributaria = new UnidadeProdutoModel()};
            try
            {
                viewModel.Localizando = true;
                await viewModel.SpinnerPrincipal.ShowAsync();
                LimpaTelaCadastroClassificacaoFiscal.Limpar(viewModel);

                resposta = await classFiscaisService.GetByIdAsync(URIsClassificacoesFiscais.GetAsync, id, statusAtividade);

                if (!resposta.Sucesso)
                {
                    viewModel.Mensagem = resposta.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    classFiscal = (ClassificacaoFiscalModel)resposta.Objeto;
                    classFiscal.UnidadeTributaria ??= new UnidadeProdutoModel();
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.Localizando = false;
            }

            return classFiscal;
        }
    }
}
