﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroClassificacaoFiscal
{
    public static class EnvioDadosCadastroClassificacaoFiscal
    {
        public static async Task Enviar(CadastroClassificacaoFiscalVM viewModel, IClassificacoesFiscaisService service)
        {
            viewModel.Enviando = true;
            var retorno = viewModel.ClassFiscal.Id == 0 ? await service.PostAsync(viewModel.ClassFiscal) : await service.PutAsync(viewModel.ClassFiscal);
            viewModel.Mensagem = retorno.Sucesso ? string.Empty : retorno.MensagemErro;
            viewModel.MensagemResultadoEnvio = retorno.Status == System.Net.HttpStatusCode.Created ? "NCM criado com sucesso" :
                retorno.Status == System.Net.HttpStatusCode.OK ? "NCM alterado com sucesso" : viewModel.Mensagem;
            viewModel.TipoToast = retorno.Sucesso ? TipoToast.Sucesso : TipoToast.Erro;
            if (retorno.Sucesso)
            {
                LimpaTelaCadastroClassificacaoFiscal.Limpar(viewModel);
                viewModel.Mensagem = viewModel.MensagemResultadoEnvio;
            }
            viewModel.Enviando = false;
            await viewModel.MeuToast.Show();
        }
    }
}
