﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroClassificacaoFiscal
{
    public static class LocalizaUnidadeTribCadastroClassFiscal
    {
        public static async Task LocalizarAsync(CadastroClassificacaoFiscalVM viewModel, IUnidadesProdutoService service)
        {
            if (viewModel != null)
            {
                viewModel.UnidadesTribBtnEnabled  = false;
                viewModel.PesquisandoUnidadesTrib = true;
                var retorno = await service?.GetAsync(URIsClassificacoesFiscais.GetUnidadesAsync, StatusAtivo.Ativos);
                viewModel.PesquisandoUnidadesTrib = false;
                viewModel.UnidadesTribBtnEnabled = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.DlgVisible = true;
                }
                else
                {
                    viewModel.UnidadesTrib = (List<UnidadeProdutoModel>)retorno.Objeto;
                    viewModel.DlgUnidadesTribVisible = true;
                }
            }
        }
    }
}
