﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroClassificacaoFiscal
{
    public static class UnidadeTribByIdCadastroClassificacaoFiscal
    {
        public static async Task<UnidadeProdutoModel> Get(CadastroClassificacaoFiscalVM viewModel, IUnidadesProdutoService unidadeService, long id, StatusAtivo statusAtividade)
        {
            RespostaAPIModel resposta;
            UnidadeProdutoModel unidade = new();
            try
            {
                viewModel.PesquisandoUnidadesTrib = true;
                await viewModel.SpinnerPrincipal.ShowAsync();

                resposta = await unidadeService.GetByIdAsync(URIsClassificacoesFiscais.GetUnidadesAsync, id, statusAtividade);

                if (!resposta.Sucesso)
                {
                    viewModel.Mensagem = resposta.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    unidade = (UnidadeProdutoModel)resposta.Objeto;
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.PesquisandoUnidadesTrib = false;
            }

            return unidade;
        }
    }
}
