﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroCondicaoDePagamento
{
    public static class CondPgtoByIdCadastroCondPgto
    {
        public static async Task<CondicaoDePagamentoModel> Get(ICadastroCondicaoDePagamentoVM viewModel, ICondicoesDePagamentoService condicoesDePagamentoService, long id, StatusAtivo statusAtividade)
        {
            RespostaAPIModel resposta;
            CondicaoDePagamentoModel condicaoDePagamento = new() { Ativo = true };
            try
            {
                viewModel.Localizando = true;
                await viewModel.SpinnerPrincipal.ShowAsync();
                LimpaTelaCadastroCondicaoDePagamento.Limpar(viewModel);

                resposta = await condicoesDePagamentoService.GetByIdAsync(URIsCondicoesDePagamento.GetAsync, id, statusAtividade);

                if (!resposta.Sucesso)
                {
                    viewModel.Mensagem = resposta.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    condicaoDePagamento = (CondicaoDePagamentoModel)resposta.Objeto;
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.Localizando = false;
            }

            return condicaoDePagamento;
        }
    }
}
