﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroCondicaoDePagamento
{
    public static class EnvioDadosCadastroCondicaoDePagamento
    {
        public static async Task Enviar(CadastroCondicaoDePagamentoVM viewModel, ICondicoesDePagamentoService service)
        {
            viewModel.Enviando = true;
            var retorno = viewModel.CondicaoDePagamento.Id == 0 ? await service.PostAsync(viewModel.CondicaoDePagamento) : await service.PutAsync(viewModel.CondicaoDePagamento);
            viewModel.Mensagem = retorno.Sucesso ? string.Empty : retorno.MensagemErro;
            viewModel.MensagemResultadoEnvio = retorno.Status == System.Net.HttpStatusCode.Created ? "CondicaoDePagamento criada com sucesso" :
                retorno.Status == System.Net.HttpStatusCode.OK ? "CondicaoDePagamento alterada com sucesso" : viewModel.Mensagem;
            viewModel.TipoToast = retorno.Sucesso ? TipoToast.Sucesso : TipoToast.Erro;
            if (retorno.Sucesso)
            {
                LimpaTelaCadastroCondicaoDePagamento.Limpar(viewModel);
                viewModel.Mensagem = viewModel.MensagemResultadoEnvio;
            }
            viewModel.Enviando = false;
            await viewModel.MeuToast.Show();
        }
    }
}
