﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroEmbalagem
{
    public static class EmbalagemByIdCadastroEmbalagem
    {
        public static async Task<EmbalagemModel> Get(CadastroEmbalagemVM viewModel, IEmbalagensService embalagensService, long id, StatusAtivo statusAtividade)
        {
            RespostaAPIModel resposta;
            EmbalagemModel embalagem = new(){ Ativo = true };
            try
            {
                viewModel.Localizando = true;
                await viewModel.SpinnerPrincipal.ShowAsync();
                LimpaTelaCadastroEmbalagem.Limpar(viewModel);

                resposta = await embalagensService.GetByIdAsync(URIsEmbalagens.GetAsync, id, statusAtividade);

                if (!resposta.Sucesso)
                {
                    viewModel.Mensagem = resposta.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    embalagem = (EmbalagemModel)resposta.Objeto;
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.Localizando = false;
            }

            return embalagem;
        }
    }
}
