﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroEmbalagem
{
    public static class EnvioDadosCadastroEmbalagem
    {
        public static async Task Enviar(CadastroEmbalagemVM viewModel, IEmbalagensService service)
        {
            viewModel.Enviando = true;
            var retorno = viewModel.Embalagem.Id == 0 ? await service.PostAsync(viewModel.Embalagem) : await service.PutAsync(viewModel.Embalagem);
            viewModel.Mensagem = retorno.Sucesso ? string.Empty : retorno.MensagemErro;
            viewModel.MensagemResultadoEnvio = retorno.Status == System.Net.HttpStatusCode.Created ? "Embalagem criada com sucesso" :
                retorno.Status == System.Net.HttpStatusCode.OK ? "Embalagem alterada com sucesso" : viewModel.Mensagem;
            viewModel.TipoToast = retorno.Sucesso ? TipoToast.Sucesso : TipoToast.Erro;
            if (retorno.Sucesso)
            {
                LimpaTelaCadastroEmbalagem.Limpar(viewModel);
                viewModel.Mensagem = viewModel.MensagemResultadoEnvio;
            }
            viewModel.Enviando = false;
            await viewModel.MeuToast.Show();
        }
    }
}
