﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroFormulario
{
    public static class EnvioDadosCadastroFormulario
    {
        public static async Task Enviar(ICadastroFormularioVM viewModel, IFormulariosService service)
        {
            viewModel.Enviando = true;
            var retorno = viewModel.Formulario.Id == 0 ? await service.PostAsync(viewModel.Formulario) : await service.PutAsync(viewModel.Formulario);
            viewModel.Mensagem = retorno.Sucesso ? string.Empty : retorno.MensagemErro;
            viewModel.MensagemResultadoEnvio = retorno.Status == System.Net.HttpStatusCode.Created ? "Formulário criado com sucesso" :
                retorno.Status == System.Net.HttpStatusCode.OK ? "Formulário alterado com sucesso" : viewModel.Mensagem;
            viewModel.TipoToast = retorno.Sucesso ? TipoToast.Sucesso : TipoToast.Erro;
            if (retorno.Sucesso)
            {
                LimpaTelaCadastroFormulario.Limpar(viewModel);
                viewModel.Mensagem = viewModel.MensagemResultadoEnvio;
            }
            viewModel.Enviando = false;
            await viewModel.MeuToast.Show();
        }
    }
}
