﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroFormulario
{
    public static class FormularioByIdCadastroFormulario
    {
        public static async Task<FormularioModel> Get(ICadastroFormularioVM viewModel, IFormulariosService formulariosService, long id, StatusAtivo statusAtividade)
        {
            RespostaAPIModel resposta;
            FormularioModel formulario = new FormularioModel { Ativo = true };
            try
            {
                viewModel.Localizando = true;
                await viewModel.SpinnerPrincipal.ShowAsync();

                resposta = await formulariosService.GetByIdAsync(URIsFormularios.GetAsync, id, statusAtividade);

                if (!resposta.Sucesso)
                {
                    viewModel.Mensagem = resposta.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    formulario = (FormularioModel)resposta.Objeto;
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.Localizando = false;
            }

            return formulario;
        }
    }
}
