﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroGeneroProduto
{
    public static class EnvioDadosCadastroGeneroProduto
    {
        public static async Task Enviar(CadastroGeneroProdutoVM viewModel, IGenerosProdutoService service)
        {
            viewModel.Enviando = true;
            var retorno = viewModel.Genero.Id == 0 ? await service.PostAsync(viewModel.Genero) : await service.PutAsync(viewModel.Genero);
            viewModel.Mensagem = retorno.Sucesso ? string.Empty : retorno.MensagemErro;
            viewModel.MensagemResultadoEnvio = retorno.Status == System.Net.HttpStatusCode.Created ? "Gênero criado com sucesso" :
                retorno.Status == System.Net.HttpStatusCode.OK ? "Gênero alterado com sucesso" : viewModel.Mensagem;
            viewModel.TipoToast = retorno.Sucesso ? TipoToast.Sucesso : TipoToast.Erro;
            if (retorno.Sucesso)
            {
                LimpaTelaCadastroGeneroProduto.Limpar(viewModel);
                viewModel.Mensagem = viewModel.MensagemResultadoEnvio;
            }
            viewModel.Enviando = false;
            await viewModel.MeuToast.Show();
        }
    }
}
