﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroGeneroProduto
{
    public static class GeneroByIdCadastroGeneroProduto
    {
        public static async Task<GeneroProdutoModel> Get(CadastroGeneroProdutoVM viewModel, IGenerosProdutoService generosService, long id, StatusAtivo statusAtividade)
        {
            RespostaAPIModel resposta;
            GeneroProdutoModel genero = new GeneroProdutoModel();
            try
            {
                viewModel.Localizando = true;
                await viewModel.SpinnerPrincipal.ShowAsync();
                LimpaTelaCadastroGeneroProduto.Limpar(viewModel);

                resposta = await generosService.GetByIdAsync(URIsGenerosProduto.GetAsync, id, statusAtividade);

                if (!resposta.Sucesso)
                {
                    viewModel.Mensagem = resposta.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    genero = (GeneroProdutoModel)resposta.Objeto;
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.Localizando = false;
            }

            return genero;
        }
    }
}
