﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroGrupoProduto
{
    public static class EnvioDadosCadastroGrupoProduto
    {
        public static async Task Enviar(CadastroGrupoProdutoVM viewModel, IGruposProdutoService service)
        {
            viewModel.Enviando = true;
            var retorno = viewModel.Grupo.Id == 0 ? await service.PostAsync(viewModel.Grupo) : await service.PutAsync(viewModel.Grupo);
            viewModel.Mensagem = retorno.Sucesso ? string.Empty : retorno.MensagemErro;
            viewModel.MensagemResultadoEnvio = retorno.Status == System.Net.HttpStatusCode.Created ? "Grupo criado com sucesso" :
                retorno.Status == System.Net.HttpStatusCode.OK ? "Grupo alterado com sucesso" : viewModel.Mensagem;
            viewModel.TipoToast = retorno.Sucesso ? TipoToast.Sucesso : TipoToast.Erro;
            if (retorno.Sucesso)
            {
                LimpaTelaCadastroGrupoProduto.Limpar(viewModel);
                viewModel.Mensagem = viewModel.MensagemResultadoEnvio;
            }
            viewModel.Enviando = false;
            await viewModel.MeuToast.Show();
        }
    }
}
