﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroGrupoProduto
{
    public static class GrupoByIdCadastroGrupoProduto
    {
        public static async Task<GrupoProdutoModel> Get(CadastroGrupoProdutoVM viewModel, IGruposProdutoService gruposService, long id, StatusAtivo statusAtividade)
        {
            RespostaAPIModel resposta;
            GrupoProdutoModel grupo = new GrupoProdutoModel();
            try
            {
                viewModel.Localizando = true;
                await viewModel.SpinnerPrincipal.ShowAsync();
                LimpaTelaCadastroGrupoProduto.Limpar(viewModel);

                resposta = await gruposService.GetByIdAsync(URIsGruposProduto.GetAsync, id, statusAtividade);

                if (!resposta.Sucesso)
                {
                    viewModel.Mensagem = resposta.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    grupo = (GrupoProdutoModel)resposta.Objeto;
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.Localizando = false;
            }

            return grupo;
        }
    }
}
