﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroHistorico
{
    public static class EnvioDadosCadastroHistorico
    {
        public static async Task Enviar(CadastroHistoricoVM viewModel, IHistoricosService service)
        {
            if (viewModel == null) return;
            viewModel.Enviando = true;
            var retorno = viewModel.Historico.Id == 0 ? await service?.PostAsync(viewModel.Historico) : await service?.PutAsync(viewModel.Historico);
            viewModel.Mensagem = retorno.Sucesso ? string.Empty : retorno.MensagemErro;
            viewModel.MensagemResultadoEnvio = retorno.Status == System.Net.HttpStatusCode.Created ? "Histórico criado com sucesso" :
                retorno.Status == System.Net.HttpStatusCode.OK ? "Histórico alterado com sucesso" : viewModel.Mensagem;
            viewModel.TipoToast = retorno.Sucesso ? TipoToast.Sucesso : TipoToast.Erro;
            if (retorno.Sucesso)
            {
                LimpaTelaCadastroHistorico.Limpar(viewModel);
                viewModel.Mensagem = viewModel.MensagemResultadoEnvio;
                await viewModel.DescricaoTextBox.FocusAsync();
            }
            viewModel.Enviando = false;
            await viewModel.MeuToast.Show();
        }
    }
}
