﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroHistorico
{
    public static class HistoricoByIdCadastroHistorico
    {
        public static async Task<HistoricoModel> Get(CadastroHistoricoVM viewModel, IHistoricosService historicosService, long id, StatusAtivo statusAtividade)
        {
            RespostaAPIModel resposta = new();
            try
            {
                viewModel.Localizando = true;
                await viewModel.SpinnerPrincipal.ShowAsync();
                resposta = await historicosService.GetByIdAsync(URIsHistoricos.GetAsync, id, statusAtividade);

                if (!resposta.Sucesso)
                {
                    viewModel.Mensagem = resposta.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                    return new HistoricoModel { HistoricoEstorno = new HistoricoModel() };
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.Localizando = false;
            }
            var historicoRetorno = (HistoricoModel)resposta.Objeto;
            historicoRetorno.HistoricoEstorno ??= new HistoricoModel();
            return historicoRetorno;
        }
    }
}
