﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroHistorico
{
    public static class LocalizaHistoricoEstornoCadastroHistorico
    {
        public static async Task LocalizarAsync(CadastroHistoricoVM viewModel, IHistoricosService service)
        {
            if (viewModel == null) return;
            
            viewModel.HistoricosEstornoBtnEnabled  = false;
            viewModel.PesquisandoHistoricosEstorno = true;
            string filtro = viewModel.Historico.EntradaSaida == (int)EntradaSaidaHistorico.Entrada ? "entradasaida eq 1" : "entradasaida eq 0";
            filtro += $"and tiponf eq {(int)TipoNFHistorico.Estorno} and ativo eq true";
            var retorno = await service?.GetAsync(URIsHistoricos.GetAsync, "id,descricao,entradasaida,tiponf,ativo", filtro,"","");
            viewModel.PesquisandoHistoricosEstorno = false;
            viewModel.HistoricosEstornoBtnEnabled  = true;

            if (!retorno.Sucesso)
            {
                viewModel.Mensagem = retorno.MensagemErro;
                viewModel.DlgVisible = true;
                return;
            }
            
            viewModel.Historicos = (List<HistoricoModel>)retorno.Objeto;
            viewModel.DlgHistoricosEstornoVisible = true;
        }
    }
}
