﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class CentroDeCustoByIdCadastroPessoa
    {
        public static async Task<CentroDeCustoModel> Get(CadastroPessoaVM viewModel, ICentrosDeCustoService centrosDeCustoService, long id, StatusAtivo ativos)
        {
            RespostaAPIModel resposta = new();
            try
            {
                viewModel.CentrosDeCustoBtnEnabled = false;
                await viewModel.SpinnerFinanceiro.ShowAsync();
                resposta = await centrosDeCustoService.GetByIdAsync(URIsPessoas.GetCentrosDeCustoAsync, id, ativos);
            }
            finally
            {
                viewModel.CentrosDeCustoBtnEnabled = true;
                await viewModel.SpinnerFinanceiro.HideAsync();
            }

            if (resposta.Sucesso)
            {
                return (CentroDeCustoModel)resposta.Objeto;
            }
            else
            {
                viewModel.Mensagem = resposta.Status == System.Net.HttpStatusCode.NotFound ? $"Não foi encontrado um centro de custo ativo com o Id {id}" :
                    $"Ocorreu um erro ao consultar o centro de custo com o id {id}. Erro {resposta.MensagemErro}";

                viewModel.TipoToast = TipoToast.Aviso;
                viewModel.AoMudarPropriedade("TipoToast");
                await viewModel.MeuToast.Show();
                await viewModel.IdCentroCustoInput.FocusAsync();
                return new CentroDeCustoModel();
            }
        }
    }
}
