﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class CondPgtoByIdCadastroPessoa
    {
        public static async Task<CondicaoDePagamentoModel> Get(CadastroPessoaVM viewModel, ICondicoesDePagamentoService condPgtosService, long id, StatusAtivo ativos)
        {
            RespostaAPIModel resposta = new RespostaAPIModel();
            try
            {
                await viewModel.SpinnerFinanceiro.ShowAsync();
                viewModel.CondicoesDePagamentoBtnEnabled = false;
                resposta = await condPgtosService?.GetByIdAsync(URIsPessoas.GetCondicoesDePagamentoAsync, id, ativos);
            }
            finally
            {
                viewModel.CondicoesDePagamentoBtnEnabled = true;
                await viewModel.SpinnerFinanceiro.HideAsync();
            }

            if (resposta.Sucesso)
            {
                return (CondicaoDePagamentoModel)resposta.Objeto;
            }
            else
            {
                viewModel.Mensagem = resposta.Status == System.Net.HttpStatusCode.NotFound ? $"Não foi encontrado uma condição de pagamento ativa com o Id {id}" :
                    $"Ocorreu um erro ao consultar a condição de pagamento com o id {id}. Erro {resposta.MensagemErro}";

                viewModel.TipoToast = TipoToast.Aviso;
                viewModel.AoMudarPropriedade("TipoToast");
                await viewModel.MeuToast.Show();
                await viewModel.IdCondPgtoInput.FocusAsync();

                return new CondicaoDePagamentoModel();
            }
        }
    }
}
