﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class EnderecoPeloCEPCadastroPessoa
    {
        public async static Task Endereco(CadastroPessoaVM viewModel, string cep, IEnderecoPeloCEPService enderecoPeloCEPService)
        {
            await viewModel.SpinnerEndereco.ShowAsync();
            viewModel.Endereco = await viewModel.GetEnderecoVazio();
            await viewModel.SpinnerEndereco.HideAsync();

            if (string.IsNullOrEmpty(cep)) return;
            await viewModel.SpinnerEndereco.ShowAsync();
            var retorno = await enderecoPeloCEPService.Endereco(cep);

            if (string.IsNullOrEmpty(retorno.MensagemErro))
            {
                viewModel.Endereco = (EnderecoPessoaModel)retorno.Objeto;
            }

            await viewModel.SpinnerEndereco.HideAsync();

            viewModel.Mensagem = retorno.MensagemErro;
            if (!string.IsNullOrEmpty(viewModel.Mensagem))
            {
                viewModel.DlgVisible = true;
            }
            return;

        }
    }
}
