﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class EnvioDadosCadastroPessoa
    {
        public static async Task Enviar(CadastroPessoaVM viewModel, IPessoasService service)
        {
            viewModel.Enviando = true;
            var retorno = viewModel.Pessoa.Id == 0 ? await service.PostAsync(viewModel.Pessoa) : await service.PutAsync(viewModel.Pessoa);
            viewModel.Mensagem = retorno.Sucesso ? string.Empty : retorno.MensagemErro;
            viewModel.MensagemResultadoEnvio = retorno.Status == System.Net.HttpStatusCode.Created ? "Pessoa criada com sucesso" :
                retorno.Status == System.Net.HttpStatusCode.OK ? "Pessoa alterada com sucesso" : viewModel.Mensagem;
            viewModel.TipoToast = retorno.Sucesso ? TipoToast.Sucesso : TipoToast.Erro;
            if (retorno.Sucesso)
            {
                await viewModel.CNPJTextBox.FocusAsync();
                await LimpaTelaCadastroPessoa.Limpar(viewModel, service, true);
                viewModel.Mensagem = viewModel.MensagemResultadoEnvio;
            }

            viewModel.Enviando = false;
            viewModel.AoMudarPropriedade(nameof(viewModel.Mensagem));
            viewModel.AoMudarPropriedade("TipoToast");
            await Task.Delay(100);
            await viewModel.MeuToast.Show();
        }
    }
}
