﻿using GAFNETBlazor.Models;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class InsereEMailCadastroPessoa
    {
        public async static Task Add(CadastroPessoaVM viewModel)
        {
            var email = viewModel?.EMail;
            if (email == null) return;

            if (!email.EMailCompleto())
            {
                viewModel.Mensagem = "Existem campos do E-Mail que não foram informados.";
                viewModel.DlgVisible = true;
                return;
            }

            viewModel.Pessoa.EMails = viewModel.Pessoa.EMails ?? new ObservableCollection<EMailPessoaModel>();
            
            var emailPessoa = viewModel.Pessoa.EMails.FirstOrDefault(e => e.EMail == email.EMail );
            if (emailPessoa != null)
            {
                viewModel.Pessoa.EMails.Remove(emailPessoa);
            }
            

            viewModel.Pessoa.EMails.Add(email);
            viewModel.EMail = new EMailPessoaModel();
            await viewModel.EMailTextBox.FocusAsync();
            return;
        }
    }
}
