﻿using GAFNETBlazor.Models;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class InsereEnderecoCadastroPessoa
    {
        public async static Task Add(CadastroPessoaVM viewModel)
        {
            if (viewModel?.Endereco == null) return;

            viewModel.Endereco.CNPJ = !string.IsNullOrEmpty(viewModel.Endereco.CNPJ) ? viewModel.Endereco.CNPJ : viewModel.Pessoa.CNPJ;

            if (!viewModel.Endereco.EnderecoCompleto())
            {
                viewModel.Mensagem = "Existem campos do endereço que não foram preenchidos.";
                viewModel.DlgVisible = true;
                return;
            }

            viewModel.Pessoa.Enderecos = viewModel.Pessoa.Enderecos ?? new ObservableCollection<EnderecoPessoaModel>();

            //se o endereço estiver marcado como principal, desmarca o antigo principal
            bool ehPrincipal = viewModel.Endereco.EhPrincipal; // feito aqui em cima porque no foreach seta todos como não principal
            if (ehPrincipal)
            {
                foreach (var endereco in viewModel.Pessoa.Enderecos)
                {
                    endereco.EhPrincipal = false;
                }
                viewModel.Pessoa.EnderecoPrincipal = viewModel.Endereco;
                viewModel.Endereco.EhPrincipal = true;
            }
            
            var enderecoPessoa = viewModel.Pessoa.Enderecos.FirstOrDefault(e => e.Equals(viewModel.Endereco));
            if (enderecoPessoa != null) viewModel.Pessoa.Enderecos.Remove(enderecoPessoa);
            viewModel.Pessoa.Enderecos.Add(viewModel.Endereco);
            viewModel.Endereco = await viewModel.GetEnderecoVazio();
            await viewModel.CEPTextBox.FocusAsync();
            return;
        }
    }
}
