﻿using GAFNETBlazor.Models;
using System.Collections.ObjectModel;
using System.Linq;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class InsereTelefoneCadastroPessoa
    {
        public async static Task Add(CadastroPessoaVM viewModel)
        {
            var telefone = viewModel?.Telefone;
            if (telefone == null || (string.IsNullOrEmpty(telefone.Telefone))) return;

            viewModel.Pessoa.Telefones = viewModel.Pessoa.Telefones ?? new ObservableCollection<TelefonePessoaModel>();

            var telefonePessoa = viewModel.Pessoa.Telefones.FirstOrDefault(e => e.Telefone == telefone.Telefone);
            if (telefonePessoa != null)
            {
                viewModel.Pessoa.Telefones.Remove(telefonePessoa);
            }


            viewModel.Pessoa.Telefones.Add(telefone);
            viewModel.Telefone = new TelefonePessoaModel();
            await viewModel.TelefoneTextBox.FocusAsync();
            return;
        }
    }
}
