﻿using GAFNETBlazor.Models;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class InsereTransportadoraCadastroPessoa
    {
        public static Task Add(CadastroPessoaVM viewModel)
        {
            var transportadora = viewModel?.Transportadora;
            if (transportadora == null) return Task.CompletedTask;

            if (transportadora.Id == 0)
            {
                viewModel.Mensagem = "É necessário selecionar uma transportadora.";
                viewModel.DlgVisible = true;
                return Task.CompletedTask;
            }

            viewModel.Pessoa.TransportadorasPessoa = viewModel.Pessoa.TransportadorasPessoa ?? new ObservableCollection<TransportadoraPessoaModel>();
            
            var transportadoraPessoa = viewModel.Pessoa.TransportadorasPessoa.FirstOrDefault(e => e.IdTransportadora == transportadora.Id );
            if (transportadoraPessoa != null)
            {
                viewModel.Pessoa.TransportadorasPessoa.Remove(transportadoraPessoa);
            }

            viewModel.Pessoa.TransportadorasPessoa.Add(new TransportadoraPessoaModel { IdTransportadora = transportadora.Id, Transportadora = transportadora});
            viewModel.Transportadora = new PessoaModel();
            return Task.CompletedTask;
        }
    }
}
