﻿using GAFNETBlazor.Models;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class InsereVendedorCadastroPessoa
    {
        public static Task Add(CadastroPessoaVM viewModel)
        {
            if (viewModel.VendedorPessoa.Vendedor.Id == 0)
            {
                viewModel.Mensagem = "É necessário selecionar um vendedor.";
                viewModel.DlgVisible = true;
                return Task.CompletedTask;
            }

            viewModel.Pessoa.VendedoresPessoa = viewModel.Pessoa.VendedoresPessoa ?? new ObservableCollection<VendedorPessoaModel>();
            
            var vendedorPessoa = viewModel.Pessoa.VendedoresPessoa.FirstOrDefault(e => e.IdVendedor == viewModel.VendedorPessoa.Vendedor.Id );
            if (vendedorPessoa != null)
            {
                viewModel.Pessoa.VendedoresPessoa.Remove(vendedorPessoa);
            }

            viewModel.Pessoa.VendedoresPessoa.Add(new VendedorPessoaModel { IdVendedor = viewModel.VendedorPessoa.Vendedor.Id, PercComissao = viewModel.VendedorPessoa.PercComissao, Vendedor = viewModel.VendedorPessoa.Vendedor });
            viewModel.VendedorPessoa = new VendedorPessoaModel { Vendedor = new PessoaModel() };
            return Task.CompletedTask;
        }
    }
}
