﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class LimpaTelaCadastroPessoa
    {
        public static async Task Limpar(CadastroPessoaVM viewModel, IPessoasService pessoasService, bool limparDadosPessoa)
        {
            viewModel.ErrosValidacaoFormulario.Clear();
            if (limparDadosPessoa)
            {
                viewModel.Pessoa = pessoasService?.GetPessoaVazia();
            }

            viewModel.Endereco = await viewModel.GetEnderecoVazio();
            viewModel.Transportadora = new PessoaModel();
            viewModel.EMail          = new EMailPessoaModel();
            viewModel.Telefone       = new TelefonePessoaModel();
            viewModel.ProdutoPessoa  = new ProdutoPessoaModel { Produto = new ProdutoModel()};
            viewModel.VendedorPessoa = new VendedorPessoaModel { Vendedor = new PessoaModel() };
        }
    }
}
