﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class LocalizaCentroDeCustoCadastroPessoa
    {
        public static async Task LocalizarAsync(CadastroPessoaVM viewModel, ICentrosDeCustoService service)
        {
            if (viewModel != null)
            {
                viewModel.CentrosDeCustoBtnEnabled  = false;
                viewModel.PesquisandoCentrosDeCusto = true;
                var retorno                         = await service?.GetAsync(URIsPessoas.GetCentrosDeCustoAsync, StatusAtivo.Ativos);
                viewModel.PesquisandoCentrosDeCusto = false;
                viewModel.CentrosDeCustoBtnEnabled  = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.DlgVisible = true;
                }
                else
                {
                    viewModel.CentrosDeCusto = (List<CentroDeCustoModel>)retorno.Objeto;
                    viewModel.DlgCentrosDeCustoVisible = true;
                }
            }
        }
    }
}
