﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class LocalizaCidadeCadastroPessoa
    {
        public static async Task LocalizarAsync(CadastroPessoaVM viewModel, ICidadesService service)
        {
            if (viewModel != null)
            {
                viewModel.CidadesBtnEnabled = false;
                viewModel.PesquisandoCidades = true;
                var retorno = await service.GetAsync(URIsPessoas.GetCidadesAsync, StatusAtivo.Ativos);
                viewModel.PesquisandoCidades = false;

                if (!string.IsNullOrEmpty(retorno.MensagemErro))
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                }
                else
                {
                    viewModel.Mensagem = string.Empty;
                    viewModel.Cidades = (List<CidadeModel>)retorno.Objeto;
                    viewModel.DlgCidadesVisible = true;
                }

                viewModel.CidadesBtnEnabled = true;
            }
        }
    }
}
