﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class LocalizaCondPgtoCadastroPessoa
    {
        public static async Task LocalizarAsync(CadastroPessoaVM viewModel, ICondicoesDePagamentoService service)
        {
            if (viewModel != null)
            {
                viewModel.CondicoesDePagamentoBtnEnabled  = false;
                viewModel.PesquisandoCondicoesDePagamento = true;
                var retorno                               = await service?.GetAsync(URIsPessoas.GetCondicoesDePagamentoAsync, StatusAtivo.Ativos);
                viewModel.PesquisandoCondicoesDePagamento = false;
                viewModel.CondicoesDePagamentoBtnEnabled  = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.DlgVisible = true;
                }
                else
                {
                    viewModel.CondicoesDePagamento = (List<CondicaoDePagamentoModel>)retorno.Objeto;
                    viewModel.DlgCondicoesDePagamentoVisible = true;
                }
            }
        }
    }
}
