﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class LocalizaHistoricoCadastroPessoa
    {
        public static async Task LocalizarAsync(CadastroPessoaVM viewModel, IHistoricosService service)
        {
            if (viewModel != null)
            {
                viewModel.HistoricosBtnEnabled  = false;
                viewModel.PesquisandoHistoricos = true;
                var retorno                     = await service?.GetAsync(URIsPessoas.GetHistoricosAsync, StatusAtivo.Ativos);
                viewModel.PesquisandoHistoricos = false;
                viewModel.HistoricosBtnEnabled  = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.DlgVisible = true;
                }
                else
                {
                    viewModel.Historicos = (List<HistoricoModel>)retorno.Objeto;
                    viewModel.DlgHistoricosVisible = true;
                }
                //viewModel.HistoricosBtnEnabled = true;
            }
        }
    }
}
