﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class LocalizaPaisCadastroPessoa
    {
        public static async Task LocalizarAsync(CadastroPessoaVM viewModel, IPaisesService service)
        {
            if (viewModel != null)
            {
                viewModel.PaisesBtnEnabled = false;
                viewModel.PesquisandoPaises = true;
                var retorno = await service?.GetAsync(URIsPessoas.GetPaisesAsync, StatusAtivo.Ativos);
                viewModel.PesquisandoPaises = false;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.DlgVisible = true;
                }
                else
                {
                    viewModel.Paises = (List<PaisModel>)retorno.Objeto;
                    viewModel.DlgPaisesVisible = true;
                }
                viewModel.PaisesBtnEnabled = true;
            }
        }
    }
}
