﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class LocalizaPlanoDeContaCadastroPessoa
    {
        public static async Task LocalizarAsync(CadastroPessoaVM viewModel, IPlanosDeContaService service)
        {
            if (viewModel != null)
            {
                viewModel.PlanosDeContaBtnEnabled  = false;
                viewModel.PesquisandoPlanosDeConta = true;
                var retorno                        = await service?.GetAsync(URIsPessoas.GetPlanosDeContaAsync, 
                    "id, descricao, tipo, debitocredito, classificacao1, classificacao2, classificacao3, ativo",
                    "tipo eq 'Analitica' and ativo eq true", "descricao", "");
                viewModel.PesquisandoPlanosDeConta = false;
                viewModel.PlanosDeContaBtnEnabled  = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.DlgVisible = true;
                }
                else
                {
                    viewModel.PlanosDeContas = (List<PlanoDeContaModel>)retorno.Objeto;
                    viewModel.DlgPlanosDeContaVisible = true;
                }
            }
        }
    }
}
