﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class LocalizaProdutoCadastroPessoa
    {
        public static async Task LocalizarAsync(CadastroPessoaVM viewModel, IProdutosService service)
        {
            if (viewModel != null)
            {
                viewModel.ProdutosBtnEnabled = false;
                viewModel.PesquisandoProdutos = true;
                var retorno = await service?.GetAsync(URIsPessoas.GetProdutosAsync, StatusAtivo.Ativos);
                viewModel.PesquisandoProdutos = false;

                viewModel.ProdutosBtnEnabled = true;

                if (retorno.Status != System.Net.HttpStatusCode.OK)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.DlgVisible = true;
                }
                else
                {
                    viewModel.Produtos = (List<ProdutoModel>)retorno.Objeto;
                    viewModel.DlgProdutosVisible = true;
                }
            }
        }
    }
}
