﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class LocalizaTipoDeOperacaoCadastroPessoa
    {
        public static async Task LocalizarAsync(CadastroPessoaVM viewModel, ITiposDeOperacaoService service)
        {
            if (viewModel != null)
            {
                viewModel.TiposDeOperacaoBtnEnabled  = false;
                viewModel.PesquisandoTiposDeOperacao = true;
                var retorno                     = await service?.GetAsync(URIsPessoas.GetTiposDeOperacaoAsync, StatusAtivo.Ativos);
                viewModel.PesquisandoTiposDeOperacao = false;
                viewModel.TiposDeOperacaoBtnEnabled  = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.DlgVisible = true;
                }
                else
                {
                    viewModel.TiposDeOperacao = (List<TipoDeOperacaoModel>)retorno.Objeto;
                    viewModel.DlgTiposDeOperacaoVisible = true;
                }
            }
        }
    }
}
