﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class LocalizaVendedorCadastroPessoa
    {
        public static async Task LocalizarAsync(CadastroPessoaVM viewModel, IPessoasService service)
        {
            if (viewModel != null)
            {
                viewModel.VendedoresBtnEnabled = false;
                viewModel.PesquisandoVendedores = true;
                var retorno = await service?.GetAsync(URIsPessoas.GetVendedoresAsync, StatusAtivo.Ativos);
                viewModel.PesquisandoVendedores = false;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.DlgVisible = true;
                }
                else
                {
                    viewModel.Vendedores = (List<PessoaModel>)retorno.Objeto;
                    viewModel.DlgVendedoresVisible = true;
                }
                viewModel.VendedoresBtnEnabled = true;
            }
        }
    }
}
