﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class ManipulaPessoaCadastroPessoa
    {
        public static PessoaModel Manipular(IPessoasService pessoasService, RespostaAPIModel resposta)
        {
            var pessoa = resposta.Sucesso ? (PessoaModel)resposta.Objeto : pessoasService.GetPessoaVazia();


            pessoa.Historico ??= new HistoricoModel();
            pessoa.PlanoDeConta ??= new PlanoDeContaModel();
            pessoa.CentroDeCusto ??= new CentroDeCustoModel();
            pessoa.TipoDeOperacao ??= new TipoDeOperacaoModel();
            pessoa.CondicaoDePagamento ??= new CondicaoDePagamentoModel();
            pessoa.IndicadorIE = pessoa.IndicadorIE == 0 ? IndicadorIE.NaoContribuinte : pessoa.IndicadorIE;
            return pessoa;
        }

    }
}
