﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class PessoaByCNPJCadastroPessoa
    {
        public static async Task<PessoaModel> Get(CadastroPessoaVM viewModel, IPessoasService pessoasService, string cnpj, StatusAtivo statusAtividade)
        {
            await LimpaTelaCadastroPessoa.Limpar(viewModel, pessoasService, false);
            RespostaAPIModel resposta = new();
            try
            {
                viewModel.Localizando = true;
                await viewModel.SpinnerPrincipal.ShowAsync();
                resposta = await pessoasService.GetByCNPJAsync(cnpj, statusAtividade);

                if (!resposta.Sucesso)
                {
                    viewModel.Mensagem = resposta.MensagemErro;
                    viewModel.DlgVisible = (!string.IsNullOrEmpty(viewModel.Mensagem));
                    return new PessoaModel();
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.Localizando = false;
            }
            var pessoa = ManipulaPessoaCadastroPessoa.Manipular(pessoasService, resposta);
            return pessoa;
        }
    }
}
