﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class PessoaByIdCadastroPessoa
    {
        public static async Task<PessoaModel> Get(CadastroPessoaVM viewModel, IPessoasService pessoasService, long id, StatusAtivo statusAtividade)
        {
            RespostaAPIModel resposta = new();
            try
            {
                viewModel.Localizando = true;
                await viewModel.SpinnerPrincipal.ShowAsync();
                await LimpaTelaCadastroPessoa.Limpar(viewModel, pessoasService, false);

                resposta = await pessoasService.GetByIdAsync(URIsPessoas.GetAsync, id, statusAtividade);

                if (!resposta.Sucesso)
                {
                    viewModel.Mensagem = resposta.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.Localizando = false;
            }
            var pessoa = ManipulaPessoaCadastroPessoa.Manipular(pessoasService, resposta);
            return pessoa;
        }
    }
}
