﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services;
using GAFNETBlazor.Services.Interfaces;
using System.Linq;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class RetiraTelefoneCadastroPessoa
    {
        public static Task Retirar(CadastroPessoaVM viewModel)
        {
            var telefonePessoa = viewModel.Pessoa.Telefones.FirstOrDefault(e => e.Telefone == viewModel.Telefone.Telefone);
            if (telefonePessoa != null)
            {
                viewModel.Pessoa.Telefones.Remove(telefonePessoa);
            }
            
            viewModel.Telefone = new TelefonePessoaModel();
            return Task.CompletedTask;
        }
    }
}
