﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class TipoDeOperacaoByIdCadastroPessoa
    {
        public static async Task<TipoDeOperacaoModel> Get(CadastroPessoaVM viewModel, ITiposDeOperacaoService tiposDeOperacaoService, long id, StatusAtivo statusAtivo)
        {
            RespostaAPIModel resposta = new RespostaAPIModel();
            try
            {
                viewModel.TiposDeOperacaoBtnEnabled = false;
                await viewModel.SpinnerFinanceiro.ShowAsync();
                resposta = await tiposDeOperacaoService.GetByIdAsync(URIsPessoas.GetTiposDeOperacaoAsync, id, statusAtivo);
            }
            finally
            {
                await viewModel.SpinnerFinanceiro.HideAsync();
                viewModel.TiposDeOperacaoBtnEnabled = true;
            }
            
            

            if (resposta.Sucesso)
            {
                return (TipoDeOperacaoModel)resposta.Objeto;
            }
            else
            {
                viewModel.Mensagem = resposta.Status == System.Net.HttpStatusCode.NotFound ? $"Não foi encontrado um tipo de operação ativo com o Id {id}" :
                    $"Ocorreu um erro ao consultar o tipo de operação com o id {id}. Erro {resposta.MensagemErro}";

                viewModel.TipoToast = TipoToast.Aviso;
                viewModel.AoMudarPropriedade("TipoToast");
                await viewModel.MeuToast.Show();
                return new TipoDeOperacaoModel();
            }
        }
    }
}
