﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPessoa
{
    public static class TransportadoraByIdCadastroPessoa
    {
        public static async Task<PessoaModel> Get(CadastroPessoaVM viewModel, IPessoasService pessoasService, long id)
        {
            viewModel.TransportadorasBtnEnabled = false;
            await viewModel.SpinnerTransportadora.ShowAsync();
            viewModel.PesquisandoTransportadoras = true;
            var resposta = await pessoasService.GetByIdAsync(URIsPessoas.GetAsync, id, "", "ativo eq true and EhTransportadora eq true");

            await viewModel.SpinnerTransportadora.HideAsync();
            viewModel.TransportadorasBtnEnabled = true;
            viewModel.PesquisandoTransportadoras = false;

            if (resposta.Sucesso)
            {
                return (PessoaModel)resposta.Objeto;
            }
            else
            {
                viewModel.Mensagem = resposta.Status == System.Net.HttpStatusCode.NotFound ? $"Não foi encontrada uma transportadora ativa com o Id {id}" :
                    $"Ocorreu um erro ao consultar a transportadora com o id {id}. Erro {resposta.MensagemErro}";

                viewModel.TipoToast = TipoToast.Aviso;
                viewModel.AoMudarPropriedade("TipoToast");
                await viewModel.MeuToast.Show();

                return new PessoaModel();
            }
        }
    }
}
