﻿using GAFNETBlazor.Constantes;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETLibrary.Enums;
using GAFNETLibrary.Models;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPlanoDeConta;

public static class ContaContrapartidaByIdCadastroPlanoDeContas
{
    public static async Task<PlanoDeContaModel> Get(CadastroPlanoDeContaVM viewModel, IPlanosDeContaService planoDeContasService, long id, StatusAtivo statusAtividade)
    {
        RespostaAPIModel resposta;
        PlanoDeContaModel contaContrapartida = new();
        
        resposta = await planoDeContasService.GetByIdAsync(URIsPlanosDeConta.GetAsync, id, statusAtividade);

        if (!resposta.Sucesso)
        {
            await viewModel.ExibirMensagemToast(resposta.MensagemErro, TipoToast.Aviso);
            return contaContrapartida;
        }

        contaContrapartida = (PlanoDeContaModel)resposta.Objeto;
        viewModel.PlanoDeConta.ContaContrapartida = contaContrapartida ?? new PlanoDeContaModel();
        viewModel.PlanoDeConta.IdContaContrapartida = contaContrapartida.Id > 0 ? contaContrapartida.Id : null;
        viewModel.AoMudarPropriedade(nameof(viewModel.PlanoDeConta));
        return contaContrapartida;
    }
}
