﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETBlazor.ViewModels.Usuario.CadastroGrupoProduto;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPlanoDeConta;

public static class EnvioDadosCadastroPlanoDeConta
{
    public static async Task Enviar(CadastroPlanoDeContaVM viewModel, IPlanosDeContaService service)
    {
        viewModel.Enviando = true;
        var retorno = viewModel.PlanoDeConta.Id == 0 ? await service.PostAsync(viewModel.PlanoDeConta) : await service.PutAsync(viewModel.PlanoDeConta);
        viewModel.Mensagem = retorno.Sucesso ? string.Empty : retorno.MensagemErro;
        viewModel.MensagemResultadoEnvio = retorno.Status == System.Net.HttpStatusCode.Created ? "Plano de Conta criado com sucesso" :
            retorno.Status == System.Net.HttpStatusCode.OK ? "Plano de Conta alterado com sucesso" : viewModel.Mensagem;
        viewModel.TipoToast = retorno.Sucesso ? TipoToast.Sucesso : TipoToast.Erro;
        if (retorno.Sucesso)
        {
            LimpaTelaCadastroPlanoDeConta.Limpar(viewModel);
            viewModel.Mensagem = viewModel.MensagemResultadoEnvio;
        }
        viewModel.Enviando = false;
        await viewModel.MeuToast.Show();
    }
}
