﻿using GAFNETBlazor.Constantes;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETLibrary.Enums;
using GAFNETLibrary.Models;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroPlanoDeConta;

public static class PlanoDeContaByIdCadastroPlanoDeContas
{
    public static async Task<PlanoDeContaModel> Get(CadastroPlanoDeContaVM viewModel, IPlanosDeContaService planoDeContasService, long id, StatusAtivo statusAtividade)
    {
        RespostaAPIModel resposta;
        PlanoDeContaModel planoDeConta = new();
        try
        {
            viewModel.Localizando = true;
            await viewModel.SpinnerPrincipal.ShowAsync();
            LimpaTelaCadastroPlanoDeConta.Limpar(viewModel);

            resposta = await planoDeContasService.GetByIdAsync(URIsPlanosDeConta.GetAsync, id, statusAtividade);

            if (!resposta.Sucesso)
            {
                await viewModel.ExibirMensagemToast(resposta.MensagemErro, TipoToast.Aviso);
                return planoDeConta;
            }

            planoDeConta = (PlanoDeContaModel)resposta.Objeto;
            planoDeConta.ContaContrapartida = planoDeConta.ContaContrapartida ?? new PlanoDeContaModel();
        }
        finally
        {
            await viewModel.SpinnerPrincipal.HideAsync();
            viewModel.Localizando = false;
        }

        return planoDeConta;
    }
}
