﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroProduto
{
    public static class EmbalagemByIdCadastroProduto
    {
        public static async Task<EmbalagemModel> Get(ICadastroProdutoVM viewModel, IEmbalagensService embalagensService, long id, StatusAtivo ativos)
        {
            RespostaAPIModel resposta = new();
            try
            {
                viewModel.EmbalagensBtnEnabled = false;
                await viewModel.SpinnerPrincipal.ShowAsync();
                resposta = await embalagensService.GetByIdAsync(URIsProdutos.GetEmbalagensAsync, id, ativos);
            }
            finally
            {
                viewModel.EmbalagensBtnEnabled = true;
                await viewModel.SpinnerPrincipal.HideAsync();
            }

            if (!resposta.Sucesso)
            {
                var mensagem = resposta.Status == System.Net.HttpStatusCode.NotFound ? $"Não foi encontrada uma embalagem ativa com o Id {id}" :
                    $"Ocorreu um erro ao consultar a embalagem com o id {id}. Erro {resposta.MensagemErro}";

                await viewModel.ExibirMensagemToast(mensagem, TipoToast.Aviso);
                //await viewModel.IdAliquotaInput.FocusAsync();
                return new EmbalagemModel();
            }

            return (EmbalagemModel)resposta.Objeto;
        }
    }
}
