﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETBlazor.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroProduto
{
    public static class EnvioDadosCadastroProduto
    {
        public static async Task Enviar(CadastroProdutoVM viewModel, IProdutosService service)
        {
            viewModel.Enviando = true;
            var retorno = viewModel.Produto.Id == 0 ? await service.PostAsync(viewModel.Produto) : await service.PutAsync(viewModel.Produto);
            viewModel.Mensagem = retorno.Sucesso ? string.Empty : retorno.MensagemErro;
            viewModel.MensagemResultadoEnvio = retorno.Status == System.Net.HttpStatusCode.Created ? "Item criado com sucesso" :
                retorno.Status == System.Net.HttpStatusCode.OK ? "Item alterado com sucesso" : viewModel.Mensagem;
            viewModel.TipoToast = retorno.Sucesso ? TipoToast.Sucesso : TipoToast.Erro;
            if (retorno.Sucesso)
            {
                LimpaTelaCadastroProduto.Limpar(viewModel);
                viewModel.Mensagem = viewModel.MensagemResultadoEnvio;
            }
            
            viewModel.Enviando = false;
            viewModel.AoMudarPropriedade("TipoToast");
            await viewModel.MeuToast.Show();
            
        }
    }
}
