﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroProduto
{
    public static class GeneroByIdCadastroProduto
    {
        public static async Task<GeneroProdutoModel> Get(ICadastroProdutoVM viewModel, IGenerosProdutoService generosService, long id, StatusAtivo ativos)
        {
            RespostaAPIModel resposta = new();
            try
            {
                viewModel.GenerosBtnEnabled = false;
                await viewModel.SpinnerPrincipal.ShowAsync();
                resposta = await generosService.GetByIdAsync(URIsProdutos.GetGenerosAsync, id, ativos);
            }
            finally
            {
                viewModel.GenerosBtnEnabled = true;
                await viewModel.SpinnerPrincipal.HideAsync();
            }

            if (resposta.Sucesso)
            {
                return (GeneroProdutoModel)resposta.Objeto;
            }
            else
            {
                viewModel.Mensagem = resposta.Status == System.Net.HttpStatusCode.NotFound ? $"Não foi encontrado um gênero ativo com o Id {id}" :
                    $"Ocorreu um erro ao consultar o gênero com o id {id}. Erro {resposta.MensagemErro}";

                viewModel.TipoToast = TipoToast.Aviso;
                viewModel.AoMudarPropriedade("TipoToast");
                await viewModel.MeuToast.Show();
                await viewModel.IdGeneroInput.FocusAsync();
                return new GeneroProdutoModel();
            }
        }
    }
}
