﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroProduto
{
    public static class LocalizaAliquotaCadastroProduto
    {
        public static async Task LocalizarAsync(CadastroProdutoVM viewModel, IAliquotasService service)
        {
            if (viewModel != null)
            {
                viewModel.AliquotasBtnEnabled = false;
                viewModel.PesquisandoAliquotas = true;
                var retorno = await service?.GetAsync(URIsProdutos.GetAliquotasAsync, StatusAtivo.Todos);
                viewModel.PesquisandoAliquotas = false;
                viewModel.AliquotasBtnEnabled = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    viewModel.Aliquotas = (List<AliquotaModel>)retorno.Objeto;
                    viewModel.DlgAliquotasVisible = true;
                }
            }
        }
    }
}
