﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroProduto
{
    public static class LocalizaClassFiscaisCadastroProduto
    {
        public static async Task LocalizarAsync(ICadastroProdutoVM viewModel, IClassificacoesFiscaisService service)
        {
            if (viewModel != null)
            {
                viewModel.ClassFiscaisBtnEnabled = false;
                viewModel.PesquisandoClassFiscais = true;
                var retorno = await service?.GetAsync(URIsProdutos.GetClassFiscaisAsync, StatusAtivo.Todos);
                viewModel.PesquisandoClassFiscais = false;
                viewModel.ClassFiscaisBtnEnabled = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    viewModel.ClassFiscais = (List<ClassificacaoFiscalModel>)retorno.Objeto;
                    viewModel.DlgClassFiscaisVisible = true;
                }
            }
        }
    }
}
