﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroProduto
{
    public static class LocalizaEmbalagemCadastroProduto
    {
        public static async Task LocalizarAsync(ICadastroProdutoVM viewModel, IEmbalagensService service)
        {
            if (viewModel != null)
            {
                viewModel.EmbalagensBtnEnabled = false;
                viewModel.PesquisandoEmbalagens = true;
                var retorno = await service?.GetAsync(URIsProdutos.GetEmbalagensAsync, StatusAtivo.Todos);
                viewModel.PesquisandoEmbalagens = false;
                viewModel.EmbalagensBtnEnabled = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    viewModel.Embalagens = (List<EmbalagemModel>)retorno.Objeto;
                    viewModel.DlgEmbalagensVisible = true;
                }
            }
        }
    }
}
