﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroProduto
{
    public static class LocalizaGeneroCadastroProduto
    {
        public static async Task LocalizarAsync(ICadastroProdutoVM viewModel, IGenerosProdutoService service)
        {
            if (viewModel != null)
            {
                viewModel.GenerosBtnEnabled = false;
                viewModel.PesquisandoGeneros = true;
                var retorno = await service?.GetAsync(URIsProdutos.GetGenerosAsync, StatusAtivo.Todos);
                viewModel.PesquisandoGeneros = false;
                viewModel.GenerosBtnEnabled = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    viewModel.Generos = (List<GeneroProdutoModel>)retorno.Objeto;
                    viewModel.DlgGenerosVisible = true;
                }
            }
        }
    }
}
