﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroProduto
{
    public static class LocalizaProdutoCadastroProduto
    {
        public static async Task LocalizarAsync(CadastroProdutoVM viewModel, IProdutosService service)
        {
            if (viewModel != null)
            {
                viewModel.Localizando = true;
                var retorno = await service?.GetAsync(URIsProdutos.GetAsync, StatusAtivo.Ativos);
                viewModel.Localizando = false;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    viewModel.Produtos = (List<ProdutoModel>)retorno.Objeto;
                    viewModel.DlgProdutosVisible = true;
                }
            }
        }
    }
}
