﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroProduto
{
    public static class LocalizaSubgrupoCadastroProduto
    {
        public static async Task LocalizarAsync(ICadastroProdutoVM viewModel, ISubgruposProdutoService service)
        {
            if (viewModel != null)
            {
                viewModel.SubgruposBtnEnabled = false;
                viewModel.PesquisandoSubgrupos = true;
                var retorno = await service?.GetAsync(URIsProdutos.GetSubgruposAsync, StatusAtivo.Todos);
                viewModel.PesquisandoSubgrupos = false;
                viewModel.SubgruposBtnEnabled = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    viewModel.Subgrupos = (List<SubgrupoProdutoModel>)retorno.Objeto;
                    viewModel.DlgSubgruposVisible = true;
                }
            }
        }
    }
}
