﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroProduto
{
    public static class LocalizaUnidadeCadastroProduto
    {
        public static async Task LocalizarAsync(ICadastroProdutoVM viewModel, IUnidadesProdutoService service)
        {
            if (viewModel != null)
            {
                viewModel.UnidadesBtnEnabled = false;
                viewModel.PesquisandoUnidades = true;
                var retorno = await service?.GetAsync(URIsProdutos.GetUnidadesAsync, StatusAtivo.Todos);
                viewModel.PesquisandoUnidades = false;
                viewModel.UnidadesBtnEnabled = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    viewModel.Unidades = (List<UnidadeProdutoModel>)retorno.Objeto;
                    viewModel.DlgUnidadesVisible = true;
                }
            }
        }
    }
}
