﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroProduto
{
    public static class ProdutoByCodigoCadastroProduto
    {
        public static async Task<ProdutoModel> Get(ICadastroProdutoVM viewModel, IProdutosService produtosService, string codigo, StatusAtivo statusAtividade)
        {
            await viewModel.SpinnerPrincipal.ShowAsync();
            viewModel.Localizando = false;

            var resposta = await produtosService?.GetByCodigoAsync(URIsProdutos.GetAsync, codigo, statusAtividade);
            await viewModel.SpinnerPrincipal.HideAsync();
            viewModel.Localizando = false;
            viewModel.Mensagem = resposta.MensagemErro;

            if (!resposta.Sucesso)
            {
                return new ProdutoModel { Aliquota = new AliquotaModel(), Subgrupo = new SubgrupoProdutoModel(), Unidade = new UnidadeProdutoModel(), ClassificacaoFiscal = new ClassificacaoFiscalModel() };
            }
            
            return (ProdutoModel)resposta.Objeto;

            //else
            //{
            //    viewModel.Mensagem = resposta.Status == System.Net.HttpStatusCode.NotFound ? $"Não foi encontrado um item com o código {codigo}" :
            //        $"Ocorreu um erro ao consultar o item com o código {codigo}. Erro {resposta.MensagemErro}";

            //    viewModel.TipoToast = TipoToast.Aviso;
            //    viewModel.AoMudarPropriedade("TipoToast");
            //    await viewModel.MeuToast.Show();
            //    await viewModel.CodigoProdutoTextBox.FocusAsync();
            //}

        }
    }
}
