﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroProduto
{
    public static class ProdutoByIdCadastroProduto
    {
        public static async Task<ProdutoModel> Get(CadastroProdutoVM viewModel, IProdutosService produtosService, long id, StatusAtivo statusAtividade)
        {
            RespostaAPIModel resposta;
            ProdutoModel produto = new ProdutoModel { Aliquota = new AliquotaModel(), Unidade = new UnidadeProdutoModel(), ClassificacaoFiscal = new ClassificacaoFiscalModel(), Subgrupo = new SubgrupoProdutoModel { Grupo = new GrupoProdutoModel() } };

            try
            {
                viewModel.Localizando = true;
                await viewModel.SpinnerPrincipal.ShowAsync();

                resposta = await produtosService.GetByIdAsync(URIsProdutos.GetAsync, id, statusAtividade);

                if (!resposta.Sucesso)
                {
                    viewModel.Mensagem = resposta.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    produto = (ProdutoModel)resposta.Objeto;
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.Localizando = false;
            }
            return produto;
        }
    }
}
