﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroProduto
{
    public static class UnidadeByCodigoCadastroProduto
    {
        public static async Task<UnidadeProdutoModel> Get(ICadastroProdutoVM viewModel, IUnidadesProdutoService unidadesService, string codigo, StatusAtivo ativos)
        {
            RespostaAPIModel resposta = new RespostaAPIModel();
            try
            {
                viewModel.UnidadesBtnEnabled = false;
                await viewModel.SpinnerPrincipal.ShowAsync();
                resposta = await unidadesService.GetByCodigoAsync(URIsProdutos.GetUnidadesAsync, codigo, ativos);
            }
            finally
            {
                viewModel.UnidadesBtnEnabled = true;
                await viewModel.SpinnerPrincipal.HideAsync();
            }

            if (!resposta.Sucesso)
            {
                viewModel.Mensagem = resposta.Status == System.Net.HttpStatusCode.NotFound ? $"Não foi encontrada uma unidade ativa com o código {codigo}" :
                    $"Ocorreu um erro ao consultar a unidade com o código {codigo}. Erro {resposta.MensagemErro}";

                viewModel.TipoToast = TipoToast.Aviso;
                viewModel.AoMudarPropriedade("TipoToast");
                await viewModel.MeuToast.Show();
                await viewModel.IdUnidadeInput.FocusAsync();
                return new UnidadeProdutoModel();
            }

            return (UnidadeProdutoModel)resposta.Objeto;
        }
    }
}
