﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroProduto
{
    public static class UnidadeByIdCadastroProduto
    {
        public static async Task<UnidadeProdutoModel> Get(ICadastroProdutoVM viewModel, IUnidadesProdutoService unidadesService, long id, StatusAtivo ativos)
        {
            RespostaAPIModel resposta = new RespostaAPIModel();
            try
            {
                viewModel.UnidadesBtnEnabled = false;
                await viewModel.SpinnerPrincipal.ShowAsync();
                resposta = await unidadesService.GetByIdAsync(URIsProdutos.GetUnidadesAsync, id, ativos);
            }
            finally
            {
                viewModel.UnidadesBtnEnabled = true;
                await viewModel.SpinnerPrincipal.HideAsync();
            }

            if (!resposta.Sucesso)
            {
                var mensagem = resposta.Status == System.Net.HttpStatusCode.NotFound ? $"Não foi encontrada uma unidade ativa com o Id {id}" :
                    $"Ocorreu um erro ao consultar a unidade com o id {id}. Erro {resposta.MensagemErro}";

                await viewModel.ExibirMensagemToast(mensagem, TipoToast.Aviso);

                await viewModel.IdUnidadeInput.FocusAsync();
                return new UnidadeProdutoModel();
            }
            await viewModel.VlrVendaInput.FocusAsync();
            return (UnidadeProdutoModel)resposta.Objeto;
            
        }
    }
}
