﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroSubgrupoProduto
{
    public static class EnvioDadosCadastroSubgrupoProduto
    {
        public static async Task Enviar(CadastroSubgrupoProdutoVM viewModel, ISubgruposProdutoService service)
        {
            viewModel.Enviando = true;
            var retorno = viewModel.Subgrupo.Id == 0 ? await service.PostAsync(viewModel.Subgrupo) : await service.PutAsync(viewModel.Subgrupo);
            viewModel.Mensagem = retorno.Sucesso ? string.Empty : retorno.MensagemErro;
            viewModel.MensagemResultadoEnvio = retorno.Status == System.Net.HttpStatusCode.Created ? "Subgrupo criado com sucesso" :
                retorno.Status == System.Net.HttpStatusCode.OK ? "Subgrupo alterado com sucesso" : viewModel.Mensagem;
            viewModel.TipoToast = retorno.Sucesso ? TipoToast.Sucesso : TipoToast.Erro;
            if (retorno.Sucesso)
            {
                LimpaTelaCadastroSubgrupoProduto.Limpar(viewModel);
                viewModel.Mensagem = viewModel.MensagemResultadoEnvio;
            }
            viewModel.Enviando = false;
            await viewModel.MeuToast.Show();
        }
    }
}
