﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroSubgrupoProduto
{
    public static class GrupoByIdCadastroSubgrupoProduto
    {
        public static async Task<GrupoProdutoModel> Get(CadastroSubgrupoProdutoVM viewModel, IGruposProdutoService grupoService, long id, StatusAtivo statusAtividade)
        {
            RespostaAPIModel resposta;
            GrupoProdutoModel grupo = new();
            try
            {
                viewModel.PesquisandoGrupos = true;
                await viewModel.SpinnerPrincipal.ShowAsync();

                resposta = await grupoService.GetByIdAsync(URIsSubgruposProduto.GetGruposAsync, id, statusAtividade);

                if (!resposta.Sucesso)
                {
                    viewModel.Mensagem = resposta.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    grupo = (GrupoProdutoModel)resposta.Objeto;
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.PesquisandoGrupos = false;
            }

            return grupo;
        }
    }
}
