﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroSubgrupoProduto
{
    public static class LocalizaGrupoCadastroSubgrupo
    {
        public static async Task LocalizarAsync(CadastroSubgrupoProdutoVM viewModel, IGruposProdutoService service)
        {
            if (viewModel != null)
            {
                viewModel.GruposBtnEnabled  = false;
                viewModel.PesquisandoGrupos = true;
                var retorno = await service?.GetAsync(URIsSubgruposProduto.GetGruposAsync, StatusAtivo.Ativos);
                viewModel.PesquisandoGrupos = false;
                viewModel.GruposBtnEnabled = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.DlgVisible = true;
                }
                else
                {
                    viewModel.Grupos = (List<GrupoProdutoModel>)retorno.Objeto;
                    viewModel.DlgGruposVisible = true;
                }
            }
        }
    }
}
