﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroSubgrupoProduto
{
    public static class SubgrupoByIdCadastroSubgrupoProduto
    {
        public static async Task<SubgrupoProdutoModel> Get(CadastroSubgrupoProdutoVM viewModel, ISubgruposProdutoService subgruposService, long id, StatusAtivo statusAtividade)
        {
            RespostaAPIModel resposta;
            SubgrupoProdutoModel subgrupo = new() { Grupo = new GrupoProdutoModel()};
            try
            {
                viewModel.Localizando = true;
                await viewModel.SpinnerPrincipal.ShowAsync();
                LimpaTelaCadastroSubgrupoProduto.Limpar(viewModel);

                resposta = await subgruposService.GetByIdAsync(URIsSubgruposProduto.GetAsync, id, statusAtividade);

                if (!resposta.Sucesso)
                {
                    viewModel.Mensagem = resposta.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    subgrupo = (SubgrupoProdutoModel)resposta.Objeto;
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.Localizando = false;
            }

            return subgrupo;
        }
    }
}
