﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroUFICMS
{
    public static class EnvioDadosCadastroUFICMS
    {
        public static async Task Enviar(ICadastroUFICMSVM viewModel, IUFICMSsService service)
        {
            viewModel.Enviando = true;
            var retorno = viewModel.UFICMS.Id == 0 ? await service.PostAsync(viewModel.UFICMS) : await service.PutAsync(viewModel.UFICMS);
            viewModel.Mensagem = retorno.Sucesso ? string.Empty : retorno.MensagemErro;
            viewModel.MensagemResultadoEnvio = retorno.Status == System.Net.HttpStatusCode.Created ? "Alíquota criada com sucesso" :
                retorno.Status == System.Net.HttpStatusCode.OK ? "Alíquota alterada com sucesso" : viewModel.Mensagem;
            viewModel.TipoToast = retorno.Sucesso ? TipoToast.Sucesso : TipoToast.Erro;

            if (retorno.Sucesso)
            {
                LimpaTelaCadastroUFICMS.Limpar(viewModel, true);
                viewModel.Mensagem = viewModel.MensagemResultadoEnvio;
            }
            viewModel.Enviando = false;
            await viewModel.MeuToast.Show();
        }
    }
}
