﻿using GAFNETBlazor.Constantes;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using GAFNETLibrary.Models;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroUFICMS
{
    public static class UFICMSByUFCadastroUFICMS
    {
        public static async Task<UFICMSModel> Get(ICadastroUFICMSVM viewModel, IUFICMSsService ufICMSsService, string uf)
        {
            RespostaAPIModel resposta;
            UFICMSModel ufICMS = new UFICMSModel();
            try
            {
                viewModel.Localizando = true;
                await viewModel.SpinnerPrincipal.ShowAsync();
                LimpaTelaCadastroUFICMS.Limpar(viewModel, false);

                resposta = await ufICMSsService.GetByUFAsync(URIsUFICMSs.GetAsync, uf);

                if (resposta.Sucesso)
                {
                    ufICMS = (UFICMSModel)resposta.Objeto;
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.Localizando = false;
            }

            if (ufICMS == null)
            {
                ufICMS = new UFICMSModel { UF = uf };
            }
            return ufICMS;
        }
    }
}
