﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroUnidadeProduto
{
    public static class EnvioDadosCadastroUnidadeProduto
    {
        public static async Task Enviar(CadastroUnidadeProdutoVM viewModel, IUnidadesProdutoService service)
        {
            viewModel.Enviando = true;
            var retorno = viewModel.Unidade.Id == 0 ? await service.PostAsync(viewModel.Unidade) : await service.PutAsync(viewModel.Unidade);
            viewModel.Mensagem = retorno.Sucesso ? string.Empty : retorno.ConteudoRetorno;
            viewModel.MensagemResultadoEnvio = retorno.Status == System.Net.HttpStatusCode.Created ? "Unidade criada com sucesso" :
                retorno.Status == System.Net.HttpStatusCode.OK ? "Unidade alterada com sucesso" : viewModel.Mensagem;
            viewModel.TipoToast = retorno.Sucesso ? TipoToast.Sucesso : TipoToast.Erro;
            if (retorno.Sucesso)
            {
                LimpaTelaCadastroUnidadeProduto.Limpar(viewModel);
                viewModel.Mensagem = viewModel.MensagemResultadoEnvio;
            }
            viewModel.Enviando = false;
            await viewModel.MeuToast.Show();
        }
    }
}
