﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.CadastroUnidadeProduto
{
    public static class UnidadeByIdCadastroUnidadeProduto
    {
        public static async Task<UnidadeProdutoModel> Get(CadastroUnidadeProdutoVM viewModel, IUnidadesProdutoService unidadesService, long id, StatusAtivo statusAtividade)
        {
            RespostaAPIModel resposta;
            UnidadeProdutoModel unidade = new();
            try
            {
                viewModel.Localizando = true;
                await viewModel.SpinnerPrincipal.ShowAsync();
                LimpaTelaCadastroUnidadeProduto.Limpar(viewModel);

                resposta = await unidadesService.GetByIdAsync(URIsUnidadesProduto.GetAsync, id, statusAtividade);

                if (!resposta.Sucesso)
                {
                    viewModel.Mensagem = resposta.MensagemErro;
                    viewModel.TipoToast = TipoToast.Aviso;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    unidade = (UnidadeProdutoModel)resposta.Objeto;
                }
            }
            finally
            {
                await viewModel.SpinnerPrincipal.HideAsync();
                viewModel.Localizando = false;
            }

            return unidade;
        }
    }
}
