﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using GAFNETLibrary.Models;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.Faturamento
{
    public static class EnvioNFe
    {
        public static async Task<ResultadoModel> Enviar(IBaseVM viewModel, INFeService nFeService, FaturamentoModel faturamento)
        {
            var resultEnvioNFe = await nFeService.Enviar(faturamento);
            if (!resultEnvioNFe.Sucesso)
            {
                return resultEnvioNFe;
            }
            var retornoNFe = (RetornoNFeModel)resultEnvioNFe.Retorno;
            faturamento.ChaveEletronica = retornoNFe.ChDFe;
            if (viewModel is FaturamentoVM vM)
            {
                vM.DlgConfirmacaoEnvioEMailNFeVisible = true;
            }
            else
            {
                ((IPesquisaFaturamentoVM)viewModel).DlgConfirmacaoEnvioEMailNFeVisible = true;
            }

            return resultEnvioNFe;
        }
    }
}
