﻿using GAFNETBlazor.Constantes;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using GAFNETLibrary.Enums;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.Faturamento
{
    public static class ExibicaoPesquisaVendedores
    {
        public static async Task Exibir(IFaturamentoVM vM, IPessoasService pessoasService)
        {
            vM.PesquisandoVendedores = true;
            var retorno = await pessoasService.GetAsync(URIsFaturamentos.GetPessoasAsync, "Id,Nome,CNPJ,Ativo,DtCadastro", "ehvendedor eq true and ativo eq true", "nome", "");

            if (!retorno.Sucesso)
            {
                await vM.ExibirMensagemToast(retorno.MensagemErro, TipoToast.Erro);
                return;
            }
            
            vM.Vendedores = (List<PessoaModel>)retorno.Objeto;
            vM.PesquisandoVendedores = false;
            vM.DlgVendedoresVisible = true;

        }
    }
}
