﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using GAFNETBlazor.ViewModels.Usuario.FaturamentoBase;
using GAFNETLibrary.Enums;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.Faturamento;

public static class ExibicaoVendedor
{
    public static async Task ExibirPorId(IFaturamentoVM vM, IPessoasService pessoasService, long id)
    {
        if (id == 0)
        {
            vM.VendedorFaturamento.Vendedor = new PessoaModel();
            return;
        }
        await vM.SpinnerPrincipal.ShowAsync();
        vM.PesquisandoVendedores = true;
        var resultPesquisa = await PessoaById.Get(vM, pessoasService, id, TipoCadastroPessoa.Vendedor);
        await vM.SpinnerPrincipal.HideAsync();
        vM.PesquisandoVendedores = false;
        if (!resultPesquisa.Sucesso)
        {
            vM.VendedorFaturamento.Vendedor.Id = 0;
            await vM.ExibirMensagemToast((string)resultPesquisa.Retorno, TipoToast.Erro);
            return;
        }
        vM.VendedorFaturamento.Vendedor = (PessoaModel)resultPesquisa.Retorno;

    }
}
