﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.ObjectModel;
using System.Linq;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.Faturamento
{
    public static class InsereVendedorFaturamento
    {
        public static async Task Add(IFaturamentoVM viewModel)
        {
            if (viewModel.VendedorFaturamento.Vendedor.Id == 0)
            {
                viewModel.Mensagem = "É necessário selecionar um vendedor.";
                viewModel.DlgVisible = true;
                viewModel.TipoToast = TipoToast.Aviso;
                viewModel.AoMudarPropriedade("TipoToast");
                await viewModel.MeuToast.Show();
                return;
            }

            viewModel.Faturamento.Vendedores = viewModel.Faturamento.Vendedores ?? new ObservableCollection<VendedorFaturamentoModel>();

            var vendedorFaturamento = viewModel.Faturamento.Vendedores.FirstOrDefault(e => e.IdVendedor == viewModel.VendedorFaturamento.Vendedor.Id);
            if (vendedorFaturamento != null)
            {
                viewModel.Faturamento.Vendedores.Remove(vendedorFaturamento);
            }

            viewModel.Faturamento.Vendedores.Add(new VendedorFaturamentoModel { IdVendedor = viewModel.VendedorFaturamento.Vendedor.Id, PercComissao = viewModel.VendedorFaturamento.PercComissao, Vendedor = viewModel.VendedorFaturamento.Vendedor });
            viewModel.VendedorFaturamento = new VendedorFaturamentoModel();
        }
    }
}
