﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.Faturamento
{
    public static class LocalizaFormulario
    {
        public static async Task LocalizarAsync(IFaturamentoVM viewModel, IFormulariosService service)
        {
            if (viewModel == null) return;
            
            viewModel.FormulariosBtnEnabled  = false;
            viewModel.PesquisandoFormularios = true;
            var retorno                      = await service?.GetAsync(URIsFaturamentos.GetFormulariosAsync, StatusAtivo.Ativos);
            viewModel.PesquisandoFormularios = false;
            viewModel.FormulariosBtnEnabled  = true;

            if (!retorno.Sucesso)
            {
                viewModel.Mensagem = retorno.MensagemErro;
                viewModel.TipoToast = TipoToast.Erro;
                viewModel.AoMudarPropriedade("TipoToast");
                await viewModel.MeuToast.Show();
            }
            else
            {
                viewModel.Formularios = (List<FormularioModel>)retorno.Objeto;
                viewModel.DlgFormulariosVisible = true;
            }
        }
    }
}
