﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using System;
using System.Collections.Generic;

namespace GAFNETBlazor.ViewModels.Usuario.FaturamentoBase
{
    public static class AcoesPorTipoFaturamento
    {
        public static List<ListaModel> Acoes(IAcoesFaturamentoService acoesFaturamentoService, int tipoFaturamento)
        {
            return (TipoFaturamento)tipoFaturamento switch
            {
                TipoFaturamento.PedidoDeVenda => acoesFaturamentoService.ItensPedido(),
                TipoFaturamento.OrdemDeServico => acoesFaturamentoService.ItensOrdemDeServico(),
                TipoFaturamento.Orcamento => acoesFaturamentoService.ItensOrcamento(),
                TipoFaturamento.NotaFiscal => acoesFaturamentoService.ItensNotaFiscal(),
                TipoFaturamento.NotaCompra => acoesFaturamentoService.ItensCompra(),
                TipoFaturamento.PedidoDeCompra => acoesFaturamentoService.ItensPedidoDeCompra(),
                _ => throw new NotImplementedException(),
            };
        }
    }
}
