﻿using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using GAFNETLibrary.Enums;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.FaturamentoBase;

public static class AlteracaoFaturamentoParaNotaFiscal
{
    public static async Task<bool> Alterar(IFaturamentoVM viewModel, IFaturamentoBaseService faturamentosService)
    {
        var faturamento = viewModel.Faturamento;
        faturamento.IdLancamentoOrigem = faturamento.Id;
        faturamento.Numero = 0;
        faturamento.Id = 0;
        foreach (var item in faturamento.Itens)
        {
            item.IdFaturamento = 0;
        }
        faturamento.Tipo = (int)TipoFaturamento.NotaFiscal;
        await viewModel.SpinnerPrincipal.ShowAsync();
        viewModel.Calculando = true;
        var resposta = await CalculoFaturamento.Calcular(faturamento, faturamentosService);
        viewModel.Calculando = false;
        viewModel.AoMudarPropriedade(nameof(faturamento));
        await viewModel.SpinnerPrincipal.HideAsync();
        if (!resposta.Sucesso)
        {
            await viewModel.ExibirMensagemToast(resposta.MensagemErro, TipoToast.Erro);
        }
        return resposta.Sucesso;
    }
}
