﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using Newtonsoft.Json;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.FaturamentoBase
{
    public static class CalculoFaturamento
    {
        public static async Task<RespostaAPIModel> Calcular(FaturamentoModel faturamento, IFaturamentoBaseService service)
        {
            FaturamentoModel faturamentoCalculado;

            var retorno = await service.CalculaAsync(faturamento);

            if (!retorno.Sucesso) return retorno;
            
            faturamentoCalculado = JsonConvert.DeserializeObject<FaturamentoModel>(retorno.ConteudoRetorno);
            faturamento.Itens.Clear();
            foreach (var item in faturamentoCalculado.Itens)
            {
                faturamento.Itens.Add(item);
            }
            faturamento.Valor = faturamentoCalculado.Valor;
            faturamento.VlrBaseICMS = faturamentoCalculado.VlrBaseICMS;
            faturamento.VlrICMS = faturamentoCalculado.VlrICMS;
            faturamento.VlrBaseICMSST = faturamentoCalculado.VlrBaseICMSST;
            faturamento.VlrICMSST = faturamentoCalculado.VlrICMSST;
            faturamento.VlrTribEstadualIBPT = faturamentoCalculado.VlrTribEstadualIBPT;
            faturamento.VlrTribImportadosIBPT = faturamentoCalculado.VlrTribImportadosIBPT;
            faturamento.VlrTribMunicipalIBPT = faturamentoCalculado.VlrTribMunicipalIBPT;
            faturamento.VlrTribNacionalIBPT = faturamentoCalculado.VlrTribNacionalIBPT;
            return retorno;
        }
    }
}
