﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.FaturamentoBase
{
    public static class ExibicaoHistoricoFaturamento
    {
        public static async Task Exibir(IFaturamentoBaseVM viewModel, IHistoricosService historicosService, IFaturamentoBaseService faturamentosService, long idHistorico)
        {
            if (idHistorico == 0)
            {
                viewModel.Faturamento.historico = new HistoricoModel();
                return;
            }

            var resultHistoricos = await HistoricoById.Get(viewModel, historicosService, idHistorico);

            if (viewModel is ICompraVM vM && vM.DlgImportacaoXMLVisible)
            {
                vM.FaturamentoEmImportacao.Historico = (HistoricoModel)resultHistoricos.Retorno;
                vM.FaturamentoEmImportacao.IdHistorico = viewModel.Faturamento.Historico.Id;
                vM.AoMudarPropriedade(nameof(vM.FaturamentoEmImportacao.Historico));
            }
            else
            {
                viewModel.Faturamento.Historico = (HistoricoModel)resultHistoricos.Retorno;
                viewModel.Faturamento.IdHistorico = viewModel.Faturamento.Historico.Id;
                if (viewModel.Faturamento.Itens.Count > 0) await CalculoFaturamento.Calcular(viewModel.Faturamento, faturamentosService);
                viewModel.AoMudarPropriedade(nameof(viewModel.Faturamento.Historico));
            }

            await Task.Delay(100); // colocado aqui para retornar o controle para a aplicação criar ou não os campos de financeiro

            if (viewModel.Faturamento.Historico.GeraFinanceiro)
            {
                await viewModel.IdTipoDeOperacaoInput.FocusAsync();
            }
            else
            {
                await viewModel.CodigoProdutoInput.FocusAsync();
            }
        }
    }
}
