﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using GAFNETLibrary.Enums;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.FaturamentoBase;

public static class ExibicaoTransportadoraFaturamento
{
    public static async Task Exibir(IFaturamentoBaseVM viewModel, IPessoasService pessoasService, long idTransportadora)
    {
        await viewModel.SpinnerPrincipal.ShowAsync();
        viewModel.PesquisandoTransportadoras = true;
        var resultPesquisa = await PessoaById.Get(viewModel, pessoasService, idTransportadora, TipoCadastroPessoa.Transportadora);
        await viewModel.SpinnerPrincipal.HideAsync();
        viewModel.PesquisandoTransportadoras = false;
        if (!resultPesquisa.Sucesso)
        {
            viewModel.Faturamento.Transportadora = new PessoaModel();
            await viewModel.ExibirMensagemToast((string)resultPesquisa.Retorno, TipoToast.Erro);
            return;
        }

        viewModel.Faturamento.Transportadora = (PessoaModel)resultPesquisa.Retorno;

        viewModel.Faturamento.IdTransportadora = viewModel.Faturamento.Transportadora.Id;
        viewModel.AoMudarPropriedade(nameof(viewModel.Faturamento));
    }
}
