﻿using GAFNETBlazor.Models;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace GAFNETBlazor.ViewModels.Usuario.FaturamentoBase
{
    public static class LimpaTelaFaturamento
    {
        public static void Limpar(IFaturamentoBaseVM viewModel)
        {
            var tipoFaturamento = viewModel.Faturamento.Tipo;
            viewModel.ErrosValidacaoFormulario.Clear();
            viewModel.Faturamento = new FaturamentoModel { Vendedores = new ObservableCollection<VendedorFaturamentoModel>() };
            viewModel.Produtos = new List<ProdutoModel>();
            viewModel.AcaoFaturamento = null;
            if (viewModel is IFaturamentoVM vM)
            {
                vM.Vendedores = new List<PessoaModel>();
                vM.VendedorFaturamento = new VendedorFaturamentoModel { Vendedor = new PessoaModel() };
                vM.FaturamentoEmDevolucao = new FaturamentoModel();
            }
            viewModel.ProdutoSelecionado = null;
            viewModel.ItemFaturamento = new() { Produto = new ProdutoModel { Aliquota = new AliquotaModel() }  };
            viewModel.Faturamento.Tipo = tipoFaturamento;
        }
    }
}
