﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.FaturamentoBase
{
    public static class LocalizaCentroDeCusto
    {
        public static async Task LocalizarAsync(IFaturamentoBaseVM viewModel, ICentrosDeCustoService service)
        {
            viewModel.CentrosDeCustoBtnEnabled  = false;
            viewModel.PesquisandoCentrosDeCusto = true;
            var retorno                         = await service?.GetAsync(URIsFaturamentos.GetCentrosDeCustoAsync, StatusAtivo.Ativos);
            viewModel.PesquisandoCentrosDeCusto = false;
            viewModel.CentrosDeCustoBtnEnabled  = true;

            if (!retorno.Sucesso)
            {
                viewModel.Mensagem = retorno.MensagemErro;
                viewModel.TipoToast = TipoToast.Erro;
                viewModel.AoMudarPropriedade("TipoToast");
                await viewModel.MeuToast.Show();
            }
            else
            {
                viewModel.CentrosDeCusto = (List<CentroDeCustoModel>)retorno.Objeto;
                viewModel.DlgCentrosDeCustoVisible = true;
            }
        }
    }
}
