﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.FaturamentoBase
{
    public static class LocalizaCondicaoDePagamento
    {
        public static async Task LocalizarAsync(IFaturamentoBaseVM viewModel, ICondicoesDePagamentoService service)
        {
            if (viewModel == null) return;
            viewModel.CondicoesDePagamentoBtnEnabled  = false;
            viewModel.PesquisandoCondicoesDePagamento = true;
            var retorno                               = await service?.GetAsync(URIsFaturamentos.GetCondicoesDePagamentoAsync, StatusAtivo.Ativos);
            viewModel.PesquisandoCondicoesDePagamento = false;
            viewModel.CondicoesDePagamentoBtnEnabled  = true;

            if (!retorno.Sucesso)
            {
                viewModel.Mensagem = retorno.MensagemErro;
                viewModel.TipoToast = TipoToast.Erro;
                viewModel.AoMudarPropriedade("TipoToast");
                await viewModel.MeuToast.Show();
                return;
            }

            viewModel.CondicoesDePagamento = (List<CondicaoDePagamentoModel>)retorno.Objeto;
            viewModel.DlgCondicoesDePagamentoVisible = true;
        }
    }
}
