﻿using GAFNETBlazor.Constantes;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.FaturamentoBase
{
    public static class PesquisaPessoasFaturamento
    {
        public static async Task<string> Pesquisar(IFaturamentoBaseVM viewModel, IPessoasService pessoasService)
        {
            viewModel.PesquisandoPessoas = true;
            string campoFiltroTipo = viewModel is IFaturamentoVM ? "ehcliente" : "ehfornecedor";
            string campos = "Id,Nome,CNPJ,Ativo,DtCadastro&$expand=enderecoprincipal($select = id,bairro;$expand = cidade($select = id, nome, uf),pais)";
            string filtro = $"{campoFiltroTipo} eq true and ativo eq true";
            filtro += string.IsNullOrEmpty(viewModel.Faturamento.Pessoa.Nome) ? "" : $" and startswith(nome, '{viewModel.Faturamento.Pessoa.Nome}')";
            var retorno = await pessoasService.GetAsync(URIsFaturamentos.GetPessoasAsync, campos, filtro, "nome", "");
            if (!retorno.Sucesso)
            {
                return retorno.MensagemErro;
            }
            viewModel.Pessoas = (List<PessoaModel>)retorno.Objeto;
            viewModel.PesquisandoPessoas = false;
            viewModel.DlgPessoasVisible = true;
            return "";
        }
    }
}
