﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.FaturamentoBase
{
    public static class PlanoDeContaById
    {
        public static async Task<PlanoDeContaModel> Get(IFaturamentoBaseVM viewModel, IPlanosDeContaService planosDeContaService, long id)
        {
            if (id == 0) return new PlanoDeContaModel();
            
            var resposta = new RespostaAPIModel();
            try
            {
                //viewModel.PlanosDeContaBtnEnabled = false;
                await viewModel.SpinnerPrincipal.ShowAsync();
                resposta = await planosDeContaService.GetByIdAsync(URIsFaturamentos.GetPlanosDeContaAsync, id, StatusAtivo.Ativos);
            }
            finally
            {
                //viewModel.PlanosDeContaBtnEnabled = true;
                await viewModel.SpinnerPrincipal.HideAsync();
            }

            if (resposta.Sucesso)
            {
               return (PlanoDeContaModel)resposta.Objeto;
            }
            else
            {
                viewModel.Mensagem = resposta.Status == System.Net.HttpStatusCode.NotFound ? $"Não foi encontrado um plano de contas ativo com o Id {id}" :
                    $"Ocorreu um erro ao consultar o plano de contas com o id {id}. Erro {resposta.MensagemErro}";

                viewModel.TipoToast = TipoToast.Aviso;
                viewModel.AoMudarPropriedade("TipoToast");
                await viewModel.MeuToast.Show();
                //await viewModel.IdPlanoDeContaInput.FocusAsync();

                return new PlanoDeContaModel();
            }
        }
    }
}
