﻿using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.FaturamentoBase
{
    public static class SetaFocoAposInformarPessoaFaturamento
    {
        public static async Task Setar(IFaturamentoBaseVM viewModel)
        {
            if (viewModel.Faturamento.Pessoa.Historico == null)
            {
                await viewModel.IdHistoricoInput.FocusAsync();
                return;
            }

            if (!viewModel.Faturamento.Pessoa.Historico.GeraFinanceiro)
            {
                await viewModel.CodigoProdutoInput.FocusAsync();
                return;
            };

            if (viewModel.Faturamento.Pessoa.TipoDeOperacao == null)
            {
                if (viewModel.IdTipoDeOperacaoInput != null) await viewModel.IdTipoDeOperacaoInput.FocusAsync();
                return;
            }

            if (viewModel.Faturamento.Pessoa.CondicaoDePagamento == null)
            {
                if (viewModel.IdTipoDeOperacaoInput != null) await viewModel.IdCondPgtoInput.FocusAsync();
                return;
            }

            if (viewModel.Faturamento.Pessoa.CentroDeCusto == null)
            {
                if (viewModel.IdCentroDeCustoInput != null) await viewModel.IdCentroDeCustoInput.FocusAsync();
                return;
            }

            await viewModel.CodigoProdutoInput.FocusAsync();
        }
    }
}
