﻿using GAFNETBlazor.Models.Validations;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;

namespace GAFNETBlazor.ViewModels.Usuario.FaturamentoBase
{
    public static class ValidacaoDadosEnvioFaturamento
    {
        public static bool Validar(IFaturamentoBaseVM viewModel)
        {
            var validator = new FaturamentoModelValidator();
            viewModel.ErrosValidacaoFormulario.Clear();
            var erros = new List<string>();

            var results = validator.Validate(viewModel.Faturamento);
            if (!results.IsValid)
            {
                foreach (var erro in results.Errors)
                {
                    erros.Add(erro.ErrorMessage);
                }
                viewModel.ErrosValidacaoFormulario.AddRange(erros);
                return false;
            }

            return true;
        }
    }
}
