﻿using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.FaturamentoBase
{
    public static class ValidacaoDocumentoPelaAcao
    {
        public static ResultadoModel Validar(FaturamentoModel faturamento, TipoAcaoFaturamento acao)
        {
            var tipoFaturamento = (TipoFaturamento)faturamento.Tipo;

            if (faturamento.Id == 0)
                return new ResultadoModel { Sucesso = false, Retorno = "É necessário selecionar um documento." };
            if (!faturamento.DocumentoFaturavel && acao == TipoAcaoFaturamento.Faturar)
                return new ResultadoModel { Sucesso = false, Retorno = "Não é possível faturar esse tipo de documento." };
            if (acao == TipoAcaoFaturamento.Devolver && tipoFaturamento != TipoFaturamento.NotaFiscal && tipoFaturamento != TipoFaturamento.NotaCompra)
                return new ResultadoModel { Sucesso = false, Retorno = "Não é possível devolver esse tipo de documento." };

            return new ResultadoModel { Sucesso = true, Retorno = "OK" };
        }
    }
}
