﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using GAFNETLibrary.Enums;
using GAFNETLibrary.Models;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.PagarReceber;

public static class ExibicaoPessoa
{
    public static async Task<ResultadoModel> Exibir(IPagarReceberVM viewModel, IPessoasService pessoasService, long id)
    {
        if (id == 0)
        {
            return new ResultadoModel { Sucesso = false, Retorno = "Não foi informado o id da pessoa." };
        }
        var pagarReceber = viewModel.PagarReceber;
        await viewModel.SpinnerPrincipal.ShowAsync();
        viewModel.PesquisandoPessoas = true;
        TipoCadastroPessoa tipoCadastro = (TipoPagarReceber)viewModel.PagarReceber.Tipo == TipoPagarReceber.Receber ? TipoCadastroPessoa.Cliente : TipoCadastroPessoa.Fornecedor;
        var resultPesquisa = await PessoaById.Get(viewModel, pessoasService, id, tipoCadastro);
        await viewModel.SpinnerPrincipal.HideAsync();
        viewModel.PesquisandoPessoas = false;

        PessoaModel pessoa;
        if (resultPesquisa.Sucesso)
        {
            pessoa = (PessoaModel)resultPesquisa.Retorno;
        }
        else
        {
            pessoa = new PessoaModel();
        }

        if (!resultPesquisa.Sucesso)
        {
            return new ResultadoModel { Sucesso = false, Retorno = (string)resultPesquisa.Retorno };
        }

        pagarReceber.Pessoa = pessoa;
        pagarReceber.IdPessoa = pessoa.Id;

        

        RespostaAPIModel respostaCalculo = new() { Sucesso = true };

        viewModel.AoMudarPropriedade(nameof(PagarReceber));

        return new ResultadoModel { Sucesso = respostaCalculo.Sucesso, Retorno = pessoa };
    }
}
