﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.PagarReceber;

public static class LocalizaCentroDeCusto
{
    public static async Task LocalizarAsync(IPagarReceberVM viewModel, ICentrosDeCustoService service)
    {
        viewModel.CentrosDeCustoBtnEnabled = false;
        viewModel.PesquisandoCentrosDeCusto = true;
        var retorno = await service?.GetAsync(URIsFaturamentos.GetCentrosDeCustoAsync, StatusAtivo.Ativos);
        viewModel.PesquisandoCentrosDeCusto = false;
        viewModel.CentrosDeCustoBtnEnabled = true;

        if (!retorno.Sucesso)
        {
            await viewModel.ExibirMensagemToast(retorno.MensagemErro, TipoToast.Erro);
            return;
        }
        
        viewModel.CentrosDeCusto = (List<CentroDeCustoModel>)retorno.Objeto;
        viewModel.DlgCentrosDeCustoVisible = true;
    }
}
