﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.PagarReceber;

public static class LocalizaContaApropriacao
{
    public static async Task LocalizarAsync(IPagarReceberVM viewModel, IPlanosDeContaService service)
    {
        try
        {
            viewModel.PesquisandoContasApropriacao = true;
            if (viewModel == null) return;
            var retorno = await service?.GetAsync(URIsPagarReceber.GetPlanosDeContaAsync,
                "id, descricao, tipo, debitocredito, classificacao1, classificacao2, classificacao3, ativo",
                "tipo eq 0 and ativo eq true", "descricao", "");

            if (!retorno.Sucesso)
            {
                await viewModel.ExibirMensagemToast(retorno.MensagemErro, TipoToast.Erro);
                return;
            }


            viewModel.PlanosDeConta = (List<PlanoDeContaModel>)retorno.Objeto;
            viewModel.DlgContasApropriacaoVisible = true;
        }
        finally
        {
            viewModel.PesquisandoContasApropriacao = false;
            viewModel.AoMudarPropriedade(nameof(viewModel.PesquisandoContasApropriacao));
        }
    }
}
