﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.PagarReceber;

public static class LocalizaTipoDeOperacao
{
    public static async Task LocalizarAsync(IPagarReceberVM viewModel, ITiposDeOperacaoService service)
    {
        try
        {
            if (viewModel == null) return;
            viewModel.PesquisandoTiposDeOperacao = true;
            var retorno = await service?.GetAsync(URIsFaturamentos.GetTiposDeOperacaoAsync, StatusAtivo.Ativos);
            viewModel.TiposDeOperacaoBtnEnabled = true;

            if (!retorno.Sucesso)
            {
                await viewModel.ExibirMensagemToast(retorno.MensagemErro, TipoToast.Erro);
                return;
            }

            viewModel.TiposDeOperacao = (List<TipoDeOperacaoModel>)retorno.Objeto;
            viewModel.DlgTiposDeOperacaoVisible = true;
        }
        finally
        {
            viewModel.PesquisandoTiposDeOperacao = false;
            viewModel.AoMudarPropriedade(nameof(viewModel.PesquisandoTiposDeOperacao));
        }
    }
}
