﻿using GAFNETBlazor.Constantes;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using GAFNETLibrary.Enums;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.PagarReceber;

public static class PagarReceberById
{
    public static async Task<PagarReceberModel> Get(IPagarReceberVM viewModel, IPagarReceberService pagarReceberService, long id)
    {
        var pagarReceber = new PagarReceberModel();
        if (id == 0) return pagarReceber;

        try
        {
            viewModel.Localizando = true;
            if (viewModel.SpinnerPrincipal != null)
            {
                await viewModel.SpinnerPrincipal.ShowAsync();
            }
            var resposta = await pagarReceberService.GetByIdAsync(URIsPagarReceber.GetAsync, id, StatusAtivo.Todos);

            if (!resposta.Sucesso)
            {
                await viewModel.ExibirMensagemToast(resposta.MensagemErro, TipoToast.Erro);
                return null;
            }

            pagarReceber = (PagarReceberModel)resposta.Objeto;
        }
        finally
        {
            if (viewModel.SpinnerPrincipal != null)
            {
                await viewModel.SpinnerPrincipal.HideAsync();
            }

            viewModel.Localizando = false;
        }

        return pagarReceber;
    }
}
