﻿using GAFNETBlazor.Constantes;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using GAFNETLibrary.Enums;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.PagarReceber;

public static class PesquisaPessoas
{
    public static async Task<string> Pesquisar(IPagarReceberVM viewModel, IPessoasService pessoasService)
    {
        try
        {
            viewModel.PesquisandoPessoas = true;
            string campoFiltroTipo = viewModel.PagarReceber.Tipo == (int)TipoPagarReceber.Receber ? "ehcliente" : "ehfornecedor";
            string campos = "Id,Nome,CNPJ,Ativo,DtCadastro&$expand=enderecoprincipal($select = id,bairro;$expand = cidade($select = id, nome, uf),pais)";
            string filtro = $"{campoFiltroTipo} eq true and ativo eq true";
            filtro += string.IsNullOrEmpty(viewModel.PagarReceber.Pessoa.Nome) ? "" : $" and startswith(nome, '{viewModel.PagarReceber.Pessoa.Nome}')";
            var retorno = await pessoasService.GetAsync(URIsPagarReceber.GetPessoasAsync, campos, filtro, "nome", "");
            if (!retorno.Sucesso)
            {
                return retorno.MensagemErro;
            }
            viewModel.Pessoas = (List<PessoaModel>)retorno.Objeto;
            viewModel.PesquisandoPessoas = false;
            viewModel.DlgPessoasVisible = true;
            return "";
        }
        finally
        {
            viewModel.PesquisandoPessoas = false;
        }
    }
}
