﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Threading.Tasks;
using GAFNETLibrary.Models;

namespace GAFNETBlazor.ViewModels.Usuario.PagarReceber;

public static class PessoaById
{
    public static async Task<ResultadoModel> Get(IPagarReceberVM viewModel, IPessoasService pessoasService, long id, TipoCadastroPessoa tipoCadastro)
    {
        PessoaModel pessoa;
        if (id == 0) return new ResultadoModel { Sucesso = false, Retorno = "Não informado o id da pessoa." };

        viewModel.PesquisandoPessoas = true;

        string filtro = "ativo eq true" + tipoCadastro switch {
            TipoCadastroPessoa.Cliente => " and ehcliente eq true",
            TipoCadastroPessoa.Fornecedor => " and ehfornecedor eq true",
            _=> ""
        };

        string campos = "id,nome,cnpj&$expand=enderecoprincipal($select=ehprincipal;$expand=cidade($select=id,nome,uf))";
        var resposta = await pessoasService.GetByIdAsync(URIsPagarReceber.GetPessoasAsync, id, campos, filtro);

        if (!resposta.Sucesso)
        {
            return new ResultadoModel { Sucesso = false, Retorno = resposta.MensagemErro };
        }
            
        pessoa = (PessoaModel)resposta.Objeto;
        
        return new ResultadoModel { Sucesso = true, Retorno = pessoa };
    }
}
