﻿using GAFNETBlazor.Models.Validations;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;

namespace GAFNETBlazor.ViewModels.Usuario.PagarReceber;

public static class ValidacaoDadosEnvio
{
    public static bool Validar(IPagarReceberVM viewModel)
    {
        var validator = new PagarReceberModelValidator();
        viewModel.ErrosValidacaoFormulario.Clear();
        var erros = new List<string>();

        var results = validator.Validate(viewModel.PagarReceber);
        if (!results.IsValid)
        {
            foreach (var erro in results.Errors)
            {
                erros.Add(erro.ErrorMessage);
            }
            viewModel.ErrosValidacaoFormulario.AddRange(erros);
            return false;
        }

        return true;
    }
}
