﻿using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using GAFNETLibrary.Enums;
using Microsoft.IdentityModel.Tokens;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.PagarReceber;

public static class ValidacaoGeracaoItens
{
    public static async Task<bool> Validar(IPagarReceberVM viewModel)
    {
        if (string.IsNullOrEmpty(viewModel.PlanoDeConta.Descricao))
        {
            await viewModel.ExibirMensagemToast("É necessário informar o plano de conta.", TipoToast.Aviso);
            return false;
        }

        if (string.IsNullOrEmpty(viewModel.CentroDeCusto.Nome))
        {
            await viewModel.ExibirMensagemToast("É necessário informar o centro de custos.", TipoToast.Aviso);
            return false;
        }

        if (string.IsNullOrEmpty(viewModel.TipoDeOperacao.Descricao))
        {
            await viewModel.ExibirMensagemToast("É necessário informar o tipo de operação.", TipoToast.Aviso);
            return false;
        }

        return true;
    }
}
