﻿using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETLibrary.Models;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.Parametrizacao
{
    public static class EnvioDadosParametrizacao
    {
        public static async Task<ResultadoModel> Enviar(ParametrizacaoVM viewModel, IParametrizacoesService service)
        {
            viewModel.Enviando = true;
            var retorno = await service.PostAsync(viewModel.Parametrizacao);
            viewModel.Enviando = false;

            if (!retorno.Sucesso)
            {
                return new ResultadoModel { Sucesso = false, Retorno = retorno.MensagemErro };
            }

            string mensagem = retorno.Status == System.Net.HttpStatusCode.Created ? "Parametrização criada com sucesso." : "Parametrização alterada com sucesso.";
            return new ResultadoModel { Sucesso = true, Retorno = mensagem };
        }
    }
}
