﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.PesquisaFaturamento
{
    public static class LocalizaFormulario
    {
        public static async Task LocalizarAsync(IPesquisaFaturamentoVM viewModel, IFormulariosService service)
        {
            if (viewModel != null)
            {
                viewModel.FormulariosBtnEnabled  = false;
                viewModel.PesquisandoFormularios = true;
                var retorno                      = await service?.GetAsync(URIsFaturamentos.GetFormulariosAsync, StatusAtivo.Todos);
                viewModel.PesquisandoFormularios = false;
                viewModel.FormulariosBtnEnabled  = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.TipoToast = TipoToast.Erro;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    viewModel.Formularios = (List<FormularioModel>)retorno.Objeto;
                    viewModel.DlgFormulariosVisible = true;
                }
            }
        }
    }
}
