﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.PesquisaFaturamento
{
    public static class LocalizaHistorico
    {
        public static async Task LocalizarAsync(IPesquisaFaturamentoVM viewModel, IHistoricosService service)
        {
            if (viewModel != null)
            {
                viewModel.HistoricosBtnEnabled  = false;
                viewModel.PesquisandoHistoricos = true;
                var retorno                     = await service?.GetAsync(URIsFaturamentos.GetHistoricosAsync, StatusAtivo.Todos);
                viewModel.PesquisandoHistoricos = false;
                viewModel.HistoricosBtnEnabled  = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.TipoToast = TipoToast.Erro;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    viewModel.Historicos = (List<HistoricoModel>)retorno.Objeto;
                    viewModel.DlgHistoricosVisible = true;
                }
            }
        }
    }
}
