﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.PesquisaFaturamento
{
    public static class LocalizaPlanoDeConta
    {
        public static async Task LocalizarAsync(IPesquisaFaturamentoVM viewModel, IPlanosDeContaService service)
        {
            if (viewModel != null)
            {
                viewModel.PlanosDeContaBtnEnabled = false;
                viewModel.PesquisandoPlanosDeConta = true;
                var retorno = await service?.GetAsync(URIsFaturamentos.GetPlanosDeContaAsync,
                    "id, descricao, tipo, debitocredito, classificacao1, classificacao2, classificacao3, ativo",
                    "tipo eq 'Analitica'", "descricao", "");
                viewModel.PesquisandoPlanosDeConta = false;
                viewModel.PlanosDeContaBtnEnabled = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.TipoToast = TipoToast.Erro;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    viewModel.PlanosDeContas = (List<PlanoDeContaModel>)retorno.Objeto;
                    viewModel.DlgPlanosDeContaVisible = true;
                }
            }
        }
    }
}
