﻿using GAFNETBlazor.Constantes;
using GAFNETLibrary.Enums;
using GAFNETBlazor.Models;
using GAFNETBlazor.Services.Interfaces;
using GAFNETBlazor.ViewModels.Interfaces.Usuario;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace GAFNETBlazor.ViewModels.Usuario.PesquisaFaturamento
{
    public static class LocalizaTipoDeOperacao
    {
        public static async Task LocalizarAsync(IPesquisaFaturamentoVM viewModel, ITiposDeOperacaoService service)
        {
            if (viewModel != null)
            {
                viewModel.TiposDeOperacaoBtnEnabled  = false;
                viewModel.PesquisandoTiposDeOperacao = true;
                var retorno                     = await service?.GetAsync(URIsFaturamentos.GetTiposDeOperacaoAsync, StatusAtivo.Todos);
                viewModel.PesquisandoTiposDeOperacao = false;
                viewModel.TiposDeOperacaoBtnEnabled  = true;

                if (!retorno.Sucesso)
                {
                    viewModel.Mensagem = retorno.MensagemErro;
                    viewModel.TipoToast = TipoToast.Erro;
                    viewModel.AoMudarPropriedade("TipoToast");
                    await viewModel.MeuToast.Show();
                }
                else
                {
                    viewModel.TiposDeOperacao = (List<TipoDeOperacaoModel>)retorno.Objeto;
                    viewModel.DlgTiposDeOperacaoVisible = true;
                }
            }
        }
    }
}
